package com.example.module_android_demo;

import java.io.DataOutputStream;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Locale;
import java.util.Map;

import android.app.Application;
import android.app.TabActivity;
import android.content.Context;
import android.content.Intent;
import android.database.sqlite.SQLiteDatabase;
import android.graphics.Color;
import android.graphics.drawable.ColorDrawable;
import android.media.AudioManager;
import android.media.SoundPool;
import android.os.Bundle;
import android.os.Handler;
import android.os.PowerManager;
import android.util.Log;
import android.view.KeyEvent;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.Button;
import android.widget.ExpandableListView;
import android.widget.ListView;
import android.widget.TabHost;
import android.widget.TabHost.OnTabChangeListener;
import android.widget.TabHost.TabSpec;
import android.widget.TabWidget;
import android.widget.TextView;
import android.widget.Toast;

import com.function.AndroidWakeLock;
import com.function.MyAdapter;
import com.function.ScreenListener;
import com.function.ScreenListener.ScreenStateListener;
import com.function.Utils;
import com.senter.iot.support.openapi.uhf.UhfI;

@SuppressWarnings("deprecation")
public class MainActivity extends TabActivity {
    SQLiteDatabase sql;
    ExpandableListView tab4_left, tab4_right;
    TextView tv_once, tv_state, tv_tags, tv_costt;
    Button button_read, button_stop, button_clear;
    private ListView listView;
    
    Map<String, UhfI.ST_TagInfo> TagsMap = new LinkedHashMap();//有序
    private Handler handler = new Handler();
    private MyApplication myapp;
    private SoundPool soundPool;
    TabHost tabHost;
    ScreenListener l;
    AndroidWakeLock Awl;
    int Test_count = 0;
    boolean autostop;
    
    //RULE 默认平台
    boolean RULE_NOSELPT = false;
    
    List<Map<String, ?>> ListMs = new ArrayList<Map<String, ?>>();
    MyAdapter Adapter;
    Map<String, String> h = new HashMap<String, String>();
    
    public static boolean runRootCommand(String command) {
        Process process = null;
        DataOutputStream os = null;
        
        try {
            process = Runtime.getRuntime().exec("sh");//Runtime.getRuntime().exec("su");
            os = new DataOutputStream(process.getOutputStream());
            os.writeBytes(command + "\n");
            os.writeBytes("exit\n");
            os.flush();
            process.waitFor();
        } catch (Exception e) {
            Log.d("Phone Link", "su root - the device is not rooted,  error message： " + e.getMessage());
            return false;
        } finally {
            try {
                if (null != os) {
                    os.close();
                }
                if (null != process) {
                    process.destroy();
                }
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
        return true;
    }
    
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        setLange();
        String apkRoot = "chmod 777 " + getPackageCodePath();
        
        runRootCommand(apkRoot);
        
        soundPool = new SoundPool(10, AudioManager.STREAM_SYSTEM, 5);
        soundPool.load(this, R.raw.beep333, 1);
        Awl = new AndroidWakeLock((PowerManager) getSystemService(Context.POWER_SERVICE));
        
        Awl.WakeLock();
        tabHost = (TabHost) findViewById(android.R.id.tabhost);
        tabHost.setup();
        
        if (RULE_NOSELPT)
            ;
        else
            tabHost.addTab(tabHost.newTabSpec("tab1").setIndicator(MyApplication.Constr_CONNECT,
                                                                   getResources().getDrawable(R.drawable.ic_launcher)).setContent(
                    new Intent(this, Sub1TabActivity.class)));
        
        TabSpec tp = tabHost.newTabSpec("tab2").setIndicator(MyApplication.Constr_INVENTORY)
                .setContent(R.id.tab2);
        
        tabHost.addTab(tp);
        tabHost.addTab(tabHost.newTabSpec("tab3").setIndicator(MyApplication.Constr_RWLOP,
                                                               getResources().getDrawable(android.R.drawable.arrow_down_float)).setContent(
                new Intent(this, Sub3TabActivity.class)));
        
        tabHost.addTab(tabHost.newTabSpec("tab4").setIndicator(
                MyApplication.Constr_set,
                getResources().getDrawable(android.R.drawable.arrow_down_float)).setContent(
                new Intent(this, Sub4TabActivity.class)));
        
        TabWidget tw = tabHost.getTabWidget();
        if (RULE_NOSELPT)
            ;
        else {
            tw.getChildAt(1).setVisibility(View.INVISIBLE);
            tw.getChildAt(2).setVisibility(View.INVISIBLE);
            tw.getChildAt(3).setVisibility(View.INVISIBLE);
        }
        
        Application app = getApplication();
        myapp = (MyApplication) app;
        Coname = MyApplication.Coname;
        
        myapp.tabHost = tabHost;
        button_read = (Button) findViewById(R.id.button_start);
        button_stop = (Button) findViewById(R.id.button_stop);
        button_stop.setEnabled(false);
        button_clear = (Button) findViewById(R.id.button_readclear);
        listView = (ListView) findViewById(R.id.listView_epclist);
        
        tv_once = (TextView) findViewById(R.id.textView_readoncecnt);
        tv_state = (TextView) findViewById(R.id.textView_invstate);
        tv_tags = (TextView) findViewById(R.id.textView_readallcnt);
        tv_costt = (TextView) findViewById(R.id.textView_costtime);
        for (int i = 0; i < Coname.length; i++)
            h.put(Coname[i], Coname[i]);
        l = new ScreenListener(this);
        
        l.begin(new ScreenStateListener() {
            
            @Override
            public void onScreenOn() {
                
            }
            
            @Override
            public void onScreenOff() {
                if (button_stop.isEnabled()) { button_stop.performClick();}
            }
        });
        
        button_read.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View arg0) {
                try {
                    
                    if (Adapter == null) {
                        ListMs.add(h);
                        Adapter = new MyAdapter(getApplicationContext(),
                                                ListMs, R.layout.listitemview_inv, Coname,
                                                new int[]{R.id.textView_readsort,
                                                        R.id.textView_readepc,
                                                        R.id.textView_readcnt,
                                                        R.id.textView_readant,
                                                        R.id.textView_readpro,
                                                        R.id.textView_readrssi,
                                                        R.id.textView_readfre,
                                                        R.id.textView_reademd});
                        
                        listView.setAdapter(Adapter);
                    }
                    
                    UhfI.getInstance().startInventory(new UhfI.OnNewTagInventoried() {
                        @Override
                        public void onNewUiiReceived(final UhfI.ST_TagInfo tagInfo) {
                            //非主线程
                            runOnUiThread(new Runnable() {
                                @Override
                                public void run() {
                                    //soundPool.play(1, 1, 1, 0, 0, 1);
                                    TagsBufferResh(Utils.bytes_Hexstr(tagInfo.EpcId), tagInfo);
                                    Adapter.notifyDataSetChanged();
                                }
                            });
                        }
                    });
                    
                    myapp.TagsMap.clear();
                    ReadHandleUI();
                    
                } catch (Exception ex) {
                    Toast.makeText(
                            MainActivity.this,
                            MyApplication.Constr_nostopreadfailed
                                    + ex.getMessage(), Toast.LENGTH_SHORT)
                            .show();
                }
            }
            
        });
        
        button_stop.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View arg0) {
                UhfI.getInstance().stopInventory();
                StopHandleUI();
            }
            
        });
        
        button_clear.setOnClickListener(new OnClickListener() {
            
            @Override
            public void onClick(View arg0) {
                // TODO Auto-generated method stub
                if (Adapter != null) {
                    TagsMap.clear();
                    myapp.TagsMap.clear();
                    ListMs.clear();
                    // showlist();
                    
                    ListMs.add(h);
                    Adapter.notifyDataSetChanged();
                }
                
                TextView et = (TextView) findViewById(R.id.textView_readoncecnt);
                et.setText("0");
                
                TextView et2 = (TextView) findViewById(R.id.textView_readallcnt);
                et2.setText("0");
                
                TextView et3 = (TextView) findViewById(R.id.textView_invstate);
                et3.setText("...");
                
                myapp.Curepc = "";
            }
        });
        
        this.listView.setOnItemClickListener(new OnItemClickListener() {
            
            @Override
            public void onItemClick(AdapterView<?> arg0, View arg1, int arg2,
                                    long arg3) {
                // TODO Auto-generated method stub
                arg1.setBackgroundColor(Color.YELLOW);
                
                @SuppressWarnings("unchecked")
                HashMap<String, String> hm = (HashMap<String, String>) listView.getItemAtPosition(arg2);
                String epc = hm.get("EPC ID");
                myapp.Curepc = epc;
                
                for (int i = 0; i < listView.getCount(); i++) {
                    if (i != arg2) {
                        View v = listView.getChildAt(i);
                        if (v != null) {
                            ColorDrawable cd = (ColorDrawable) v.getBackground();
                            if (Color.YELLOW == cd.getColor()) {
                                int[] colors = {Color.WHITE, Color.rgb(219, 238, 244)};//RGB颜色
                                v.setBackgroundColor(colors[i % 2]);// 每隔item之间颜色不同
                            }
                        }
                    }
                }
            }
            
        });
        
        tabHost.setOnTabChangedListener(new OnTabChangeListener() {
            
            @Override
            public void onTabChanged(String arg0) {
                int j = tabHost.getCurrentTab();
                if (RULE_NOSELPT) {
                    if (j == 1) {
                        Sub3TabActivity.EditText_sub3fildata.setText(myapp.Curepc);
                        Sub3TabActivity.EditText_sub3wdata.setText(myapp.Curepc);
                    }
                } else {
                    if (j == 2) {
                        Sub3TabActivity.EditText_sub3fildata.setText(myapp.Curepc);
                        Sub3TabActivity.EditText_sub3wdata.setText(myapp.Curepc);
                    }
                }
            }
        });
    }
    
    String[] Coname;//=new String[]{"序号","EPC ID","次数","天线","协议","RSSI","频率","附加数据"};
    
    private void TagsBufferResh(String key, UhfI.ST_TagInfo tfs) {
        if (!TagsMap.containsKey(key)) {
            TagsMap.put(key, tfs);
            
            //show
            Map<String, String> m = new HashMap<String, String>();
            m.put(Coname[0], String.valueOf(TagsMap.size()));
            
            String epcstr = Utils.bytes_Hexstr(tfs.EpcId);
            if (epcstr.length() < 24)
                epcstr = String.format("%-24s", epcstr);
            
            m.put(Coname[1], epcstr);
            String cs = m.get("次数");
            if (cs == null)
                cs = "0";
            int isc = Integer.parseInt(cs) + tfs.ReadCnt;
            
            m.put(Coname[2], String.valueOf(isc));
            m.put(Coname[3],
                  String.valueOf(tfs.AntennaID));
            m.put(Coname[4], "");
            m.put(Coname[5], String.valueOf(tfs.RSSI));
            m.put(Coname[6],
                  String.valueOf(tfs.Frequency));
            
            if (tfs.EmbededDatalen > 0) {
                char[] out = new char[tfs.EmbededDatalen * 2];
                Utils.Hex2Str(tfs.EmbededData,
                              tfs.EmbededDatalen, out);
                m.put(Coname[7], String.valueOf(out));
                
            } else
                m.put(Coname[7], "                 ");
            
            ListMs.add(m);
        } else {
            UhfI.ST_TagInfo tf = TagsMap.get(key);
            
            String epcstr = key;
            if (epcstr.length() < 24)
                epcstr = String.format("%-24s", epcstr);
            
            for (int k = 0; k < ListMs.size(); k++) {
                @SuppressWarnings("unchecked")
                Map<String, String> m = (Map<String, String>) ListMs
                        .get(k);
                if (m.get(Coname[1]).equals(epcstr)) {
                    tf.ReadCnt += tfs.ReadCnt;
                    tf.RSSI = tfs.RSSI;
                    tf.Frequency = tfs.Frequency;
                    
                    m.put(Coname[2],
                          String.valueOf(tf.ReadCnt));
                    m.put(Coname[3],
                          String.valueOf(tfs.AntennaID));
                    m.put(Coname[5],
                          String.valueOf(tf.RSSI));
                    m.put(Coname[6],
                          String.valueOf(tf.Frequency));
                    break;
                }
            }
        }
    }
    
    private void ReadHandleUI() {
        this.button_read.setEnabled(false);
        this.button_stop.setEnabled(true);
        TabWidget tw = myapp.tabHost.getTabWidget();
        if (RULE_NOSELPT) {
            tw.getChildAt(1).setEnabled(false);
            tw.getChildAt(2).setEnabled(false);
        } else {
            tw.getChildAt(0).setEnabled(false);
            tw.getChildAt(2).setEnabled(false);
            tw.getChildAt(3).setEnabled(false);
        }
    }
    
    private void StopHandleUI() {
        button_read.setEnabled(true);
        button_stop.setEnabled(false);
        TabWidget tw = myapp.tabHost.getTabWidget();
        if (RULE_NOSELPT) {
            tw.getChildAt(1).setEnabled(true);
            tw.getChildAt(2).setEnabled(true);
        } else {
            tw.getChildAt(0).setEnabled(true);
            tw.getChildAt(2).setEnabled(true);
            tw.getChildAt(3).setEnabled(true);
        }
    }
    
    @Override
    public void onResume() {
        
        super.onResume();
        
    }
    
    @Override
    protected void onDestroy() {
        Awl.ReleaseWakeLock();
        System.exit(0);
        super.onDestroy();
    }
    
    @Override
    public void onPause() {
        
        super.onPause();
    }
    
    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        if (keyCode == KeyEvent.KEYCODE_BACK && event.getAction() == KeyEvent.ACTION_DOWN) {
            if ((System.currentTimeMillis() - myapp.exittime) > 2000) {
                Toast.makeText(getApplicationContext(), MyApplication.Constr_Putandexit, Toast.LENGTH_SHORT).show();
                myapp.exittime = System.currentTimeMillis();
            } else {
                UhfI.getInstance().stopInventory();
                UhfI.getInstance().uninit();
                finish();
            }
            return true;
        }
        
        return super.onKeyDown(keyCode, event);
    }
    
    private void setLange() {
        //Toast.makeText(getApplicationContext(), "setl1", Toast.LENGTH_SHORT).show();
        Locale locale = getApplicationContext().getResources().getConfiguration().locale;
        String language = locale.getLanguage();
        MyApplication.Constr_READ = this.getString(R.string.Constr_READ);
        MyApplication.Constr_CONNECT = this.getString(R.string.Constr_CONNECT);
        MyApplication.Constr_INVENTORY = this.getString(R.string.Constr_INVENTORY);
        MyApplication.Constr_RWLOP = this.getString(R.string.Constr_RWLOP);
        MyApplication.Constr_set = this.getString(R.string.Constr_set);
        MyApplication.Constr_SetFaill = this.getString(R.string.Constr_SetFaill);
        MyApplication.Constr_GetFaill = this.getString(R.string.Constr_GetFaill);
        MyApplication.Constr_SetOk = this.getString(R.string.Constr_SetOk);
        MyApplication.Constr_unsupport = this.getString(R.string.Constr_unsupport);
        MyApplication.Constr_Putandexit = this.getString(R.string.Constr_Putandexit);
        
        MyApplication.Constr_stopscan = this.getString(R.string.Constr_stopscan);
        MyApplication.Constr_hadconnected = this.getString(R.string.Constr_hadconnected);
        MyApplication.Constr_plsetuuid = this.getString(R.string.Constr_plsetuuid);
        MyApplication.Constr_pwderror = this.getString(R.string.Constr_pwderror);
        MyApplication.Constr_search = this.getString(R.string.Constr_search);
        MyApplication.Constr_stop = this.getString(R.string.Constr_stop);
        
        MyApplication.Constr_createreaderok = this.getString(R.string.Constr_createreaderok);
        
        MyApplication.Constr_sub3readmem = this.getString(R.string.Constr_sub3readmem);
        MyApplication.Constr_sub3writemem = this.getString(R.string.Constr_sub3writemem);
        MyApplication.Constr_sub3lockkill = this.getString(R.string.Constr_sub3lockkill);
        MyApplication.Constr_sub3readfail = this.getString(R.string.Constr_sub3readfail);
        MyApplication.Constr_sub3nodata = this.getString(R.string.Constr_sub3nodata);
        MyApplication.Constr_sub3wrtieok = this.getString(R.string.Constr_sub3wrtieok);
        MyApplication.Constr_sub3writefail = this.getString(R.string.Constr_sub3writefail);
        MyApplication.Constr_sub3lockok = this.getString(R.string.Constr_sub3lockok);
        MyApplication.Constr_sub3lockfail = this.getString(R.string.Constr_sub3lockfail);
        MyApplication.Constr_sub3killok = this.getString(R.string.Constr_sub3killok);
        MyApplication.Constr_sub3killfial = this.getString(R.string.Constr_sub3killfial);
        
        MyApplication.Auto = this.getString(R.string.Auto);
        MyApplication.No = this.getString(R.string.No);
        MyApplication.Constr_sub4invenpra = this.getString(R.string.Constr_sub4invenpra);
        MyApplication.Constr_sub4antpow = this.getString(R.string.Constr_sub4antpow);
        MyApplication.Constr_sub4regionfre = this.getString(R.string.Constr_sub4regionfre);
        MyApplication.Constr_sub4gen2opt = this.getString(R.string.Constr_sub4gen2opt);
        MyApplication.Constr_sub4invenfil = this.getString(R.string.Constr_sub4invenfil);
        MyApplication.Constr_sub4addidata = this.getString(R.string.Constr_sub4addidata);
        MyApplication.Constr_sub4others = this.getString(R.string.Constr_sub4others);
        MyApplication.Constr_sub4quickly = this.getString(R.string.Constr_sub4quickly);
        MyApplication.Constr_sub4setmodefail = this.getString(R.string.Constr_sub4setmodefail);
        MyApplication.Constr_sub4setokresettoab = this.getString(R.string.Constr_sub4setokresettoab);
        MyApplication.Constr_sub4ndsapow = this.getString(R.string.Constr_sub4ndsapow);
        MyApplication.Constr_sub4unspreg = this.getString(R.string.Constr_sub4unspreg);
        
        MyApplication.Constr_subblmode = this.getString(R.string.Constr_subblmode);
        MyApplication.Constr_subblinven = this.getString(R.string.Constr_subblinven);
        MyApplication.Constr_subblfil = this.getString(R.string.Constr_subblfil);
        MyApplication.Constr_subblfre = this.getString(R.string.Constr_subblfre);
        MyApplication.Constr_subblnofre = this.getString(R.string.Constr_subblnofre);
        
        MyApplication.Constr_subcsalterpwd = this.getString(R.string.Constr_subcsalterpwd);
        MyApplication.Constr_subcslockwpwd = this.getString(R.string.Constr_subcslockwpwd);
        MyApplication.Constr_subcslockwoutpwd = this.getString(R.string.Constr_subcslockwoutpwd);
        MyApplication.Constr_subcsplsetimeou = this.getString(R.string.Constr_subcsplsetimeou);
        MyApplication.Constr_subcsputcnpwd = this.getString(R.string.Constr_subcsputcnpwd);
        MyApplication.Constr_subcsplselreg = this.getString(R.string.Constr_subcsplselreg);
        MyApplication.Constr_subcsopfail = this.getString(R.string.Constr_subcsopfail);
        MyApplication.Constr_subcsputcurpwd = this.getString(R.string.Constr_subcsputcurpwd);
        
        MyApplication.Constr_subdbdisconnreconn = this.getString(R.string.Constr_subdbdisconnreconn);
        MyApplication.Constr_subdbhadconnected = this.getString(R.string.Constr_subdbhadconnected);
        MyApplication.Constr_subdbconnecting = this.getString(R.string.Constr_subdbconnecting);
        MyApplication.Constr_subdbrev = this.getString(R.string.Constr_subdbrev);
        MyApplication.Constr_subdbstop = this.getString(R.string.Constr_subdbstop);
        MyApplication.Constr_subdbdalennot = this.getString(R.string.Constr_subdbdalennot);
        MyApplication.Constr_subdbplpuhexchar = this.getString(R.string.Constr_subdbplpuhexchar);
        
        MyApplication.Constr_subsysaveok = this.getString(R.string.Constr_subsysaveok);
        MyApplication.Constr_subsysout = this.getString(R.string.Constr_subsysout);
        MyApplication.Constr_subsysreavaid = this.getString(R.string.Constr_subsysreavaid);
        MyApplication.Constr_sub1recfailed = this.getString(R.string.Constr_sub1recfailed);
        MyApplication.Constr_subsysavefailed = this.getString(R.string.Constr_subsysavefailed);
        MyApplication.Constr_subsysexefin = this.getString(R.string.Constr_subsysexefin);
        MyApplication.Constr_sub1adrno = this.getString(R.string.Constr_sub1adrno);
        MyApplication.Constr_sub1pdtsl = this.getString(R.string.Constr_sub1pdtsl);
        MyApplication.Constr_mainpu = this.getString(R.string.Constr_mainpu);
        MyApplication.Constr_nostopstreadfailed = this.getString(R.string.Constr_nostopstreadfailed);
        MyApplication.Constr_nostopspreadfailed = this.getString(R.string.Constr_nostopspreadfailed);
        MyApplication.Constr_nostopreadfailed = this.getString(R.string.Constr_nostopreadfailed);
        MyApplication.Constr_connectok = this.getString(R.string.Constr_connectok);
        MyApplication.Constr_connectfialed = this.getString(R.string.Constr_connectfialed);
        MyApplication.Constr_disconpowdown = this.getString(R.string.Constr_disconpowdown);
        MyApplication.Constr_ok = this.getString(R.string.Constr_ok);
        MyApplication.Constr_failed = this.getString(R.string.Constr_failed);
        MyApplication.Constr_excep = this.getString(R.string.Constr_excep);
        MyApplication.Constr_setcep = this.getString(R.string.Constr_setcep);
        MyApplication.Constr_getcep = this.getString(R.string.Constr_getcep);
        MyApplication.Constr_killok = this.getString(R.string.Constr_killok);
        MyApplication.Constr_killfailed = this.getString(R.string.Constr_killfailed);
        MyApplication.Constr_psiant = this.getString(R.string.Constr_psiant);
        MyApplication.Constr_selpro = this.getString(R.string.Constr_selpro);
        if (language.endsWith("zh")) {
            
        } else {
            MyApplication.Coname = new String[]{"Sort", "EPC ID", "Count", "Ant",
                    "Protocol", "RSSI", "Frequency", "Addition "};
            
            MyApplication.pdaatpot = new String[]{"one ant", "two ants", "three ants", "fours ants", "sixteen ants"};
            
            MyApplication.spibank = new String[]{"reserver bank", "EPC bank", "TID bank", "user bank"};
            MyApplication.spifbank = new String[]{"EPC bank", "TID bank", "User bank"};
            MyApplication.spilockbank = new String[]{"Access password", "Kill password", "EPCbank", "TIDbank", "USERbank"};
            MyApplication.spilocktype = new String[]{"Unlock", "Temporary lock", "Permanent lock"};
            
            MyApplication.spireg = new String[]{"China", "NA", "Japan", "Korea", "Europe", "Europe2", "Europe3", "India",
                    "Canada", "ALL", "China2"};
            MyApplication.spinvmo = new String[]{"General mode", "High speed mode"};
            MyApplication.spitari = new String[]{"25microsecond", "12.5microsecond", "6.25microsecond"};
            MyApplication.spiwmod = new String[]{"word write", "block write"};
            
            MyApplication.cusreadwrite = new String[]{"read opration", "wirte opration"};
            MyApplication.cuslockunlock = new String[]{"lock", "unlock"};
            
        }
        
    }
}
