package com.example.module_android_demo;

import android.app.Activity;
import android.app.Application;
import android.os.Bundle;
import android.view.KeyEvent;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.TabWidget;
import android.widget.TextView;
import android.widget.Toast;

import com.senter.iot.support.openapi.uhf.UhfI;


public class Sub1TabActivity extends Activity {
    
    private Button button_connect, button_disconnect;
    
    
    MyApplication myapp;
    
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.tab1_tablelayout_connect);
        
        Application app = getApplication();
        myapp = (MyApplication) app;
        
        button_connect = (Button) findViewById(R.id.button_connect);
        button_disconnect = (Button) findViewById(R.id.button_disconnect);
        
        //窗体事件
        button_connect.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View arg0) {
                boolean isInited = UhfI.getInstance().init();
                if (isInited) {
                    ConnectHandleUI();
                } else {
                    Toast.makeText(Sub1TabActivity.this, MyApplication.Constr_connectfialed, Toast.LENGTH_SHORT).show();
                }
            }
        });
        
        button_disconnect.setOnClickListener(new OnClickListener() {
            
            @Override
            public void onClick(View arg0) {
                UhfI.getInstance().uninit();
                Toast.makeText(Sub1TabActivity.this, MyApplication.Constr_disconpowdown + "true",
                               Toast.LENGTH_SHORT).show();
                DisConnectHandleUI();
            }
        });
    }
    
    private void ConnectHandleUI() {
        this.button_connect.setEnabled(false);
        this.button_disconnect.setEnabled(true);
        TabWidget tw = myapp.tabHost.getTabWidget();
        tw.getChildAt(1).setVisibility(View.VISIBLE);
        tw.getChildAt(2).setVisibility(View.VISIBLE);
        tw.getChildAt(3).setVisibility(View.VISIBLE);
        myapp.tabHost.setCurrentTab(1);
    }
    
    private void DisConnectHandleUI() {
        button_disconnect.setEnabled(false);
        button_connect.setEnabled(true);
        TabWidget tw = myapp.tabHost.getTabWidget();
        tw.getChildAt(1).setVisibility(View.INVISIBLE);
        tw.getChildAt(2).setVisibility(View.INVISIBLE);
        tw.getChildAt(3).setVisibility(View.INVISIBLE);
        TextView tv_module = (TextView) findViewById(R.id.textView_module);
        tv_module.setText("");
        
    }
    
    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        if (keyCode == KeyEvent.KEYCODE_BACK && event.getAction() == KeyEvent.ACTION_DOWN) {
            if ((System.currentTimeMillis() - myapp.exittime) > 2000) {
                Toast.makeText(getApplicationContext(), MyApplication.Constr_Putandexit, Toast.LENGTH_SHORT).show();
                myapp.exittime = System.currentTimeMillis();
            } else {
                finish();
                // System.exit(0);
            }
            return true;
        }
        return super.onKeyDown(keyCode, event);
    }
    
}
