package com.example.module_android_demo;

import android.app.Activity;
import android.app.Application;
import android.content.Context;
import android.graphics.Color;
import android.os.Bundle;
import android.text.TextUtils;
import android.view.KeyEvent;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.RadioGroup;
import android.widget.Spinner;
import android.widget.TabHost;
import android.widget.TabHost.OnTabChangeListener;
import android.widget.TabWidget;
import android.widget.TextView;
import android.widget.Toast;

import com.function.Utils;
import com.function.commfun;
import com.senter.iot.support.openapi.uhf.UhfI;

public class Sub3TabActivity extends Activity {
    
    Button button_readop, button_writeop, button_writepc, button_lockop, button_kill;
    Spinner spinner_opbank, spinner_bankr, spinner_bankw,
            spinner_lockbank, spinner_locktype;
    TabHost tabHost_op;
    RadioGroup gr_opant, gr_match, gr_enablefil, gr_wdatatype;
    CheckBox cb_pwd;
    // Switch swt_fil;
    @SuppressWarnings("rawtypes")
    private ArrayAdapter arradp_bank, arradp_fbank, arradp_lockbank, arradp_locktype;
    MyApplication myapp;
    public static EditText EditText_sub3fildata, EditText_sub3wdata;
    
    private View createIndicatorView(Context context, TabHost tabHost, String title) {
        LayoutInflater inflater = (LayoutInflater) context.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
        
        View tabIndicator = inflater.inflate(R.layout.tab_indicator_vertical, tabHost.getTabWidget(), false);
        final TextView titleView = (TextView) tabIndicator.findViewById(R.id.tv_indicator);
        titleView.setText(title);
        return tabIndicator;
    }
    
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.tab3_tablelayout);
        Application app = getApplication();
        myapp = (MyApplication) app;
        
        // 获取TabHost对象
        // 得到TabActivity中的TabHost对象
        tabHost_op = (TabHost) findViewById(R.id.tabhost3);
        // 如果没有继承TabActivity时，通过该种方法加载启动tabHost
        tabHost_op.setup();
        tabHost_op.getTabWidget().setOrientation(LinearLayout.VERTICAL);
        
        tabHost_op.addTab(tabHost_op.newTabSpec("tab1").setIndicator(createIndicatorView(this, tabHost_op, MyApplication.Constr_sub3readmem))
                                  .setContent(R.id.tab3_sub_read));
        tabHost_op.addTab(tabHost_op.newTabSpec("tab2").setIndicator(createIndicatorView(this, tabHost_op, MyApplication.Constr_sub3writemem))
                                  .setContent(R.id.tab3_sub_write));
        tabHost_op.addTab(tabHost_op.newTabSpec("tab3").setIndicator(createIndicatorView(this, tabHost_op, MyApplication.Constr_sub3lockkill))
                                  .setContent(R.id.tab3_sub_lockkill));
        
        TabWidget tw = tabHost_op.getTabWidget();
        tw.getChildAt(0).setBackgroundColor(Color.BLUE);
        
        spinner_bankr = (Spinner) findViewById(R.id.spinner_bankr);
        spinner_bankw = (Spinner) findViewById(R.id.spinner_bankw);
        spinner_opbank = (Spinner) findViewById(R.id.spinner_opfbank);
        arradp_bank = new ArrayAdapter<String>(this, android.R.layout.simple_spinner_item, MyApplication.spibank);
        arradp_bank.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        arradp_fbank = new ArrayAdapter<String>(this, android.R.layout.simple_spinner_item, MyApplication.spifbank);
        arradp_fbank.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        spinner_bankr.setAdapter(arradp_bank);
        spinner_bankw.setAdapter(arradp_bank);
        spinner_opbank.setAdapter(arradp_fbank);
        
        spinner_lockbank = (Spinner) findViewById(R.id.spinner_lockbank);
        //将可选内容与ArrayAdapter连接起来
        arradp_lockbank = new ArrayAdapter<String>(this, android.R.layout.simple_spinner_item, MyApplication.spilockbank);
        //设置下拉列表的风格
        arradp_lockbank.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        //将adapter 添加到spinner中
        spinner_lockbank.setAdapter(arradp_lockbank);
        
        spinner_locktype = (Spinner) findViewById(R.id.spinner_locktype);
        arradp_locktype = new ArrayAdapter<String>(this, android.R.layout.simple_spinner_item, MyApplication.spilocktype);
        arradp_locktype.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        spinner_locktype.setAdapter(arradp_locktype);
        
        button_readop = (Button) findViewById(R.id.button_read);
        button_writeop = (Button) findViewById(R.id.button_write);
        button_writepc = (Button) findViewById(R.id.button_wepc);
        button_lockop = (Button) findViewById(R.id.button_lock);
        button_kill = (Button) findViewById(R.id.button_kill);
        gr_opant = (RadioGroup) findViewById(R.id.radioGroup_opant);
        gr_match = (RadioGroup) findViewById(R.id.radioGroup_opmatch);
        gr_enablefil = (RadioGroup) findViewById(R.id.radioGroup_enableopfil);
        gr_wdatatype = (RadioGroup) findViewById(R.id.radioGroup_datatype);
        cb_pwd = (CheckBox) findViewById(R.id.checkBox_opacepwd);
        EditText_sub3fildata = (EditText) findViewById(R.id.editText_opfilterdata);
        EditText_sub3wdata = (EditText) findViewById(R.id.editText_dataw);
        
        spinner_opbank.setSelection(0);
        spinner_bankr.setSelection(1);
        spinner_bankw.setSelection(1);
        spinner_lockbank.setSelection(2);
        spinner_locktype.setSelection(1);
        
        button_readop.setOnClickListener(new OnClickListener() {
            
            @Override
            public void onClick(View arg0) {
                
                //密码处理
                byte[] rpaswd = new byte[4];
                if (cb_pwd.isChecked()) {
                    EditText et = (EditText) findViewById(R.id.editText_password);
                    if (!TextUtils.isEmpty(et.getText().toString())) {
                        Utils.Str2Hex(et.getText().toString(), et.getText().toString().length(), rpaswd);
                    }
                }
                
                //过滤条件处理
                UhfI.ST_TagFilter tagFilter = new UhfI.ST_TagFilter();
                if (commfun.SortGroup(gr_enablefil) == 1) {
                    EditText et = (EditText) findViewById(R.id.editText_opfilterdata);
                    int ln = et.getText().toString().length();
                    if (ln == 1 || ln % 2 == 1)
                        ln++;
                    byte[] fdata = new byte[ln / 2];
                    Utils.Str2Hex(et.getText().toString(),
                                  et.getText().toString().length(), fdata);
                    tagFilter.fdata = fdata;
                    tagFilter.flen = fdata.length * 8;
                    int ma = commfun.SortGroup(gr_match);
                    if (ma == 1)
                        tagFilter.isInvert = 1;
                    else
                        tagFilter.isInvert = 0;
                    
                    tagFilter.bank = UhfI.Bank.valueOf(spinner_opbank.getSelectedItemPosition() + 1);
                    
                    EditText etadr = (EditText) findViewById(R.id.editText_opfilsadr);
                    tagFilter.startaddr = Integer.valueOf(etadr.getText().toString());
                } else {
                    tagFilter = null;
                }
                
                EditText etcount = (EditText) findViewById(R.id.editText_opcountr);
                EditText etadr = (EditText) findViewById(R.id.editText_startaddr);
                EditText etdr = (EditText) findViewById(R.id.editText_datar);
                
                byte[] data = UhfI.getInstance().readTag(UhfI.Bank.valueOf(spinner_bankr.getSelectedItemPosition()),
                                                         Integer.valueOf(etadr.getText().toString()),
                                                         Integer.valueOf(etcount.getText().toString()),
                                                         rpaswd, tagFilter);
                try {
                    if (data != null) {
                        //读取数据成功
                        String val = "";
                        char[] out = null;
                        if (commfun.SortGroup(gr_wdatatype) == 0) {
                            out = new char[data.length * 2];
                            Utils.Hex2Str(data, data.length, out);
                            val = String.valueOf(out);
                        } else if (commfun.SortGroup(gr_wdatatype) == 1) {
                            out = new char[data.length];
                            for (int i = 0; i < data.length; i++)
                                out[i] = (char) data[i];
                            val = String.valueOf(out);
                        } else if (commfun.SortGroup(gr_wdatatype) == 2) {
                            val = new String(data, "gbk");
                        }
                        etdr.setText(val);
                        EditText_sub3wdata.setText(val);
                        Toast.makeText(Sub3TabActivity.this, MyApplication.Constr_ok,
                                       Toast.LENGTH_SHORT).show();
                    } else {
                        Toast.makeText(Sub3TabActivity.this, MyApplication.Constr_failed,
                                       Toast.LENGTH_SHORT).show();
                    }
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        });
        
        button_writeop.setOnClickListener(new OnClickListener() {
            
            @Override
            public void onClick(View arg0) {
                
                //密码处理
                byte[] rpaswd = new byte[4];
                if (cb_pwd.isChecked()) {
                    EditText et = (EditText) findViewById(R.id.editText_password);
                    if (!TextUtils.isEmpty(et.getText().toString())) {
                        Utils.Str2Hex(et.getText().toString(), et.getText().toString().length(), rpaswd);
                    }
                }
                
                //过滤条件处理
                UhfI.ST_TagFilter tagFilter = new UhfI.ST_TagFilter();
                if (commfun.SortGroup(gr_enablefil) == 1) {
                    EditText et = (EditText) findViewById(R.id.editText_opfilterdata);
                    int ln = et.getText().toString().length();
                    if (ln == 1 || ln % 2 == 1)
                        ln++;
                    byte[] fdata = new byte[ln / 2];
                    Utils.Str2Hex(et.getText().toString(),
                                  et.getText().toString().length(), fdata);
                    tagFilter.fdata = fdata;
                    tagFilter.flen = fdata.length * 8;
                    int ma = commfun.SortGroup(gr_match);
                    if (ma == 1)
                        tagFilter.isInvert = 1;
                    else
                        tagFilter.isInvert = 0;
                    
                    tagFilter.bank = UhfI.Bank.valueOf(spinner_bankw.getSelectedItemPosition() + 1);
                    
                    EditText etadr = (EditText) findViewById(R.id.editText_opfilsadr);
                    tagFilter.startaddr = Integer.valueOf(etadr.getText().toString());
                } else {
                    tagFilter = null;
                }
                
                EditText etadr = (EditText) findViewById(R.id.editText_startaddrw);
                
                try {
                    byte[] data = null;
                    if (commfun.SortGroup(gr_wdatatype) == 0) {
                        data = new byte[EditText_sub3wdata.getText().toString().length() / 2];
                        Utils.Str2Hex(EditText_sub3wdata.getText().toString(),
                                      EditText_sub3wdata.getText().length(), data);
                    } else if (commfun.SortGroup(gr_wdatatype) == 1) {
                        String ascstr = EditText_sub3wdata.getText().toString();
                        if (ascstr.length() % 2 != 0)
                            ascstr += "0";
                        data = ascstr.getBytes();
                        
                    } else if (commfun.SortGroup(gr_wdatatype) == 2) {
                        String ascstr = EditText_sub3wdata.getText().toString();
                        data = ascstr.getBytes("gbk");
                    }
                    
                    boolean isSuccess = UhfI.getInstance().writeTag(UhfI.Bank.valueOf(spinner_bankw.getSelectedItemPosition()),
                                                                    Integer.valueOf(etadr.getText().toString()),
                                                                    data, rpaswd, tagFilter);
                    if (isSuccess) {
                        Toast.makeText(Sub3TabActivity.this, MyApplication.Constr_ok,
                                       Toast.LENGTH_SHORT).show();
                    } else {
                        Toast.makeText(Sub3TabActivity.this, MyApplication.Constr_failed,
                                       Toast.LENGTH_SHORT).show();
                    }
                } catch (Exception e) {
                    e.printStackTrace();
                    Toast.makeText(Sub3TabActivity.this, MyApplication.Constr_excep + e.getMessage(),
                                   Toast.LENGTH_SHORT).show();
                }
            }
            
        });
        
        button_writepc.setOnClickListener(new OnClickListener() {
            
            @Override
            public void onClick(View arg0) {
                
                //密码处理
                byte[] rpaswd = new byte[4];
                if (cb_pwd.isChecked()) {
                    EditText et = (EditText) findViewById(R.id.editText_password);
                    if (!TextUtils.isEmpty(et.getText().toString())) {
                        Utils.Str2Hex(et.getText().toString(), et.getText().toString().length(), rpaswd);
                    }
                }
                
                try {
                    byte[] data = null;
                    if (commfun.SortGroup(gr_wdatatype) == 0) {
                        data = new byte[EditText_sub3wdata.getText().toString().length() / 2];
                        Utils.Str2Hex(EditText_sub3wdata.getText().toString(),
                                      EditText_sub3wdata.getText().length(), data);
                    } else if (commfun.SortGroup(gr_wdatatype) == 1) {
                        String ascstr = EditText_sub3wdata.getText().toString();
                        if (ascstr.length() / 2 != 0)
                            ascstr += "0";
                        data = new byte[EditText_sub3wdata.getText().toString().length()];
                        
                        for (int i = 0; i < data.length; i++)
                            data[i] = Byte.parseByte(ascstr.substring(i, 1), 16);
                    } else if (commfun.SortGroup(gr_wdatatype) == 2) {
                        String ascstr = EditText_sub3wdata.getText().toString();
                        
                        data = ascstr.getBytes("gbk");
                    }
                    boolean isSuccess = UhfI.getInstance().writeTagEpc(data, rpaswd);
                    if (isSuccess) {
                        Toast.makeText(Sub3TabActivity.this, MyApplication.Constr_ok,
                                       Toast.LENGTH_SHORT).show();
                    } else {
                        Toast.makeText(Sub3TabActivity.this, MyApplication.Constr_failed,
                                       Toast.LENGTH_SHORT).show();
                    }
                    
                } catch (Exception e) {
                    e.printStackTrace();
                    Toast.makeText(Sub3TabActivity.this, MyApplication.Constr_excep + e.getMessage(),
                                   Toast.LENGTH_SHORT).show();
                }
            }
            
        });
        
        button_lockop.setOnClickListener(new OnClickListener() {
            
            @Override
            public void onClick(View arg0) {
                
                //密码处理
                byte[] rpaswd = new byte[4];
                if (cb_pwd.isChecked()) {
                    EditText et = (EditText) findViewById(R.id.editText_password);
                    if (!TextUtils.isEmpty(et.getText().toString())) {
                        Utils.Str2Hex(et.getText().toString(), et.getText().toString().length(), rpaswd);
                    }
                }
                
                //过滤条件处理
                UhfI.ST_TagFilter tagFilter = new UhfI.ST_TagFilter();
                if (commfun.SortGroup(gr_enablefil) == 1) {
                    EditText et = (EditText) findViewById(R.id.editText_opfilterdata);
                    int ln = et.getText().toString().length();
                    if (ln == 1 || ln % 2 == 1)
                        ln++;
                    byte[] fdata = new byte[ln / 2];
                    Utils.Str2Hex(et.getText().toString(),
                                  et.getText().toString().length(), fdata);
                    tagFilter.fdata = fdata;
                    tagFilter.flen = fdata.length * 8;
                    int ma = commfun.SortGroup(gr_match);
                    if (ma == 1)
                        tagFilter.isInvert = 1;
                    else
                        tagFilter.isInvert = 0;
                    
                    tagFilter.bank = UhfI.Bank.valueOf(spinner_bankw.getSelectedItemPosition() + 1);
                    
                    EditText etadr = (EditText) findViewById(R.id.editText_opfilsadr);
                    tagFilter.startaddr = Integer.valueOf(etadr.getText().toString());
                } else {
                    tagFilter = null;
                }
                
                UhfI.ST_LockObject lobj = null;
                UhfI.ST_LockType ltyp = null;
                int lbank = spinner_lockbank.getSelectedItemPosition();
                int ltype = spinner_locktype.getSelectedItemPosition();
                if (lbank == 0) {
                    lobj = UhfI.ST_LockObject.LOCK_OBJECT_ACCESS_PASSWD;
                    if (ltype == 0)
                        ltyp = UhfI.ST_LockType.ACCESS_PASSWD_UNLOCK;
                    else if (ltype == 1)
                        ltyp = UhfI.ST_LockType.ACCESS_PASSWD_LOCK;
                    else if (ltype == 2)
                        ltyp = UhfI.ST_LockType.ACCESS_PASSWD_PERM_LOCK;
                    
                } else if (lbank == 1) {
                    lobj = UhfI.ST_LockObject.LOCK_OBJECT_KILL_PASSWORD;
                    if (ltype == 0)
                        ltyp = UhfI.ST_LockType.KILL_PASSWORD_UNLOCK;
                    else if (ltype == 1)
                        ltyp = UhfI.ST_LockType.KILL_PASSWORD_LOCK;
                    else if (ltype == 2)
                        ltyp = UhfI.ST_LockType.KILL_PASSWORD_PERM_LOCK;
                } else if (lbank == 2) {
                    lobj = UhfI.ST_LockObject.LOCK_OBJECT_BANK1;
                    if (ltype == 0)
                        ltyp = UhfI.ST_LockType.BANK1_UNLOCK;
                    else if (ltype == 1)
                        ltyp = UhfI.ST_LockType.BANK1_LOCK;
                    else if (ltype == 2)
                        ltyp = UhfI.ST_LockType.BANK1_PERM_LOCK;
                } else if (lbank == 3) {
                    lobj = UhfI.ST_LockObject.LOCK_OBJECT_BANK2;
                    if (ltype == 0)
                        ltyp = UhfI.ST_LockType.BANK2_UNLOCK;
                    else if (ltype == 1)
                        ltyp = UhfI.ST_LockType.BANK2_LOCK;
                    else if (ltype == 2)
                        ltyp = UhfI.ST_LockType.BANK2_PERM_LOCK;
                } else if (lbank == 4) {
                    lobj = UhfI.ST_LockObject.LOCK_OBJECT_BANK3;
                    if (ltype == 0)
                        ltyp = UhfI.ST_LockType.BANK3_UNLOCK;
                    else if (ltype == 1)
                        ltyp = UhfI.ST_LockType.BANK3_LOCK;
                    else if (ltype == 2)
                        ltyp = UhfI.ST_LockType.BANK3_PERM_LOCK;
                }
                
                boolean isSuccess = UhfI.getInstance().lockTag(lobj, ltyp, rpaswd, tagFilter);
                if (isSuccess) {
                    Toast.makeText(Sub3TabActivity.this, MyApplication.Constr_sub3lockok,
                                   Toast.LENGTH_SHORT).show();
                } else {
                    Toast.makeText(Sub3TabActivity.this, MyApplication.Constr_sub3lockfail,
                                   Toast.LENGTH_SHORT).show();
                }
            }
            
        });
        
        button_kill.setOnClickListener(new OnClickListener() {
            
            @Override
            public void onClick(View arg0) {
                //密码处理
                byte[] rpaswd = new byte[4];
                if (cb_pwd.isChecked()) {
                    EditText et = (EditText) findViewById(R.id.editText_password);
                    if (!TextUtils.isEmpty(et.getText().toString())) {
                        Utils.Str2Hex(et.getText().toString(), et.getText().toString().length(), rpaswd);
                    }
                }
                
                //过滤条件处理
                UhfI.ST_TagFilter tagFilter = new UhfI.ST_TagFilter();
                if (commfun.SortGroup(gr_enablefil) == 1) {
                    EditText et = (EditText) findViewById(R.id.editText_opfilterdata);
                    int ln = et.getText().toString().length();
                    if (ln == 1 || ln % 2 == 1)
                        ln++;
                    byte[] fdata = new byte[ln / 2];
                    Utils.Str2Hex(et.getText().toString(),
                                  et.getText().toString().length(), fdata);
                    tagFilter.fdata = fdata;
                    tagFilter.flen = fdata.length * 8;
                    int ma = commfun.SortGroup(gr_match);
                    if (ma == 1)
                        tagFilter.isInvert = 1;
                    else
                        tagFilter.isInvert = 0;
                    
                    tagFilter.bank = UhfI.Bank.valueOf(spinner_bankw.getSelectedItemPosition() + 1);
                    
                    EditText etadr = (EditText) findViewById(R.id.editText_opfilsadr);
                    tagFilter.startaddr = Integer.valueOf(etadr.getText().toString());
                } else {
                    tagFilter = null;
                }
                boolean isSuccess = UhfI.getInstance().killTag(rpaswd, tagFilter);
                if (isSuccess) {
                    Toast.makeText(Sub3TabActivity.this, MyApplication.Constr_killok,
                                   Toast.LENGTH_SHORT).show();
                } else {
                    Toast.makeText(Sub3TabActivity.this, MyApplication.Constr_killfailed,
                                   Toast.LENGTH_SHORT).show();
                }
            }
            
        });
        
        tabHost_op.setOnTabChangedListener(new OnTabChangeListener() {
            
            @Override
            public void onTabChanged(String arg0) {
                int j = tabHost_op.getCurrentTab();
                TabWidget tabIndicator = tabHost_op.getTabWidget();
                View vw = tabIndicator.getChildAt(j);
                vw.setBackgroundColor(Color.BLUE);
                int tc = tabHost_op.getTabContentView().getChildCount();
                for (int i = 0; i < tc; i++) {
                    if (i != j) {
                        View vw2 = tabIndicator.getChildAt(i);
                        vw2.setBackgroundColor(Color.TRANSPARENT);
                    }
                }
                
            }
            
        });
    }
    
    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        if (keyCode == KeyEvent.KEYCODE_BACK && event.getAction() == KeyEvent.ACTION_DOWN) {
            if ((System.currentTimeMillis() - myapp.exittime) > 2000) {
                Toast.makeText(getApplicationContext(), MyApplication.Constr_Putandexit, Toast.LENGTH_SHORT).show();
                myapp.exittime = System.currentTimeMillis();
            } else {
                finish();
                // System.exit(0);
            }
            return true;
        }
        return super.onKeyDown(keyCode, event);
    }
    
    
}
