package com.senter.demo.temperature.until;

import android.text.InputFilter;
import android.text.Spanned;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * Created by Administrator on 2016/10/29.
 */
public class EmissivityEditInputFilter implements InputFilter {
    /**
     * Maximum number
     */
    public static final int MAX_VALUE = 1;
    public static final float MIN_VALUE =(float) 0.01;
    /**
     * Number of digits after the decimal point
     */
    public static final int PONTINT_LENGTH = 2;
    Pattern p;

    public EmissivityEditInputFilter() {
        p = Pattern.compile("[0-9]*");   //除数字外的其他的
    }

    /**
     * source   new input string
     * start    new input string starting index, generally 0
     * end    new input of the end of the string index, generally source length -1
     * dest     input text box content before
     * dstart   original content of the initial coordinates, generally 0
     * dend     the original content of the final coordinates, the general length of -1 dest
     */

    @Override
    public CharSequence filter(CharSequence src, int start, int end,
                               Spanned dest, int dstart, int dend) {
        String oldtext = dest.toString();
        System.out.println(oldtext);
        //Verify delete button
        if ("".equals(src.toString())) {
            return null;
        }
        if (".".equals(src.toString()) && oldtext.length() == 0) {return dest.subSequence(dstart, dend);}
        //Verify the non numeric or decimal point
        Matcher m = p.matcher(src);
        if (oldtext.contains(".")) {
            //Already exists in the case of the decimal point, can only enter the number
            if (!m.matches()) {
                return null;
            }
        } else {
            //Enter the decimal point, you can enter the decimal point and number
            if (!m.matches() && !src.equals(".")) {
                return null;
            }
        }

        if (!src.toString().equals("")) {
            double dold = Double.parseDouble(oldtext + src.toString());
            if (dold > MAX_VALUE) {
                return dest.subSequence(dstart, dend);
            } else if (dold == MAX_VALUE) {
                if (src.toString().equals(".")) {
                    return dest.subSequence(dstart, dend);
                }
            }

        }
        if (oldtext.contains(".")) {
            int index = oldtext.indexOf(".");
            int len = dend - index;
            //Small bits can only be 2 bit
            if (len > PONTINT_LENGTH) {
                CharSequence newText = dest.subSequence(dstart, dend);
                return newText;
            }
        }
        return dest.subSequence(dstart, dend) + src.toString();
    }
}