package com.senter.demo.uhf.modelD2;

import android.app.Activity;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;

import com.senter.demo.uhf.App;
import com.senter.demo.uhf.R;
import com.senter.demo.uhf.common.DestinationTagSpecifics;
import com.senter.demo.uhf.common.RecordsBoard;
import com.senter.demo.uhf.util.DataTransfer;
import com.senter.support.openapi.StUhf;

public class Activity1ReadMultiActivity extends Activity {
    
    private RecordsBoard recordsBoard;
    private DestinationTagSpecifics destinationTagSpecifics;
    
    private View inputView;
    private TextView tv_switch;
    
    private EditText et_res_start;
    private EditText et_res_length;
    private EditText et_tid_start;
    private EditText et_tid_length;
    private EditText et_user_start;
    private EditText et_user_length;
    
    private Spinner sp_session;
    private Spinner sp_target;
    private Spinner sp_readMode;
    private Button btnRead;
    
    private boolean isExpand = true;//展开
    
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_d2_read_multi);
        initViews();
        addListener();
        expand(isExpand);
    }
    
    private void initViews() {
        inputView = findViewById(R.id.idE21ReadActivity_llRead);
        tv_switch = (TextView) findViewById(R.id.tv_switch);
        et_res_start = (EditText) findViewById(R.id.et_res_start);
        et_res_length = (EditText) findViewById(R.id.et_res_length);
        et_tid_start = (EditText) findViewById(R.id.et_tid_start);
        et_tid_length = (EditText) findViewById(R.id.et_tid_length);
        et_user_start = (EditText) findViewById(R.id.et_user_start);
        et_user_length = (EditText) findViewById(R.id.et_user_length);
        sp_session = (Spinner) findViewById(R.id.sp_session);
        sp_target = (Spinner) findViewById(R.id.sp_target);
        sp_readMode = (Spinner) findViewById(R.id.sp_readMode);
        btnRead = (Button) findViewById(R.id.idE21ReadActivity_btnRead);
        
        recordsBoard = new RecordsBoard(this, findViewById(R.id.idE21ReadActivity_inShow));
        
        destinationTagSpecifics = new DestinationTagSpecifics(this, findViewById(R.id.idE21ReadActivity_inDestTypes),
                                                              DestinationTagSpecifics.ProtocolType.Iso18k6C, DestinationTagSpecifics.PasswordType.Apwd,
                                                              new DestinationTagSpecifics.TargetTagType[]{DestinationTagSpecifics.TargetTagType.SingleTag, DestinationTagSpecifics.TargetTagType.SpecifiedTag});
        destinationTagSpecifics.setOnReadyLisener(new DestinationTagSpecifics.OnDestOpTypesLisener() {
            @Override
            public void onReadyStateChanged(boolean now) {
                setViewEnable(btnRead, now);
            }
        });
    }
    
    private void addListener() {
        tv_switch.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                isExpand = !isExpand;
                expand(isExpand);
            }
        });
        
        btnRead.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                isExpand = false;
                expand(isExpand);
                onBtnRead();
            }
        });
    }
    
    private void expand(boolean isExpand) {
        int marginBottom = 0;
        if (isExpand) {
            //需要展开
            marginBottom = 0;
            tv_switch.setText("点击收缩");
        } else {
            //需要收缩
            marginBottom = -inputView.getHeight() + tv_switch.getHeight() + 10;
            tv_switch.setText("点击展开");
        }
        ViewGroup.MarginLayoutParams params = (ViewGroup.MarginLayoutParams) inputView.getLayoutParams();
        params.bottomMargin = marginBottom;
        inputView.setLayoutParams(params);
    }
    
    /**
     * 点击 读数据
     */
    private void onBtnRead() {
        if (destinationTagSpecifics.isOrderedUii() == true && destinationTagSpecifics.getDstTagUiiIfOrdered() == null) {
            Toast.makeText(this, R.string.InputCorrectLabel, Toast.LENGTH_SHORT).show();
            return;
        }
        
        if (destinationTagSpecifics.isOrderedUii()) {
            StUhf.UII uii = destinationTagSpecifics.getDstTagUiiIfOrdered();
            Boolean boolean1 = App.uhfInterfaceAsModelD2().iso18k6cSetAccessEpcMatch(StUhf.InterrogatorModelDs.UmdEpcMatchSetting.newInstanceOfMatchingEpcFieldInUii(uii.getEpc().getBytes()));
            if (boolean1 == null || boolean1 == false) {
                showToast("failed");
                return;
            }
        }
        
        //保留区的起始地址，以字为单位
        int resAdd = 0;
        //保留区的读取长度，以字为单位
        int resLen = 0;
        //TID区的起始地址，以字为单位
        int tidAdd = 0;
        //TID区的读取长度，以字为单位
        int tidLen = 0;
        //用户区的起始地址，以字为单位
        int userAdd = 0;
        //用户区的读取长度，以字为单位
        int userLen = 0;
        
        try {
            resAdd = Integer.parseInt(et_res_start.getText().toString().trim());
        } catch (Exception e) {
            Toast.makeText(this, R.string.InputCorrectReadLength, Toast.LENGTH_SHORT).show();
            return;
        }
        
        try {
            resLen = Integer.parseInt(et_res_length.getText().toString().trim());
        } catch (Exception e) {
            Toast.makeText(this, R.string.InputCorrectReadLength, Toast.LENGTH_SHORT).show();
            return;
        }
        
        try {
            tidAdd = Integer.parseInt(et_tid_start.getText().toString().trim());
        } catch (Exception e) {
            Toast.makeText(this, R.string.InputCorrectReadLength, Toast.LENGTH_SHORT).show();
            return;
        }
        
        try {
            tidLen = Integer.parseInt(et_tid_length.getText().toString().trim());
        } catch (Exception e) {
            Toast.makeText(this, R.string.InputCorrectReadLength, Toast.LENGTH_SHORT).show();
            return;
        }
        
        try {
            userAdd = Integer.parseInt(et_user_start.getText().toString().trim());
        } catch (Exception e) {
            Toast.makeText(this, R.string.InputCorrectReadLength, Toast.LENGTH_SHORT).show();
            return;
        }
        
        try {
            userLen = Integer.parseInt(et_user_length.getText().toString().trim());
        } catch (Exception e) {
            Toast.makeText(this, R.string.InputCorrectReadLength, Toast.LENGTH_SHORT).show();
            return;
        }
        StUhf.InterrogatorModelDs.UmdSession session = null;
        switch (sp_session.getSelectedItemPosition()) {
            case 0:
                session = StUhf.InterrogatorModelDs.UmdSession.S0;
                break;
            case 1:
                session = StUhf.InterrogatorModelDs.UmdSession.S1;
                break;
            case 2:
                session = StUhf.InterrogatorModelDs.UmdSession.S2;
                break;
            case 3:
                session = StUhf.InterrogatorModelDs.UmdSession.S3;
                break;
        }
        StUhf.InterrogatorModelDs.UmdTarget target = null;
        switch (sp_target.getSelectedItemPosition()) {
            case 0:
                target = StUhf.InterrogatorModelDs.UmdTarget.A;
                break;
            case 1:
                target = StUhf.InterrogatorModelDs.UmdTarget.B;
                break;
        }
        StUhf.InterrogatorModelDs.UmdReadMode readMode = null;
        switch (sp_readMode.getSelectedItemPosition()) {
            case 0:
                readMode = StUhf.InterrogatorModelDs.UmdReadMode.Single_Mode_Fast;
                break;
            case 1:
                readMode = StUhf.InterrogatorModelDs.UmdReadMode.Single_Mode;
                break;
            case 2:
                readMode = StUhf.InterrogatorModelDs.UmdReadMode.Multi_Mode;
                break;
        }
        App.uhfInterfaceAsModelD2().iso18k6cReadForMulti(destinationTagSpecifics.getAccessPassword(), resAdd, resLen, tidAdd, tidLen, userAdd, userLen, session, target, readMode, new StUhf
                .InterrogatorModelDs.UmdOnIso18k6cReadMulti() {
            @Override
            public void onTagRead(int tagCount, StUhf.UII uii, byte[] resData, byte[] tidData, byte[] userData, StUhf.InterrogatorModelDs.UmdFrequencyPoint frequencyPoint, Integer antennaId, int readCount) {
                //读取到数据
                //resData:保留区数据 没有读取该区 返回null
                //tidData:TID区数据 没有读取该区 返回null
                //userData:用户区数据 没有读取该区 返回null
                addNewMassageToListview(uii, resData, tidData, userData);
            }
            
            @Override
            public void onFailed(StUhf.InterrogatorModelDs.UmdErrorCode errorCode) {
                //读取失败
                showToast("error:" + errorCode.name());
            }
        });
    }
    
    protected final void addNewMassageToListview(final StUhf.UII uii, final byte[] resData, final byte[] tidData, final byte[] userData) {
        runOnUiThread(new Runnable() {
            @Override
            public void run() {
                recordsBoard.addMassage(getString(R.string.Label) + (uii != null ? DataTransfer.xGetString(uii.getBytes()) : "unknown")
                                                + "\r\n"
                                                + "Reversed: " + getString(R.string.Length) + (resData != null ? resData.length / 2 : 0) + " " + getString(R.string.Data) + DataTransfer
                        .xGetString
                                (resData)
                                                + "\r\n"
                                                + "Tid: " + getString(R.string.Length) + (tidData != null ? tidData.length / 2 : 0) + " " + getString(R.string.Data) + DataTransfer
                        .xGetString
                                (tidData)
                                                + "\r\n"
                                                + "User: " + getString(R.string.Length) + (userData != null ? userData.length / 2 : 0) + " " + getString(R.string.Data) + DataTransfer
                        .xGetString
                                (userData)
                                                + "\r\n"
                );
            }
        });
    }
    
    public final void showToast(final String string) {
        runOnUiThread(new Runnable() {
            @Override
            public void run() {
                Toast.makeText(Activity1ReadMultiActivity.this, string, Toast.LENGTH_SHORT).show();
            }
        });
    }
    
    public final void setViewEnable(final View view, final boolean en) {
        runOnUiThread(new Runnable() {
            @Override
            public void run() {
                view.setEnabled(en);
            }
        });
    }
    
    @Override
    public final boolean onPrepareOptionsMenu(Menu menu) {
        menu.clear();
        menu.add(0, 0, 0, R.string.EmptyData);
        return true;
    }
    
    @Override
    public final boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
            case 0: {
                recordsBoard.clearMsg();
                break;
            }
            default:
                break;
        }
        return super.onOptionsItemSelected(item);
    }
}
