package com.senter.stdemo_sdk_hfb;

import android.content.Context;
import android.util.Log;
import android.widget.Toast;

/**
 * Created by Administrator on 2017/1/7 0007.
 */

public class HfUtil {



    /**
     * 16进制的字符串表示转成字节数组
     *
     * @param hexString 16进制格式的字符串
     * @return 转换后的字节数组
     **/
    public static byte[] hexStringToByteArray(String hexString) {
        if (hexString==null && hexString.trim().length()==0)
            throw new IllegalArgumentException("this hexString must not be empty");

        hexString = hexString.toLowerCase();
        final byte[] byteArray = new byte[hexString.length() / 2];
        int k = 0;
        for (int i = 0; i < byteArray.length; i++) {//因为是16进制，最多只会占用4位，转换成字节需要两个16进制的字符，高位在先
            byte high = (byte) (Character.digit(hexString.charAt(k), 16) & 0xff);
            byte low = (byte) (Character.digit(hexString.charAt(k + 1), 16) & 0xff);
            byteArray[i] = (byte) (high << 4 | low);
            k += 2;
        }
        return byteArray;
    }

    /**
     * 将指定byte数组以16进制的形式打印到控制台
     *            String
     * @param b
     *            byte[]
     * @return void
     */
    public static String byteArrayToHexString(byte[] b)
    {
        String msg="";
        if(b!=null) {
            for (int i = 0; i < b.length; i++) {
                String hex = Integer.toHexString(b[i] & 0xFF);
                if (hex.length() == 1) {
                    hex = '0' + hex;
                }
                msg = msg + hex.toUpperCase() + " ";

            }
        }
        return msg;

    }




    public static String formatString(Context context, String text){
        text=text.toUpperCase();
        text=text.replace(" ","");
        char[] array={'0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'};
        if(text!=null){
            if(text.length()>0){
                boolean istextHeFa=true;
                StringBuilder sbfilter=new StringBuilder();
                for(int i=0;i<text.length();i++){
                    char chartojiance=text.toCharArray()[i];
                    //检查是否在数组内
                    boolean find=false;
                    for(char a:array){

                        if(a==chartojiance){
                            find=true;
                            break;
                        }
                    }
                    if(!find){
                        //不合法
                        istextHeFa=false;
                        Toast.makeText(context,"有不合法的字符："+chartojiance,Toast.LENGTH_SHORT).show();
                    }else{//合法
                        sbfilter.append(chartojiance);
                    }

                }
                text=sbfilter.toString();
                if(istextHeFa){//text合法
                    Log.d("demo","合法的字符："+text);
                }else{

                }
            }
        }


        text=text.replace(" ","");
        StringBuilder sb=new StringBuilder();
        for(int j=0;j<text.length();j++){
            char c=text.toCharArray()[j];
            sb.append(c);
            if(j%2!=0){
                sb.append(" ");
            }
        }
        String resutlStr=sb.toString();
        resutlStr=resutlStr.trim();

        return resutlStr;
    }
}
