package com.senter.stdemo_sdk_hfb;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.os.Bundle;
import android.text.Editable;
import android.text.TextWatcher;
import android.util.Log;
import android.view.KeyEvent;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.SimpleAdapter;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;

import com.example.stdemo_sdk_hfb.R;
import com.senter.support.openapi.StHfB;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.concurrent.TimeoutException;

public class MainActivity extends Activity implements View.OnClickListener{

    private String TAG="StDemo_Sdk_HfB";
    private boolean isInit=false;
    private boolean hfInit=false;
    private boolean samInit1=false;
    private boolean samInit2=false;

    private PartialWakeLocker partialWakeLocker=new PartialWakeLocker(this,"HfB PartialWakeLocker");

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        setButonClickListner();
        //设置输入十六进制输入框事件
        EditText ed_sam_communication_apdu=(EditText) findViewById(R.id.ed_sam_communication_apdu);
        setEditTextEvent(ed_sam_communication_apdu);

        EditText et_radio_frequency_m1_authentication_key=(EditText) findViewById(R.id.et_radio_frequency_m1_authentication_key);
        setEditTextEvent(et_radio_frequency_m1_authentication_key);

        EditText et_radio_frequency_write_data=(EditText) findViewById(R.id.et_radio_frequency_write_data);
        setEditTextEvent(et_radio_frequency_write_data);

        EditText et_radio_frequency_m1_operate_operate_data=(EditText) findViewById(R.id.et_radio_frequency_m1_operate_operate_data);
        setEditTextEvent(et_radio_frequency_m1_operate_operate_data);

        EditText et_radio_frequency_cpu_communication_apdu=(EditText) findViewById(R.id.et_radio_frequency_cpu_communication_apdu);
        setEditTextEvent(et_radio_frequency_cpu_communication_apdu);
    
        StHfB.getInstance().startDebug(this);
    }

    /**
     * 设置输入十六进制输入框事件
     * @param editText
     */
    private void setEditTextEvent( final EditText editText) {
        editText.addTextChangedListener(new TextWatcher() {
            @Override
            public void beforeTextChanged(CharSequence charSequence, int i, int i1, int i2) {
            }

            @Override
            public void onTextChanged(CharSequence charSequence, int i, int i1, int i2) {
            }

            @Override
            public void afterTextChanged(Editable editable) {
                Log.d(TAG,"on text changed:"+editable.toString());
                editText.removeTextChangedListener(this);
                String fs=HfUtil.formatString(MainActivity.this.getApplication(),editable.toString());
                editText.setText(fs);
                editText.setSelection(fs.length());
                editText.addTextChangedListener(this);
            }
        });
    }


    /**
     * 按钮事件
     */
    private void setButonClickListner() {
        Button bt_init=(Button)findViewById(R.id.bt_init);
        bt_init.setOnClickListener(this);

        Button bt_uninit=(Button)findViewById(R.id.bt_uninit);
        bt_uninit.setOnClickListener(this);

        Button bt_sam_init=(Button)findViewById(R.id.bt_sam_init);
        bt_sam_init.setOnClickListener(this);

        Button bt_sam_communication=(Button)findViewById(R.id.bt_sam_communication);
        bt_sam_communication.setOnClickListener(this);

        Button bt_radio_frequency_init=(Button)findViewById(R.id.bt_radio_frequency_init);
        bt_radio_frequency_init.setOnClickListener(this);

        Button bt_radio_frequency_power_mode=(Button)findViewById(R.id.bt_radio_frequency_power_mode);
        bt_radio_frequency_power_mode.setOnClickListener(this);

        Button bt_radio_frequency_find_card=(Button)findViewById(R.id.bt_radio_frequency_find_card);
        bt_radio_frequency_find_card.setOnClickListener(this);

        Button bt_radio_frequency_cpu=(Button)findViewById(R.id.bt_radio_frequency_cpu);
        bt_radio_frequency_cpu.setOnClickListener(this);

        Button bt_radio_frequency_m1_authentication=(Button)findViewById(R.id.bt_radio_frequency_m1_authentication);
        bt_radio_frequency_m1_authentication.setOnClickListener(this);

        Button bt_radio_frequency_read=(Button)findViewById(R.id.bt_radio_frequency_read);
        bt_radio_frequency_read.setOnClickListener(this);

        Button bt_radio_frequency_ul_write=(Button)findViewById(R.id.bt_radio_frequency_ul_write);
        bt_radio_frequency_ul_write.setOnClickListener(this);

        Button bt_radio_frequency_m1_operate=(Button)findViewById(R.id.bt_radio_frequency_m1_operate);
        bt_radio_frequency_m1_operate.setOnClickListener(this);
        Spinner spinner=(Spinner)findViewById(R.id.radio_frequency_m1_operate_operate_spinner);
        SimpleAdapter simplead = new SimpleAdapter(this, getOpetraData(),
                R.layout.simple_item, new String[] { "title"}, new int[] {R.id.name,});
        spinner.setAdapter(simplead);

        Button bt_radio_frequency_cpu_communication=(Button)findViewById(R.id.bt_radio_frequency_cpu_communication);
        bt_radio_frequency_cpu_communication.setOnClickListener(this);
    }

    /**
     * 操作spinner数据
     * @return
     */
    private List<Map<String, Object>> getOpetraData() {
        List<Map<String, Object>> list = new ArrayList<Map<String, Object>>();
        Map<String, Object> map = new HashMap<String, Object>();
        map.put("title", "写卡");
        map.put("code", StHfB.OperateData.OPERATE_WRITE);
        list.add(map);
        map = new HashMap<String, Object>();
        map.put("title", "备份");
        map.put("code", StHfB.OperateData.OPERATE_BACKUP);
        list.add(map);
        map = new HashMap<String, Object>();
        map.put("title", "传输");
        map.put("code", StHfB.OperateData.OPERATE_SEND);
        list.add(map);
        map = new HashMap<String, Object>();
        map.put("title", "加值");
        map.put("code", StHfB.OperateData.OPERATE_ADD);
        list.add(map);
        map = new HashMap<String, Object>();
        map.put("title", "减值");
        map.put("code", StHfB.OperateData.OPERATE_SUBTRACTION);
        list.add(map);
        return list;
    }



    @Override
    public void onClick(View view) {
        switch (view.getId()){
            case R.id.bt_init:
               init();//初始化
            break;

            case R.id.bt_uninit:
                uninit();//去初始化
            break;

            case R.id.bt_sam_init:
                samInit();
                break;
            case R.id.bt_sam_communication:
                samCommunication();
                break;
            case R.id.bt_radio_frequency_init:
                radioFrequencyInit();
                break;
            case R.id.bt_radio_frequency_power_mode:
                radioFrequencyPowerMode();
                break;
            case R.id.bt_radio_frequency_find_card:
                radioFrequencyFindCard();
                break;
            case R.id.bt_radio_frequency_cpu:
                radioFrequencyCpu();
                break;
            case R.id.bt_radio_frequency_m1_authentication:
                radioFrequencyM1Authentication();
                break;
            case R.id.bt_radio_frequency_read:
                radioFrequencyRead();
                break;

            case R.id.bt_radio_frequency_ul_write:
                radioFrequencyUlWrite();
                break;
            case R.id.bt_radio_frequency_m1_operate:
                radioFrequencyM1Operate();
                break;

            case R.id.bt_radio_frequency_cpu_communication:
                radioFrequencyCpuCommunication();
                break;

            default:
                break;
        }

    }



    /**
     * 初始化
     */
    private void init() {
        //用来保证系统待机的情况下不断电。
        partialWakeLocker.wakeLockAcquire();
        Log.d(TAG,"获得电源锁");

        Log.d(TAG,"isInit:"+isInit);
        if(isInit){
            printText("已经初始化过了,不再初始化。");
            return;
        }
        boolean bInit=StHfB.getInstance().init();
        if(bInit) {
            printText("初始化成功");
            isInit=true;
        }else{
            printText("初始化失败");
        }
    }

    /**
     * 去初始化
     */
    private void uninit() {
        //去除电源锁
        partialWakeLocker.wakeLockRelease();
        Log.d(TAG,"去除电源锁");

        if(isInit) {
            StHfB.getInstance().uninit();
            isInit = false;
            hfInit = false;
            samInit1=false;
            samInit2=false;
            printText("去初始化");
        }else{
            printText("还没有初始化");
        }
    }


    /**
     * SAM卡初始化
     */
    private void samInit() {
        if(!isInit){
            printText("请先点顶部初始化按钮，进行初始化。");
            return;
        }

        if(((EditText)findViewById(R.id.ed_sam_init_cardSlot)).getText().toString()==null){
            printText("请填写卡槽号");
            return;
        }

        if(((EditText)findViewById(R.id.ed_sam_init_cardSlot)).getText().toString().trim().length()==0){
            printText("请填写卡槽号");
            return;
        }

        int cardSlot=Integer.valueOf (((EditText)findViewById(R.id.ed_sam_init_cardSlot)).getText().toString());
        if(cardSlot<1 || cardSlot>2){
            printText("只支持卡 1 卡 2");
            return;
        }

        if(cardSlot==1){
            if(samInit1){
                printText("SAM卡1已经初始化过了");
                return;
            }

        }else if(cardSlot==2){
            if(samInit2){
                printText("SAM卡2已经初始化过了");
                return;
            }

        }

        int baudRate=Integer.valueOf (((EditText)findViewById(R.id.ed_sam_init_baudRate)).getText().toString());
        int overtime=Integer.valueOf (((EditText)findViewById(R.id.ed_sam_init_overtime)).getText().toString());
        try {
            StHfB.SamInitResult result = StHfB.getInstance().samInit(cardSlot, baudRate, overtime);
            ((TextView)findViewById(R.id.tv_sam_init_replay_code)).setText("应答码："+ com.senter.stdemo_sdk_hfb.HfUtil.byteArrayToHexString(new byte[]{result.getReplyCode()}));
            ((TextView)findViewById(R.id.tv_sam_init_card_slot)).setText("卡槽号："+ result.getCardSlot());
            ((TextView)findViewById(R.id.tv_sam_init_card_state)).setText("卡状态："+ result.getCardState());

            if(result.getReplyCode()==0){
                printText("SAM初始化成功");
                if(cardSlot==1){
                    samInit1=true;
                }else if(cardSlot==2){
                    samInit2=true;
                }

            }else{
                printText("SAM初始化失败");
            }


        } catch (TimeoutException e) {
            e.printStackTrace();
            printText("初始化命令没有返回");
        }
    }



    /**
     * SAM卡统一通讯接口
     */
    private void samCommunication() {
        if(((EditText)findViewById(R.id.ed_sam_communication_cardSlot)).getText().toString()==null){
            printText("请填写卡槽号");
            return;
        }

        if(((EditText)findViewById(R.id.ed_sam_communication_cardSlot)).getText().toString().trim().length()==0){
            printText("请填写卡槽号");
            return;
        }

        int cardSlot=Integer.valueOf (((EditText)findViewById(R.id.ed_sam_communication_cardSlot)).getText().toString());

        if(cardSlot<1 || cardSlot>2){
            printText("只支持卡 1 卡 2");
            return;
        }

        if(cardSlot==1){
            if(!samInit1){
                printText("请先初始化SAM模块 卡1");
                return;
            }

        }else if(cardSlot==2){
            if(!samInit2){
                printText("请先初始化SAM模块 卡2");
                return;
            }
        }

        String apduStr= ((EditText)findViewById(R.id.ed_sam_communication_apdu)).getText().toString();
        apduStr=apduStr.replaceAll(" ","");
        Log.d(TAG,"apduStr:"+apduStr);
        byte[] apdu= com.senter.stdemo_sdk_hfb.HfUtil.hexStringToByteArray(apduStr);
        for(int i=0;i<apdu.length;i++){
            byte[] apduArray=new byte[]{apdu[i]};
            Log.d(TAG,"apdu["+i+"]"+ com.senter.stdemo_sdk_hfb.HfUtil.byteArrayToHexString(apduArray));
        }
        int  overtime=Integer.valueOf (((EditText)findViewById(R.id.ed_sam_communication_overtime)).getText().toString());
        try {
            StHfB.SamCommunicationResult result = StHfB.getInstance().samCommunication(cardSlot, apdu, overtime);
       
            ((TextView)findViewById(R.id.tv_sam_communication_replycode)).setText("应答码："+ com.senter.stdemo_sdk_hfb.HfUtil.byteArrayToHexString(new byte[]{result.getReplyCode()}));
            if(result.getReplyCode()==0){
                printText("SAM通信成功");
                ((TextView)findViewById(R.id.tv_sam_communication_result_apdu)).setText("Apdu："+ com.senter.stdemo_sdk_hfb.HfUtil.byteArrayToHexString(result.getApdu()));
            }else{
                printText("SAM通信失败");
            }

        } catch (TimeoutException e) {
            e.printStackTrace();
            printText("SAM通信命令没有返回");
        }
    }


    /**
     * 初始化射频芯片
     */
    private void radioFrequencyInit() {
        if(!isInit){
            printText("请先点顶部初始化按钮，进行初始化。");
            return;
        }
        if(hfInit){
            printText("射频模块已经初始化过了");
            return;
        }
        int type=Integer.valueOf (((EditText)findViewById(R.id.ed_radio_frequency_init_type)).getText().toString());
        int authenticationMode=Integer.valueOf (((EditText)findViewById(R.id.ed_radio_frequency_init_authentication)).getText().toString());
        int overtime=Integer.valueOf (((EditText)findViewById(R.id.ed_radio_frequency_init_overtime)).getText().toString());
        try {
            StHfB.getInstance().radioFrequencyInit(type, authenticationMode, overtime);
            printText("射频初始化成功");
            hfInit=true;
        } catch (TimeoutException e) {
            e.printStackTrace();
            printText("射频初始化命令返回超时");
        }
    }

    /**
     * 射频开关接口
     */
    private void radioFrequencyPowerMode() {
        if(!hfInit){
            printText("请先进行射频初始化");
            return;
        }
        int radioFrequencyOutput =Integer.valueOf (((EditText)findViewById(R.id.radio_frequency_power_mode_radioFrequencyoutput)).getText().toString());
        int lowPower =Integer.valueOf (((EditText)findViewById(R.id.radio_frequency_power_mode_lowpower)).getText().toString());
        try {
            StHfB.RadioFrequencyPowerModeResult result = StHfB.getInstance().radioFrequencyPowerMode(radioFrequencyOutput, lowPower);
            ((TextView)findViewById(R.id.bt_radio_frequency_power_mode_reply_code)).setText("应答码："+ com.senter.stdemo_sdk_hfb.HfUtil.byteArrayToHexString(new byte[]{result.getReplyCode()}));
            if(result.getReplyCode()==0) {
                printText("射频开关执行成功");
            }else{
                printText("射频开关执行失败");
            }
        } catch (TimeoutException e) {
            e.printStackTrace();
            printText("射频开关命令返回超时");

        }
    }

    /**
     * 射频寻卡
     */
    private void radioFrequencyFindCard() {
        if(!hfInit){
            printText("请先进行射频初始化");
            return;
        }

        int findTime=Integer.valueOf (((EditText)findViewById(R.id.ed_radio_frequency_find_card_time)).getText().toString());
        try {
            StHfB.RadioFrequencyFindCardResult result = StHfB.getInstance().radioFrequencyFindCard(findTime);
            ((TextView)findViewById(R.id.bt_radio_frequency_find_card_reply_code)).setText("应答码："+ com.senter.stdemo_sdk_hfb.HfUtil.byteArrayToHexString(new byte[]{result.getReplyCode()}));
            if(result.getReplyCode()==0) {
                printText("寻卡成功");
                ((TextView)findViewById(R.id.bt_radio_frequency_find_card_card_type)).setText("卡类型："+ com.senter.stdemo_sdk_hfb.HfUtil.byteArrayToHexString(result.getCardType()));
                ((TextView)findViewById(R.id.bt_radio_frequency_find_card_uid)).setText("卡UID："+ com.senter.stdemo_sdk_hfb.HfUtil.byteArrayToHexString(result.getUid()));
                ((TextView)findViewById(R.id.bt_radio_frequency_find_card_ask)).setText("ASK："+ com.senter.stdemo_sdk_hfb.HfUtil.byteArrayToHexString(new byte[]{result.getAsk()}));
            }else{
                printText("寻卡失败");
            }
        } catch (TimeoutException e) {
            e.printStackTrace();
            printText("寻卡命令返回失败");
        }

    }


    /**
     * 切换到CPU
     */
    private void radioFrequencyCpu() {
        if(!hfInit){
            printText("请先进行射频初始化");
            return;
        }

        try {
            StHfB.RadioFrequencyCpuResult result = StHfB.getInstance().radioFrequencyCpu();
            ((TextView)findViewById(R.id.tv_radio_frequency_cpu_reply_code)).setText("应答码："+ com.senter.stdemo_sdk_hfb.HfUtil.byteArrayToHexString(new byte[]{result.getReplyCode()}));
            if(result.getReplyCode()==0){
                printText("切换CPU成功");
            }else{
                printText("切换CPU失败");
            }

        } catch (TimeoutException e) {
            e.printStackTrace();
            printText("切换CPU命令没有返回");
        }
    }


    /**
     * M1密钥认证接口
     */
    private void radioFrequencyM1Authentication() {
        if(!hfInit){
            printText("请先进行射频初始化");
            return;
        }

        String hexStr=((EditText)findViewById(R.id.et_radio_frequency_m1_authentication_key)).getText().toString().replace(" ","");
        byte[] key= com.senter.stdemo_sdk_hfb.HfUtil.hexStringToByteArray(hexStr);
        if(key==null){
            printText("key不能为空。");
            return;
        }
        if(key!=null && key.length!=6){
            printText("key的长度为6，输入key的长度为："+key.length);
            return;
        }
        int keyType=Integer.valueOf (((EditText)findViewById(R.id.et_radio_frequency_m1_authentication_key_type)).getText().toString());
        int section=Integer.valueOf (((EditText)findViewById(R.id.et_radio_frequency_m1_authentication_section)).getText().toString());
        try {
            StHfB.RadioFrequencyM1AuthenticationResult result = StHfB.getInstance().radioFrequencyM1Authentication(key, keyType, section);

            ((TextView)findViewById(R.id.tv_radio_frequency_m1_authentication_reply_code)).setText("应答码："+ com.senter.stdemo_sdk_hfb.HfUtil.byteArrayToHexString(new byte[]{result.getReplyCode()}));
            if(result.getReplyCode()==0){
                printText("M1密钥认证成功");
            }else{
                printText("M1密钥认证失败");
            }


        } catch (TimeoutException e) {
            e.printStackTrace();
            printText("M1密钥认证接口命令没有返回");
        }
    }

    /**
     * UL/M1 读卡操作
     */
    private void radioFrequencyRead() {
        if(!hfInit){
            printText("请先进行射频初始化");
            return;
        }

        int block=Integer.valueOf (((EditText)findViewById(R.id.bt_radio_frequency_read_block)).getText().toString());
        int overtime=Integer.valueOf (((EditText)findViewById(R.id.bt_radio_frequency_read_overtime)).getText().toString());
        try {
            StHfB.RadioFrequencyReadResult result = StHfB.getInstance().radioFrequencyRead(block, overtime);

            ((TextView)findViewById(R.id.tv_radio_frequency_read_reply_code)).setText("应答码："+ com.senter.stdemo_sdk_hfb.HfUtil.byteArrayToHexString(new byte[]{result.getReplyCode()}));
            if(result.getReplyCode()==0){
                printText("读卡成功");
                ((TextView)findViewById(R.id.tv_radio_frequency_read_data)).setText("读到的数据："+ com.senter.stdemo_sdk_hfb.HfUtil.byteArrayToHexString(result.getSectionData()));

            }else{
                printText("读卡失败");
            }

           } catch (TimeoutException e) {
            e.printStackTrace();
            printText("射频读卡命令没有返回");
        }

    }


    /**
     * UL写卡操作
     */
    private void radioFrequencyUlWrite() {
        if(!hfInit){
            printText("请先进行射频初始化");
            return;
        }

        int blockIndex=Integer.valueOf (((EditText)findViewById(R.id.et_radio_frequency_write_blockIndex)).getText().toString());
        String hexStr=((EditText)findViewById(R.id.et_radio_frequency_write_data)).getText().toString().replace(" ","");
        byte[] data= com.senter.stdemo_sdk_hfb.HfUtil.hexStringToByteArray(hexStr);
        int overtime=Integer.valueOf (((EditText)findViewById(R.id.et_radio_frequency_write_overtime)).getText().toString());

        if(data==null){
            printText("数据不能为空，并且是4个字节。");
            return;
        }
        if(data.length!=4){
            printText("数据为4个字节，输入的数据为："+data.length+"个字节。");
            return;
        }

        try {
            StHfB.RadioFrequencyWriteResult result = StHfB.getInstance().radioFrequencyUlWrite(blockIndex, data, overtime);

            ((TextView)findViewById(R.id.tv_radio_frequency_write_reply_code)).setText("应答码："+ com.senter.stdemo_sdk_hfb.HfUtil.byteArrayToHexString(new byte[]{result.getReplyCode()}));
            if(result.getReplyCode()==0){
                printText("写卡成功");

            }else{
                printText("写卡失败");
            }


        } catch (TimeoutException e) {
            e.printStackTrace();
            printText("射频写卡命令没有返回");
        }
    }

    /**
     * M1卡其他通信接口
     */
    private void radioFrequencyM1Operate() {
        if(!hfInit){
            printText("请先进行射频初始化");
            return;
        }

        int operate=(Integer)((Map)((Spinner)findViewById(R.id.radio_frequency_m1_operate_operate_spinner)).getSelectedItem()).get("code");
        int blockIndex=Integer.valueOf (((EditText)findViewById(R.id.et_radio_frequency_m1_operate_block_index)).getText().toString());
        String hexStr=((EditText)findViewById(R.id.et_radio_frequency_m1_operate_operate_data)).getText().toString().replace(" ","");
        byte[] data=null;
        if(hexStr.length()>0) {
            data = com.senter.stdemo_sdk_hfb.HfUtil.hexStringToByteArray(hexStr);
        }else{

        }
        int overtime=Integer.valueOf (((EditText)findViewById(R.id.et_radio_frequency_m1_operate_operate_overtime)).getText().toString());


        //写
        if(operate== StHfB.OperateData.OPERATE_WRITE){
            if(data==null){
                printText("写操作数据不能为空");
                return;
            }
            if(data.length!=16){
                printText("写操作数据长度必须为16，当前为"+data.length);
                return;
            }
        }
        if(operate== StHfB.OperateData.OPERATE_BACKUP || operate== StHfB.OperateData.OPERATE_SEND){
            if(data!=null && data.length>0) {
                Log.d(TAG, "数据不是必须的");
            }
        }
        if(operate== StHfB.OperateData.OPERATE_ADD || operate== StHfB.OperateData.OPERATE_SUBTRACTION){
            if(data==null){
                printText("加或者减操作，数据不能为空。");
                return;
            }

            if( data.length!=4){
                printText("加或者减操作，数据长度为4个字节。");
                return;
            }
        }

        try {
            StHfB.RadioFrequencyOperateResult result = StHfB.getInstance().radioFrequencyM1Operate(operate, blockIndex, data, overtime);
            ((TextView)findViewById(R.id.tv_radio_frequency_m1_operate_reply_code)).setText("应答码："+ com.senter.stdemo_sdk_hfb.HfUtil.byteArrayToHexString(new byte[]{result.getReplyCode()}));
            if(result.getReplyCode()==0){
                printText("其他操作接口成功");
            }else{
                printText("其他操作接口失败");
            }
        } catch (TimeoutException e) {
            e.printStackTrace();
            printText("发送其他命令操作超时");
        }
    }

    /**
     * cpu 统一通讯接口
     */
    private void radioFrequencyCpuCommunication() {
        if(!hfInit){
            printText("请先进行射频初始化");
            return;
        }

        String hexStr=((EditText)findViewById(R.id.et_radio_frequency_cpu_communication_apdu)).getText().toString().replace(" ","");
        byte[] apdu=null;
        if(hexStr.length()>0) {
            apdu = com.senter.stdemo_sdk_hfb.HfUtil.hexStringToByteArray(hexStr);
        }else{

        }
        int overtime=Integer.valueOf (((EditText)findViewById(R.id.et_radio_frequency_cpu_communication_overtime)).getText().toString());
        if(apdu==null){
            printText("apdu 数据不能为空。");
            return;
        }
        try {
            StHfB.RadioFrequencyCpuCommunicationResult result = StHfB.getInstance().radioFrequencyCpuCommunication(apdu,overtime);
            ((TextView)findViewById(R.id.tv_radio_frequency_cpu_communicatio_reply_code)).setText("应答码："+ com.senter.stdemo_sdk_hfb.HfUtil.byteArrayToHexString(new byte[]{result.getReplyCode()}));
            if(result.getReplyCode()==0){
                printText("CPU统一通信成功");
                ((TextView)findViewById(R.id.tv_radio_frequency_cpu_communicatio_apdu)).setText("Apdu："+ com.senter.stdemo_sdk_hfb.HfUtil.byteArrayToHexString(result.getApdu()));

            }else{
                printText("CPU统一通信失败");
            }


        } catch (TimeoutException e) {
            e.printStackTrace();
            printText("cpu 统一通信接口命令返回超时");
        }
    }


    private void  printText(String msg){
        Log.d(TAG, msg);
        Toast.makeText(this.getApplicationContext(),msg,Toast.LENGTH_SHORT).show();
    }

    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        // TODO Auto-generated method stub
        if(keyCode == KeyEvent.KEYCODE_BACK && event.getRepeatCount()==0)
        {
            new AlertDialog.Builder(MainActivity.this)
                    .setTitle("退出")
                    .setMessage("您确认要退出吗？")
                    .setPositiveButton("确认", new DialogInterface.OnClickListener() {

                        @Override
                        public void onClick(DialogInterface dialog, int which) {

                            if(isInit){
                                uninit();
                            }
                            finish();
                        }
                    }).setNegativeButton("取消", new DialogInterface.OnClickListener() {

                @Override
                public void onClick(DialogInterface dialog, int which) {
                    // TODO Auto-generated method stub
                    dialog.dismiss();
                }
            }).show();
        }
        return super.onKeyDown(keyCode, event);
    }

}
