package com.senter.support.demo.rs485.until;

import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import com.senter.function.openapi.unstable.Rs485.Rs485BitRate;
import com.senter.function.openapi.unstable.Rs485.Rs485CharSize;
import com.senter.function.openapi.unstable.Rs485.Rs485Parity;
import com.senter.function.openapi.unstable.Rs485.Rs485StopBits;

/**
 * Created by Administrator on 2016/7/5.
 */
public class FileUtil {

	/**
	 * 获得波特率
	 * 
	 * @param key
	 * @return
	 */
	public static Rs485BitRate Rs485BitRateOf(String key) {
		if (key.equals("1200")) {
			return Rs485BitRate.B1200;

		} else if (key.equals("2400")) {
			return Rs485BitRate.B2400;

		}
		else if (key.equals("4800")) {
			return Rs485BitRate.B4800;

		} else if (key.equals("9600")) {
			return Rs485BitRate.B9600;

		} else if (key.equals("115200")) {
			return Rs485BitRate.B115200;

		} else {
			throw new IllegalArgumentException();
		}
	}

	/**
	 * 获得数据位
	 * 
	 * @param key
	 * @return
	 */
	public static Rs485CharSize Rs485CharSizeOf(String key) {
		if (key.equals("8")) {
			return Rs485CharSize.CSize8;

		} else if (key.equals("7")) {
			return Rs485CharSize.CSize7;

		} else if (key.equals("6")) {
			return Rs485CharSize.CSize6;

		} else if (key.equals("5")) {
			return Rs485CharSize.CSize5;

		} else {
			throw new IllegalArgumentException();
		}
	}

	/**
	 * 获得校验位
	 * 
	 * @param key
	 * @return
	 */
	public static Rs485Parity Rs485ParityOf(String key) {
		if (key.equals("Event")) {
			return Rs485Parity.Event;

		} else if (key.equals("Mark")) {
			return Rs485Parity.Mark;

		} else if (key.equals("Non")) {
			return Rs485Parity.Non;

		} else if (key.equals("Odd")) {
			return Rs485Parity.Odd;

		} else if (key.equals("Space")) {
			return Rs485Parity.Space;

		} else {
			throw new IllegalArgumentException();
		}
	}

	/**
	 * 获得停止位
	 * 
	 * @param key
	 * @return
	 */
	public static Rs485StopBits Rs485StopBitsOf(String key) {
		if (key.equals("1")) {
			return Rs485StopBits.StopBits1;
		} else if (key.equals("2")) {
			return Rs485StopBits.StopBits2;
		} else {
			throw new IllegalArgumentException();
		}
	}

	/**
	 * 16进制的字符串表示转成字节数组
	 *
	 * @param hexString
	 *            16进制格式的字符串
	 * @return 转换后的字节数组
	 **/
	public static byte[] toByteArray(String hexString) throws UnsupportedEncodingException {
		if (hexString==null) {
			throw new UnsupportedEncodingException();
		}
		if (hexString.length()==0) {
			return new byte[0];
		}
		String[] ss=hexString.split("\\s");
		
		ArrayList<Byte> rawRet=new ArrayList<Byte>();
		for (int i = 0; i < ss.length; i++) {
			String ele=ss[i];
			if (ele.length()!=2) {
				ele+="0";
			}
			try {
				rawRet.add(Integer.valueOf(ele, 16).byteValue());
			} catch (Exception e) {
				throw new UnsupportedEncodingException();
			}
		}
		Byte[] bs= rawRet.toArray(new Byte[0]);
		byte[] ret=new byte[bs.length];
		for (int i = 0; i < ret.length; i++) {
			ret[i]=bs[i];
		}
		return ret;
	}

	/**
	 * 用十六进制（基数 16）参数表示的无符号整数值的字符串表示形式。
	 * 
	 * @param s
	 * @return
	 */
	public static String toHexString(byte[] bytes) {
		StringBuilder sb = new StringBuilder();
		for (int i = 0; i < bytes.length; i++) {
			sb.append(String.format("%02X", bytes[i]));
			sb.append(" ");
		}
		return sb.toString().trim();
	}
}
