package com.senter.support.openapi.demo.fingerprint;

import com.senter.demo.common.misc.ActivityHelper;
import com.senter.function.openapi.unstable.FingerprintA;
import com.senter.function.openapi.unstable.FingerprintA.FingerprintGraph;
import com.senter.function.openapi.unstable.FingerprintA.UserInfo;
import com.senter.function.openapi.unstable.FingerprintA.UserInfoAndFingerprintTemplateId;
import com.senter.support.openapi.demo.fingerprint.R;

import android.os.Bundle;
import android.os.Vibrator;
import android.app.Activity;
import android.content.Context;
import android.graphics.Bitmap;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.TextView;

public class MainActivity extends Activity implements View.OnClickListener
{
	private static final String TAG="Uart";
	private Button			but_enroll;
	private Button			but_verity;
	private Button			but_count;
	private Button			but_empty;
	private Button			but_on;
	private Button			but_off;

	private TextView		textView1;
	private EditText		edit1;
	private ImageView		iv;

	private FingerprintA	fp	= FingerprintA.getInstance();
	private ActivityHelper<MainActivity> activityHelper=new ActivityHelper<MainActivity>(this);

	Vibrator vibrator;
	@Override
	protected void onCreate(Bundle savedInstanceState)
	{
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		but_on = (Button) findViewById(R.id.button6);
		but_on.setOnClickListener(this);
		
		but_enroll = (Button) findViewById(R.id.idMainActivity_btn_enroll);
		but_enroll.setOnClickListener(this);
		but_verity = (Button) findViewById(R.id.idMainActivity_btn_verify);
		but_verity.setOnClickListener(this);
		but_count = (Button) findViewById(R.id.idMainActivity_btn_clearLibrary);
		but_count.setOnClickListener(this);
		but_empty = (Button) findViewById(R.id.idMainActivity_btn_totalNumber);
		but_empty.setOnClickListener(this);
		but_off = (Button) findViewById(R.id.button7);
		but_off.setOnClickListener(this);

		iv = (ImageView) findViewById(R.id.imageView1);
		textView1 = (TextView) findViewById(R.id.idMainActivity_tvTips);
		edit1 = (EditText) findViewById(R.id.idMainActivity_etUserInfo);
		
		setButtonsAsRunning(false);
		
		vibrator = (Vibrator)getSystemService(Context.VIBRATOR_SERVICE);
	}
	
	void setButtonsAsRunning(boolean running)
	{
		but_on.setEnabled(!running);
		
		Button[] workingButton=new Button[]{but_off,but_enroll,but_verity,but_count,but_empty};
		for (int i = 0; i < workingButton.length; i++)
		{
			workingButton[i].setEnabled(running);
		}
	}
	
	private void viborate()
	{
		if (vibrator.hasVibrator())
		{
			vibrator.vibrate(200);
		}
	}
	
	private void showGraph(FingerprintGraph imgdata)
	{
		if (imgdata != null)
		{

			Bitmap bitmapTmp = CreateBitmap(imgdata);
			if (bitmapTmp != null)
			{
				iv.setMaxHeight(1320 * 2);
				iv.setMaxWidth(1000 * 2);
				iv.setAdjustViewBounds(true);
				iv.setImageBitmap(bitmapTmp);
				iv.invalidate();
				iv.setVisibility(View.VISIBLE);
			}else {
				iv.setVisibility(View.INVISIBLE);
			}
		}else {
			iv.setVisibility(View.INVISIBLE);
		}
	}
	
	public void onClick(View v)
	{
		try
		{
			Boolean booleanTmp;
			switch (v.getId())
			{
				case R.id.idMainActivity_btn_enroll:
					
					byte[] userInfoByBytes=edit1.getText().toString().getBytes();
					if (userInfoByBytes.length < 1)
					{
						activityHelper.showToastShort(R.string.idMainActivity_Enroll_toastPleaseInputUserInfo);
						return;
					}
					if (userInfoByBytes.length>64)
					{
						activityHelper.showToastShort(R.string.idMainActivity_Enroll_toastUserInfoTooLong);
						return;
					}
					UserInfo userInfo=UserInfo.newInstanceWith(userInfoByBytes);
					
					for (int i = 0; i < 3; i++)
					{
						Log.e(TAG, "第"+i+"次指纹采集");
						textView1.setText(String.format(getString(R.string.idMainActivity_Enroll_CollectXTimes_Formmator), (i + 1)));
						textView1.invalidate();
						
						Boolean bolean = fp.collectTemporaryFingerprintGraph();
						Log.e(TAG, "collectTemporaryFingerprintGraph "+bolean);
						
						if (bolean != null && bolean == true)
						{
							if (i==0)
							{
								bolean = fp.convertTemporaryFingerprintGraphToTemporaryTemplate();
							}else {
								if (i==2)
								{
									FingerprintGraph imgdata = fp.getTemporaryFingerprintGraph();
									showGraph(imgdata);
								}
								bolean = fp.tryUpdateTemporaryFingerprintTemplateByNewTemporaryFingerprintGraph();
							}

							if (bolean == null || bolean == false)
							{
								textView1.setText(R.string.idMainActivity_Enroll_UploadFingerprintGraphFailed);
								return;
							}
						} else
						{
							textView1.setText(R.string.idMainActivity_Enroll_CollectTemplateFailed);
							return;
						}
						
					}
					
					Integer templateId=fp.enrollTemporaryFingerprintTemplateIntoTemplateLibrary(userInfo);

					if (templateId ==null)
					{
						textView1.setText(R.string.idMainActivity_Enroll_Failed);
						return;
					}
					
					textView1.setText(String.format(getString(R.string.idMainActivity_Enroll_OkIdX_Formmator), templateId));
					break;
				case R.id.idMainActivity_btn_verify:
					textView1.setText(R.string.idMainActivity_Verify_ing);
					textView1.invalidate();
					Boolean bolean=fp.collectTemporaryFingerprintGraph();
					if (bolean!=null&&bolean==true)
					{
						FingerprintGraph fg=fp.getTemporaryFingerprintGraph();
						showGraph(fg);
					} else
					{
						activityHelper.showToastLong(R.string.idMainActivity_Verify_GetFingerpintFailed);
						textView1.setText(R.string.idMainActivity_Verify_GetFingerpintFailed);
						return;
					}
					
					UserInfoAndFingerprintTemplateId userIfAndTemplateId=fp.verifyFingerOnSensorWithTemplatesInLibrary();
					if (userIfAndTemplateId != null)
					{
						textView1.setText(String.format(getString(R.string.idMainActivity_Verify_OkSsIdDd)
								, new String(userIfAndTemplateId.userInfo().getBytes())
								,userIfAndTemplateId.templateId()));
					} else
					{
						textView1.setText(R.string.idMainActivity_Verify_Failed);
					}
					break;
				case R.id.idMainActivity_btn_totalNumber:
					Integer totalNumber=fp.getTotalNumberOfFingerprintTemplatesInTemplateLibrary();
					if (totalNumber!=null)
						textView1.setText(String.format(getString(R.string.idMainActivity_GetTotalNumber_Ok_Formattor), totalNumber));
					else
						textView1.setText(R.string.idMainActivity_GetTotalNumber_Failed);
					break;
				case R.id.idMainActivity_btn_clearLibrary:
					booleanTmp=fp.clearFingerprintTemplateLibrary();
					
					if (booleanTmp!=null&&booleanTmp==true)
						textView1.setText(R.string.idMainActivity_ClearLibrary_ClearTemplateLibrarySuccessfully);
					else
						textView1.setText(R.string.idMainActivity_ClearLibrary_ClearTemplateLibraryFailed);
					break;
				case R.id.button6:
					fp.init();
					setButtonsAsRunning(true);
					break;
				case R.id.button7:
					fp.uninit();
					setButtonsAsRunning(false);
					break;
			}
		}
		finally
		{
			viborate();
		}
	}

	private static Bitmap CreateBitmap(	FingerprintGraph fg)
	{
		return Bitmap.createBitmap(fg.getAsColorsByInts(), fg.getWidth(), fg.getHeight(), Bitmap.Config.ARGB_8888);
	}

	@Override
	protected void onDestroy()
	{
		fp.uninit();
		setButtonsAsRunning(false);
		super.onDestroy();
	}
}
