package com.senter.support.openapi.demo.keymanager;

import android.app.Activity;
import android.os.Bundle;
import android.os.Handler;
import android.os.HandlerThread;
import android.view.View;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.CompoundButton.OnCheckedChangeListener;
import android.widget.Toast;

import com.senter.demo.common.misc.ActivityHelper;
import com.senter.support.openapi.StKeyManager;
import com.senter.support.openapi.StKeyManager.ShortcutKey;
import com.senter.support.openapi.demo.keymanager.R;

public class MainActivity extends Activity {
	
	Handler handler;
	private Views views;
	private final ActivityHelper<MainActivity> at=new ActivityHelper<>(this);

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		views=new Views();
		
		HandlerThread handlerThread=new HandlerThread("");
		handlerThread.start();
		handler=new Handler(handlerThread.getLooper());

		boolean isScanAvailable=StKeyManager.ShortcutKeyMonitor.isShortcutKeyAvailable(ShortcutKey.Scan);
		boolean isF1Available=StKeyManager.ShortcutKeyMonitor.isShortcutKeyAvailable(ShortcutKey.F1);
		boolean isF2Available=StKeyManager.ShortcutKeyMonitor.isShortcutKeyAvailable(ShortcutKey.F2);

		if (isScanAvailable==false) views.cbScan.setVisibility(View.INVISIBLE);
		if (isF1Available==false) views.cbF1.setVisibility(View.INVISIBLE);
		if (isF2Available==false) views.cbF2.setVisibility(View.INVISIBLE);

		if (isScanAvailable==false&&
				isF1Available==false&&
				isF2Available==false){
			Toast.makeText(this,"Current product does not support shortcut key monitor function",Toast.LENGTH_LONG).show();
			finish();
		}

	}
	
	
	protected void onUiCbScan(boolean isChecked){
		if (isChecked) {
			scanKeyMonitor.reset(this, scanKeyListener, handler);
			scanKeyMonitor.startMonitor();
		}else {
			scanKeyMonitor.stopMonitor();
		}
	}

	protected void onUiCbF1(boolean isChecked){
		if (isChecked) {
			f1KeyMonitor.reset(this, f1KeyListener, handler);
			f1KeyMonitor.startMonitor();
		}else {
			f1KeyMonitor.stopMonitor();
		}
	}
	protected void onUiCbF2(boolean isChecked){
		if (isChecked) {
			f2KeyMonitor.reset(this, f2KeyListener, handler);
			f2KeyMonitor.startMonitor();
		}else {
			f2KeyMonitor.stopMonitor();
		}
	}

	@Override
	protected void onPause() {
		super.onPause();

		if (views.cbScan.isChecked()) views.cbScan.setChecked(false);
		if (views.cbF1.isChecked())   views.cbF1.setChecked(false);
		if (views.cbF2.isChecked())   views.cbF2.setChecked(false);

		if (scanKeyMonitor!=null&&scanKeyMonitor.isMonitoring()) scanKeyMonitor.stopMonitor();
		if (f1KeyMonitor!=null&&f1KeyMonitor.isMonitoring())   f1KeyMonitor.stopMonitor();
		if (f2KeyMonitor!=null&&f2KeyMonitor.isMonitoring())   f2KeyMonitor.stopMonitor();

	}
	StKeyManager.ShortcutKeyMonitor  scanKeyMonitor=StKeyManager.ShortcutKeyMonitor.isShortcutKeyAvailable(ShortcutKey.Scan) ?
														StKeyManager.getInstanceOfShortcutKeyMonitor(ShortcutKey.Scan):null;
	StKeyManager.ShortcutKeyMonitor  f1KeyMonitor=StKeyManager.ShortcutKeyMonitor.isShortcutKeyAvailable(ShortcutKey.F1) ?
														StKeyManager.getInstanceOfShortcutKeyMonitor(ShortcutKey.F1):null;
	StKeyManager.ShortcutKeyMonitor  f2KeyMonitor=StKeyManager.ShortcutKeyMonitor.isShortcutKeyAvailable(ShortcutKey.F2) ?
														StKeyManager.getInstanceOfShortcutKeyMonitor(ShortcutKey.F2):null;
	
	StKeyManager.ShortcutKeyMonitor.ShortcutKeyListener scanKeyListener=new StKeyManager.ShortcutKeyMonitor.ShortcutKeyListener(){
		@Override
		public void onKeyDown(int keycode, int repeatCount, StKeyManager.ShortcutKeyMonitor.ShortcutKeyEvent event) {
			at.showToastShort("Scan:Down repeatCount:"+repeatCount);
		}

		@Override
		public void onKeyUp(int keycode, int repeatCount, StKeyManager.ShortcutKeyMonitor.ShortcutKeyEvent event) {
			at.showToastShort("Scan:Up repeatCount:"+repeatCount);
		}

	};

	StKeyManager.ShortcutKeyMonitor.ShortcutKeyListener f1KeyListener=new StKeyManager.ShortcutKeyMonitor.ShortcutKeyListener(){
		@Override
		public void onKeyDown(int keycode, int repeatCount, StKeyManager.ShortcutKeyMonitor.ShortcutKeyEvent event) {
			at.showToastShort("F1:Down repeatCount:"+repeatCount);
		}

		@Override
		public void onKeyUp(int keycode, int repeatCount, StKeyManager.ShortcutKeyMonitor.ShortcutKeyEvent event) {
			at.showToastShort("F1:Up repeatCount:"+repeatCount);
		}

	};

	StKeyManager.ShortcutKeyMonitor.ShortcutKeyListener f2KeyListener=new StKeyManager.ShortcutKeyMonitor.ShortcutKeyListener(){

		@Override
		public void onKeyDown(int keycode, int repeatCount, StKeyManager.ShortcutKeyMonitor.ShortcutKeyEvent event) {
			at.showToastShort("F2:Down repeatCount:"+repeatCount);
		}

		@Override
		public void onKeyUp(int keycode, int repeatCount, StKeyManager.ShortcutKeyMonitor.ShortcutKeyEvent event) {
			at.showToastShort("F2:Up repeatCount:"+repeatCount);
		}

	};

	
	private class Views{
		CheckBox cbScan=(CheckBox) findViewById(R.id.idCbKeyScan);
		CheckBox cbF1=(CheckBox) findViewById(R.id.idCbKeyF1);
		CheckBox cbF2=(CheckBox) findViewById(R.id.idCbKeyF2);
		
		{
			cbScan.setOnCheckedChangeListener(new OnCheckedChangeListener() {
				@Override
				public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
					onUiCbScan(isChecked);
				}
			});

			cbF1.setOnCheckedChangeListener(new OnCheckedChangeListener() {
				@Override
				public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
					onUiCbF1(isChecked);
				}
			});

			cbF2.setOnCheckedChangeListener(new OnCheckedChangeListener() {
				@Override
				public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
					onUiCbF2(isChecked);
				}
			});
		}
	}
	
	
	
}













