package com.senter.support.openapi.demo.lf;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;

import com.senter.function.openapi.unstable.StLf;
import com.senter.function.openapi.unstable.StLf.TransceiverModel;
import com.senter.support.openapi.demo.lf.model.ActivityModelA;
import com.senter.support.openapi.demo.lf.model.ActivityModelB;
import com.senter.support.openapi.demo.lf.model.ActivityModelB2;
import com.senter.support.openapi.demo.lf.model.ActivityModelC;
import com.senter.support.openapi.demo.lf.model.ActivityModelD;

import java.util.Set;

public class ActivityMain extends Activity
{
	Button modelA;
	Button modelB;
	Button modelB2;
	Button modelC;
	Button modelD;
	
	@Override
	protected void onCreate(Bundle savedInstanceState)
	{
		super.onCreate(savedInstanceState);
		
		setContentView(R.layout.activity0_model_select);
        
		modelA=(Button) findViewById(R.id.idMainActivity_Model_btnA);
		modelA.setOnClickListener(new View.OnClickListener()
		{
			@Override
			public void onClick(View v)
			{
                onUiBtnModelX(TransceiverModel.TransceiverModelA);
			}
		});

		modelB=(Button) findViewById(R.id.idMainActivity_Model_btnB);
		modelB.setOnClickListener(new View.OnClickListener()
		{
			@Override
			public void onClick(View v)
			{
                onUiBtnModelX(TransceiverModel.TransceiverModelB);
			}
		});
		
		modelB2=(Button) findViewById(R.id.idMainActivity_Model_btnB2);
		modelB2.setOnClickListener(new View.OnClickListener()
		{
			@Override
			public void onClick(View v)
			{
                onUiBtnModelX(TransceiverModel.TransceiverModelB2);
			}
		});

		modelC=(Button) findViewById(R.id.idMainActivity_Model_btnC);
		modelC.setOnClickListener(new View.OnClickListener()
		{
			@Override
			public void onClick(View v)
			{
                onUiBtnModelX(TransceiverModel.TransceiverModelC);
			}
		});

		modelD=(Button) findViewById(R.id.idMainActivity_Model_btnD);
		modelD.setOnClickListener(new View.OnClickListener()
		{
			@Override
			public void onClick(View v)
			{
                onUiBtnModelX(TransceiverModel.TransceiverModelD);
			}
		});
	}
	
	void onUiBtnModelX(final TransceiverModel transceiverModel){
        
        if(App.currentTransceiverModel==null){
            
            AlertDialog.Builder builder=new AlertDialog.Builder(ActivityMain.this);
            builder.setTitle(getString(R.string.point_out));
            builder.setMessage(getString(R.string.point_message));
            builder.setPositiveButton(getString(R.string.confirm), new DialogInterface.OnClickListener() {
                public void onClick(DialogInterface dialog, int which) {
                    App.currentTransceiverModel =transceiverModel;
                    startActivity(transceiverModel);
                }
            });
            builder.setNeutralButton(getString(R.string.cancel),new DialogInterface.OnClickListener() {
                public void onClick(DialogInterface dialog, int which) {
                    dialog.dismiss();
                }
            });
            
            builder.create().show();
        }else{
            startActivity(transceiverModel);
        }
    }
    void startActivity(TransceiverModel transceiverModel){
        startActivity(new Intent(ActivityMain.this, activityOf(transceiverModel)).addFlags(Intent.FLAG_ACTIVITY_NEW_TASK));
    }
    
    Class<? extends Activity> activityOf(TransceiverModel transceiverModel){
        switch (transceiverModel){
            case TransceiverModelA:  return ActivityModelA.class;
            case TransceiverModelB:  return ActivityModelB.class;
            case TransceiverModelB2: return ActivityModelB2.class;
            case TransceiverModelC:  return ActivityModelC.class;
            case TransceiverModelD:  return ActivityModelD.class;
            default:throw new IllegalArgumentException();
        }
    }
	
	
	
	@Override
	protected void onResume()
	{
        modelA.setEnabled(false);
        modelB.setEnabled(false);
        modelB2.setEnabled(false);
        modelC.setEnabled(false);
        modelD.setEnabled(false);
        
        if (App.currentTransceiverModel==null){
            Set<TransceiverModel> models=StLf.getOptionalTransceiverModel();
            for (TransceiverModel transceiverModel:models){
                switch (transceiverModel){
                    case TransceiverModelA:{  modelA.setEnabled(true);  break;}
                    case TransceiverModelB:{  modelB.setEnabled(true);  break;}
                    case TransceiverModelB2:{ modelB2.setEnabled(true); break;}
                    case TransceiverModelC:{  modelC.setEnabled(true);  break;}
                    case TransceiverModelD:{  modelD.setEnabled(true);  break;}
                }
            }
        }else{
            switch (App.currentTransceiverModel)
            {
                case TransceiverModelA:
                    modelA.setEnabled(true);
                    break;
                case TransceiverModelB:
                    modelB.setEnabled(true);
                    break;
                case TransceiverModelB2:
                    modelB2.setEnabled(true);
                    break;
                case TransceiverModelC:
                    modelC.setEnabled(true);
                    break;
                case TransceiverModelD:
                    modelD.setEnabled(true);
                    break;
                default:
                    throw new IllegalStateException();
            }
        }
        
		super.onResume();
	}
}
