package com.senter.support.openapi.demo.lf.model;

import android.app.Activity;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

import com.senter.demo.common.misc.ActivityHelper;
import com.senter.function.openapi.unstable.StLf;
import com.senter.function.openapi.unstable.StLf.TransceiverModel;
import com.senter.function.openapi.unstable.StLf.TransceiverModelA;
import com.senter.function.openapi.unstable.StLf.TransceiverModelA.TagInfo;
import com.senter.function.openapi.unstable.StLf.TransceiverModelA.TagInfoListener;
import com.senter.support.openapi.demo.lf.R;

public class ActivityModelA extends Activity
{
	Views views;
	private final com.senter.demo.common.misc.Accompaniment rfidaccompaniment = com.senter.demo.common.misc.Accompaniment.newInstanceOfResource(ActivityModelA.this, R.raw.tag_inventoried);
	StLf.TransceiverModelA modelA=StLf.getInstanceAs(TransceiverModel.TransceiverModelA).getTransceiverAs(TransceiverModelA.class);
	StringBuilder sb=new StringBuilder();
	private final ActivityHelper<ActivityModelA> at=new ActivityHelper<ActivityModelA>(this);
	
	@Override
	protected void onCreate(Bundle savedInstanceState)
	{
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity1_a);
		setTitle("Low Frequency Moddel A 134.2KHZ Demo");
		views=new Views();
	}
	
	@Override
	protected void onStop()
	{
		super.onStop();
		onUiBtnUninit();
	}
	
	protected void onUiBtnInit()
	{
		boolean initResult=modelA.init();
		if (initResult==false) {
			at.showToastShort("Cannot initialize the function,please check if some one function conflicting with LF is running");
			return;
		}
		modelA.setTagListener(new TagInfoListener()
		{
			@Override
			public void onNewTag(final TagInfo uid)
			{
				runOnUiThread(new Runnable()
				{
					@Override
					public void run()
					{
						rfidaccompaniment.start();
						sb.append(" tag type:"+uid.type().toString()
								+" country code:"+uid.countryCode()
								+" uid:"+uid.uid()
								+"\r\n");
						views.tvUid.setText(sb.toString());
					}
				});
			}
		});
		views.setRunning(true);
	}
	
	protected void onUiBtnUninit()
	{
		modelA.uninit();
		views.setRunning(false);
	}
	
	protected void onUiBtnRepeatReply()
	{
		modelA.repeatReply();
	}
	protected void onUiBtnResearch()
	{
		modelA.research();
	}
	
	
	
	private class Views{

		TextView tvUid=(TextView) findViewById(R.id.idActivityModelA_tvUid);
		Button btnInit=(Button) findViewById(R.id.idActivityModelA_btnInit);
		Button btnUninit=(Button) findViewById(R.id.idActivityModelA_btnUninit);
		Button btnRepeatReply=(Button) findViewById(R.id.idActivityModelA_btnRepeatReply);
		Button btnResearch=(Button) findViewById(R.id.idActivityModelA_btnResearch);
		
		{

			btnInit.setOnClickListener(new View.OnClickListener()
			{
				@Override
				public void onClick(View v)
				{
					onUiBtnInit();
				}
			});
			btnUninit.setOnClickListener(new View.OnClickListener()
			{
				@Override
				public void onClick(View v)
				{
					onUiBtnUninit();
				}
			});
			btnRepeatReply.setOnClickListener(new View.OnClickListener()
			{
				@Override
				public void onClick(View v)
				{
					onUiBtnRepeatReply();
				}
			});
			btnResearch.setOnClickListener(new View.OnClickListener()
			{
				@Override
				public void onClick(View v)
				{
					onUiBtnResearch();
				}
			});
			setRunning(false);
		}
		
		public void setRunning(boolean running)
		{
			btnInit.setEnabled(!running);
			btnRepeatReply.setEnabled(running);
			btnResearch.setEnabled(running);
			btnUninit.setEnabled(running);
		}
	}
}
