package com.senter.support.openapi.demo.lf.model;

import com.senter.demo.common.misc.ActivityHelper;
import com.senter.function.openapi.unstable.StLf;
import com.senter.function.openapi.unstable.StLf.TransceiverModel;
import com.senter.support.openapi.demo.lf.R;

import android.app.Activity;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

public class ActivityModelB extends Activity
{
	Views views;
	StLf.TransceiverModelB modelB=StLf.getInstanceAs(TransceiverModel.TransceiverModelB).getTransceiverAs(StLf.TransceiverModelB.class);
	StringBuilder sb=new StringBuilder();
	private final ActivityHelper<ActivityModelB> at=new ActivityHelper<ActivityModelB>(this);
	
	@Override
	protected void onCreate(Bundle savedInstanceState)
	{
		super.onCreate(savedInstanceState);
		setTitle("Low Frequency Moddel B 134.2KHZ Demo");
		setContentView(R.layout.activity2_b);
		views=new Views();
	}

	@Override
	protected void onStop()
	{
		super.onStop();
		onUiBtnUninit();
	}
	
	protected void onUiBtnInit()
	{
		boolean initResult=modelB.init();
		if (initResult==false) {
			at.showToastShort("Cannot initialize the function,please check if some one function conflicting with LF is running");
			return;
		}
		modelB.setTagListener(new StLf.TransceiverModelB.TagInfoListener()
		{
			@Override
			public void onNewTag(final StLf.TransceiverModelB.TagInfo ti)
			{
				runOnUiThread(new Runnable()
				{
					@Override
					public void run()
					{
						sb.append(" country code:"+ti.countryCode()
								+" uid:"+ti.uid()
								+"\r\n");
						views.tvUid.setText(sb.toString());
					}
				});
			}
		});
		views.setRunning(true);
	}
	

	protected void onUiBtnUninit()
	{
		modelB.uninit();
		views.setRunning(false);
	}
	
	protected void stopInventory()
	{
		modelB.stopInventory();
	}
	protected void trigInventoryOnce()
	{
		modelB.trigInventoryOnce();
	}
	
	private class Views
	{
		TextView tvUid=(TextView) findViewById(R.id.idActivityModelB_tvUid);
		Button btnInit=(Button) findViewById(R.id.idActivityModelB_btnInit);
		Button btnUninit=(Button) findViewById(R.id.idActivityModelB_btnUninit);
		Button btnStopInventory=(Button) findViewById(R.id.idActivityModelB_btnStopInventory);
		Button btnTrigInventoryOnce=(Button) findViewById(R.id.idActivityModelB_btnTrigInventoryOnce);
		
		{
			btnInit.setOnClickListener(new View.OnClickListener()
			{
				@Override
				public void onClick(View v)
				{
					onUiBtnInit();
				}
			});
			btnUninit.setOnClickListener(new View.OnClickListener()
			{
				@Override
				public void onClick(View v)
				{
					onUiBtnUninit();
				}
			});
			btnStopInventory.setOnClickListener(new View.OnClickListener()
			{
				@Override
				public void onClick(View v)
				{
					stopInventory();
				}
			});
			btnTrigInventoryOnce.setOnClickListener(new View.OnClickListener()
			{
				@Override
				public void onClick(View v)
				{
					trigInventoryOnce();
				}
			});
			setRunning(false);
		}
		
		public void setRunning(boolean running)
		{
			btnInit.setEnabled(!running);
			btnStopInventory.setEnabled(running);
			btnTrigInventoryOnce.setEnabled(running);
			btnUninit.setEnabled(running);
		}
	}
}
