package com.senter.support.openapi.demo.lf.model;

import com.senter.demo.common.misc.ActivityHelper;
import com.senter.function.openapi.unstable.StLf;
import com.senter.function.openapi.unstable.StLf.TransceiverModel;
import com.senter.function.openapi.unstable.StLf.TransceiverModelC;
import com.senter.function.openapi.unstable.StLf.TransceiverModelC.TagInfo;
import com.senter.function.openapi.unstable.StLf.TransceiverModelC.TagInfoListener;
import com.senter.support.openapi.demo.lf.R;

import android.app.Activity;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

public class ActivityModelC extends Activity
{
	Views views;
	StLf.TransceiverModelC modelC=StLf.getInstanceAs(TransceiverModel.TransceiverModelC).getTransceiverAs(TransceiverModelC.class);
	StringBuilder sb=new StringBuilder();
	private final ActivityHelper<ActivityModelC> at=new ActivityHelper<ActivityModelC>(this);
	
	@Override
	protected void onCreate(Bundle savedInstanceState)
	{
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity3_c);
		setTitle("Low Frequency Moddel C 125KHZ Demo");
		views=new Views();
	}
	
	@Override
	protected void onStop()
	{
		super.onStop();
		onUiBtnUninit();
	}
	
	
	protected void onUiBtnStart()
	{
		boolean initResult=modelC.init();
		if (initResult==false) {
			at.showToastShort("Cannot initialize the function,please check if some one function conflicting with LF is running");
			return;
		}
		modelC.setTagListener(new TagInfoListener()
		{
			@Override
			public void onNewTag(final TagInfo ti)
			{
				runOnUiThread(new Runnable()
				{
					@Override
					public void run()
					{
						sb.append(" uid:"+ti.uid()
								+"\r\n");
						views.tvUid.setText(sb.toString());
					}
				});
			}
		});
		views.setRunning(true);
	}
	

	protected void onUiBtnUninit()
	{
		modelC.uninit();
		views.setRunning(false);
	}
	
	protected void onUiBtnStartInventory()
	{
		modelC.startInventory();
	}
	protected void onUiBtnStopInventory()
	{
		modelC.stopInventory();
	}
	
	
	
	private class Views
	{

		TextView tvUid=(TextView) findViewById(R.id.idActivityModelC_tvUid);
		Button btnInit=(Button) findViewById(R.id.idActivityModelC_btnInit);
		Button btnUninit=(Button) findViewById(R.id.idActivityModelC_btnUninit);

		Button btnStartInventory=(Button) findViewById(R.id.idActivityModelC_btnStartInventory);
		Button btnStopInventory=(Button) findViewById(R.id.idActivityModelC_btnStopInventory);
		
		
		{

			btnInit.setOnClickListener(new View.OnClickListener()
			{
				@Override
				public void onClick(View v)
				{
					onUiBtnStart();
				}
			});
			btnUninit.setOnClickListener(new View.OnClickListener()
			{
				@Override
				public void onClick(View v)
				{
					onUiBtnUninit();
				}
			});
			btnStartInventory.setOnClickListener(new View.OnClickListener()
			{
				@Override
				public void onClick(View v)
				{
					onUiBtnStartInventory();
				}
			});
			btnStopInventory.setOnClickListener(new View.OnClickListener()
			{
				@Override
				public void onClick(View v)
				{
					onUiBtnStopInventory();
				}
			});
			setRunning(false);
		}
		
		public void setRunning(boolean running)
		{
			btnInit.setEnabled(!running);
			btnStopInventory.setEnabled(running);
			btnStartInventory.setEnabled(running);
			btnUninit.setEnabled(running);
		}
	}
	
}
