package com.senter.support.openapi.demo.lf.model;

import com.senter.demo.common.misc.ActivityHelper;
import com.senter.function.openapi.unstable.StLf;
import com.senter.function.openapi.unstable.StLf.TransceiverModel;
import com.senter.function.openapi.unstable.StLf.TransceiverModelD;
import com.senter.function.openapi.unstable.StLf.TransceiverModelD.TagInfo;
import com.senter.function.openapi.unstable.StLf.TransceiverModelD.TagInfoListener;
import com.senter.support.openapi.demo.lf.R;
import com.senter.support.openapi.demo.lf.util.CommMonitorUtil.SoundsHelper;

import android.app.Activity;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

public class ActivityModelD extends Activity
{
	Views views;
	StLf.TransceiverModelD modelD=StLf.getInstanceAs(TransceiverModel.TransceiverModelD).getTransceiverAs(TransceiverModelD.class);
	StringBuilder sb=new StringBuilder();
	SoundsHelper soundsHelper=new SoundsHelper(this);
	private final ActivityHelper<ActivityModelD> at=new ActivityHelper<ActivityModelD>(this);
	
	@Override
	protected void onCreate(Bundle savedInstanceState)
	{
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity4_d);
		setTitle("Low Frequency Moddel D 134KHZ Demo");
		views=new Views();
		soundsHelper.init();
	}
	
	@Override
	protected void onStop()
	{
		super.onStop();
		onUiBtnUninit();
	}
	@Override
	protected void onDestroy()
	{
		modelD.uninit();
		views.setRunning(false);
		super.onDestroy();
	}
	
	protected void onUiBtnStart()
	{
		boolean initResult=modelD.init();
		if (initResult==false) {
			at.showToastShort("Cannot initialize the function,please check if some one function conflicting with LF is running");
			return;
		}
		modelD.setTagListener(new TagInfoListener()
		{

			@Override
			public void onNewTag(	final TagInfo uid)
			{
				runOnUiThread(new Runnable()
				{
					@Override
					public void run()
					{
						soundsHelper.playSounds(1, 0);
						views.tvUid.setText(views.tvUid.getText().toString()+"tagInfo:"+Long.toHexString(uid.getFirst64BitsAsLong())+"\r\n");
					}
				}
			);
				
			}
		});
		views.setRunning(true);
	}
	

	protected void onUiBtnUninit()
	{
		modelD.uninit();
		views.setRunning(false);
	}
	
	private class Views
	{

		TextView tvUid=(TextView) findViewById(R.id.idActivityModelD_tvUid);
		Button btnInit=(Button) findViewById(R.id.idActivityModelD_btnInit);
		Button btnUninit=(Button) findViewById(R.id.idActivityModelD_btnUninit);

		Button btnClearRecords=(Button) findViewById(R.id.idActivityModelD_btnClearRecords);
		
		
		{

			btnInit.setOnClickListener(new View.OnClickListener()
			{
				@Override
				public void onClick(View v)
				{
					onUiBtnStart();
				}
			});
			btnUninit.setOnClickListener(new View.OnClickListener()
			{
				@Override
				public void onClick(View v)
				{
					onUiBtnUninit();
				}
			});
			btnClearRecords.setOnClickListener(new View.OnClickListener()
			{
				@Override
				public void onClick(View v)
				{
					tvUid.setText("");
				}
			});
			setRunning(false);
		}
		
		public void setRunning(boolean running)
		{
			btnInit.setEnabled(!running);
			btnUninit.setEnabled(running);
		}
	}
	
}
