package com.senter.support.openapi.demo.lf.util;

import java.util.HashMap;
import java.util.Timer;
import java.util.TimerTask;
import android.content.Context;
import android.media.AudioManager;
import android.media.SoundPool;
import android.util.Log;

import com.senter.support.openapi.demo.lf.R;

public class CommMonitorUtil
{
	public static final class SoundsHelper
	{
		private final static String					TAG						= "SoundsHelper";

		private static Boolean						isExit1					= false;
		
		private final Context context;
		private SoundPool							sp;
		private HashMap<Integer, Integer>			spMap;
		
		public SoundsHelper(Context context) {
			this.context=context;
		}
		
		public void init()
		{
			sp = new SoundPool(2, AudioManager.STREAM_MUSIC, 0);
			spMap = new HashMap<Integer, Integer>();
			spMap.put(1, sp.load(context, R.raw.pixiedust, 1));
		}
		
		
		/**
		 * output sound
		 * 
		 * @param sound
		 * @param number
		 */
		public void playSounds(	int sound, int number)
		{

			if (isExit1 == false)
			{
				isExit1 = true;
				new Timer().schedule(new TimerTask()
				{
					@Override
					public void run()
					{
						isExit1 = false;
						// hasTask1 = true;
					}
				}, 150);

				try
				{
					AudioManager am = (AudioManager) context.getSystemService(Context.AUDIO_SERVICE);
					// float audioMaxVolumn = am.getStreamMaxVolume(AudioManager.STREAM_MUSIC);
					float audioCurrentVolumn = am.getStreamVolume(AudioManager.STREAM_MUSIC);
					// float volumnRatio = audioCurrentVolumn/audioMaxVolumn;
					sp.play(spMap.get(sound), audioCurrentVolumn, audioCurrentVolumn, 1, number, 1);
				}
				catch (Exception e)
				{
					e.printStackTrace();
				}
			} else
			{
				Log.d(TAG, "do not output sound");
			}
		}
	}
	
	
	
}
