package com.thomas;

import java.util.ArrayList;
import java.util.List;

import android.app.Activity;
import android.os.Bundle;
import android.text.TextUtils;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.Toast;

import com.senter.iot.support.openapi.uhf.UhfH;

public class AntennaSettingsActivity extends Activity {
    CheckBox CkAntennaPort1;
    CheckBox CkAntennaPort2;
    CheckBox CkAntennaPort3;
    CheckBox CkAntennaPort4;
    CheckBox CkAntennaPort5;
    CheckBox CkAntennaPort6;
    CheckBox CkAntennaPort7;
    CheckBox CkAntennaPort8;
    EditText EtPortStayTime;
    Button BtCheckAntenna;
    Button BtSetAntenna;
    Button BtSetPortStayTime;
    Button BtGetPortStayTime;
    
    private UhfH uhfH;
    
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.antennasettings);
        uhfH = UhfH.getInstance();
        
        CkAntennaPort1 = (CheckBox) findViewById(R.id.CkAntennaPort1);
        CkAntennaPort2 = (CheckBox) findViewById(R.id.CkAntennaPort2);
        CkAntennaPort3 = (CheckBox) findViewById(R.id.CkAntennaPort3);
        CkAntennaPort4 = (CheckBox) findViewById(R.id.CkAntennaPort4);
        CkAntennaPort5 = (CheckBox) findViewById(R.id.CkAntennaPort5);
        CkAntennaPort6 = (CheckBox) findViewById(R.id.CkAntennaPort6);
        CkAntennaPort7 = (CheckBox) findViewById(R.id.CkAntennaPort7);
        CkAntennaPort8 = (CheckBox) findViewById(R.id.CkAntennaPort8);
        EtPortStayTime = (EditText) findViewById(R.id.EtPortStayTime);
        BtCheckAntenna = (Button) findViewById(R.id.BtCheckAntenna);
        BtSetAntenna = (Button) findViewById(R.id.BtSetAntenna);
        BtSetPortStayTime = (Button) findViewById(R.id.BtSetPortStayTime);
        BtGetPortStayTime = (Button) findViewById(R.id.BtGetPortStayTime);
        
        BtCheckAntenna.setOnClickListener(new BtCheckAntennaClickListener());
        BtSetAntenna.setOnClickListener(new BtSetAntennaClickListener());
        BtSetPortStayTime.setOnClickListener(new BtSetPortStayTimeClickListener());
        BtGetPortStayTime.setOnClickListener(new BtGetPortStayTimeClickListener());
    }
    
    class BtCheckAntennaClickListener implements OnClickListener {
        
        @Override
        public void onClick(View arg0) {
            CkAntennaPort1.setEnabled(false);
            CkAntennaPort1.setChecked(false);
            CkAntennaPort2.setEnabled(false);
            CkAntennaPort2.setChecked(false);
            CkAntennaPort3.setEnabled(false);
            CkAntennaPort3.setChecked(false);
            CkAntennaPort4.setEnabled(false);
            CkAntennaPort4.setChecked(false);
            CkAntennaPort5.setEnabled(false);
            CkAntennaPort5.setChecked(false);
            CkAntennaPort6.setEnabled(false);
            CkAntennaPort6.setChecked(false);
            CkAntennaPort7.setEnabled(false);
            CkAntennaPort7.setChecked(false);
            CkAntennaPort8.setEnabled(false);
            CkAntennaPort8.setChecked(false);
            Boolean isEnable = uhfH.checkAntennaEnable();
            if (isEnable != null) {
                if (isEnable) {
                    CkAntennaPort1.setEnabled(true);
                } else {
                    CkAntennaPort1.setEnabled(false);
                }
                Toast.makeText(AntennaSettingsActivity.this, "检测天线成功", Toast.LENGTH_SHORT).show();
            } else {
                Toast.makeText(AntennaSettingsActivity.this, "检测天线失败", Toast.LENGTH_SHORT).show();
            }
        }
    }
    
    class BtSetAntennaClickListener implements OnClickListener {
        
        @Override
        public void onClick(View arg0) {
            if (CkAntennaPort1.isChecked()) {
                boolean isSuccess = uhfH.setAntenna();
                if (isSuccess) {
                    Toast.makeText(AntennaSettingsActivity.this, "设置天线成功", Toast.LENGTH_SHORT).show();
                } else {
                    Toast.makeText(AntennaSettingsActivity.this, "设置天线失败", Toast.LENGTH_SHORT).show();
                }
            } else {
                Toast.makeText(AntennaSettingsActivity.this, "请至少选择一个天线", Toast.LENGTH_SHORT).show();
            }
            
        }
    }
    
    class BtSetPortStayTimeClickListener implements OnClickListener {
        
        @Override
        public void onClick(View arg0) {
            int stayTime = 0;
            
            String portStayTimeStr = EtPortStayTime.getText().toString().trim();
            if (TextUtils.isEmpty(portStayTimeStr)) {
                return;
            }
            if (!Function.isDecimal(portStayTimeStr)) {
                Toast.makeText(AntennaSettingsActivity.this, "天线驻留时间请输入10进制整数", Toast.LENGTH_SHORT).show();
                return;
            }
            stayTime = Integer.parseInt(portStayTimeStr);
            boolean isSuccess = uhfH.setAntWorkTime(stayTime);
            if (isSuccess) {
                Toast.makeText(AntennaSettingsActivity.this, "设置天线驻留时间 成功", Toast.LENGTH_SHORT).show();
            } else {
                Toast.makeText(AntennaSettingsActivity.this, "设置天线驻留时间 失败", Toast.LENGTH_SHORT).show();
            }
        }
    }
    
    class BtGetPortStayTimeClickListener implements OnClickListener {
        
        @Override
        public void onClick(View arg0) {
            Integer workTime = uhfH.getAntWorkTime();
            if (workTime != null) {
                EtPortStayTime.setText(workTime + "");
                Toast.makeText(AntennaSettingsActivity.this, "读取天线驻留时间 成功", Toast.LENGTH_SHORT).show();
            } else {
                Toast.makeText(AntennaSettingsActivity.this, "读取天线驻留时间 失败", Toast.LENGTH_SHORT).show();
            }
        }
    }
}
