package com.thomas;

import java.util.ArrayList;
import java.util.List;

import com.senter.iot.support.openapi.uhf.UhfH;


/**
 * Created by Administrator on 2017/7/21.
 */

public class Bank {
    /**
     * 根据协议类型设置存储区list
     *
     * @param protocol 协议类型（1：ISO 18000-6C；2：GB/T 29768-2013；4：GJB 7377.1-2011；8：Customized protocol）
     * @return list
     */
    public static List<BankItem> InitBankItemListByProType(UhfH.Protocol protocol) {
        List<BankItem> list = new ArrayList<>();
        
        if (protocol == UhfH.Protocol.ISO_18000_6C) {
            list.clear();
            list.add(new BankItem("RESERVED", UhfH.Bank.Reserved));
            list.add(new BankItem("UII", UhfH.Bank.UII));
            list.add(new BankItem("TID", UhfH.Bank.TID));
            list.add(new BankItem("USER", UhfH.Bank.User));
        } else if (protocol == UhfH.Protocol.GBT_29768_2013) {
            list.clear();
            list.add(new BankItem("信息区", UhfH.Bank.GB_Info));
            list.add(new BankItem("编码区", UhfH.Bank.GB_Encode));
            list.add(new BankItem("安全区", UhfH.Bank.GB_Safe));
            list.add(new BankItem("用户子区0", UhfH.Bank.GB_User0));
            list.add(new BankItem("用户子区1", UhfH.Bank.GB_User1));
            list.add(new BankItem("用户子区2", UhfH.Bank.GB_User2));
            list.add(new BankItem("用户子区3", UhfH.Bank.GB_User3));
            list.add(new BankItem("用户子区4", UhfH.Bank.GB_User4));
            list.add(new BankItem("用户子区5", UhfH.Bank.GB_User5));
            list.add(new BankItem("用户子区6", UhfH.Bank.GB_User6));
            list.add(new BankItem("用户子区7", UhfH.Bank.GB_User7));
            list.add(new BankItem("用户子区8", UhfH.Bank.GB_User8));
            list.add(new BankItem("用户子区9", UhfH.Bank.GB_User9));
            list.add(new BankItem("用户子区10", UhfH.Bank.GB_User10));
            list.add(new BankItem("用户子区11", UhfH.Bank.GB_User11));
            list.add(new BankItem("用户子区12", UhfH.Bank.GB_User12));
            list.add(new BankItem("用户子区13", UhfH.Bank.GB_User13));
            list.add(new BankItem("用户子区14", UhfH.Bank.GB_User14));
            list.add(new BankItem("用户子区15", UhfH.Bank.GB_User15));
        } else if (protocol == UhfH.Protocol.GJB_73771_2011) {
            list.clear();
            list.add(new BankItem("信息区", UhfH.Bank.GJB_Info));
            list.add(new BankItem("编码区", UhfH.Bank.GJB_Encode));
            list.add(new BankItem("安全区", UhfH.Bank.GJB_Safe));
            list.add(new BankItem("用户区", UhfH.Bank.GJB_User));
        } else {
            list.clear();
            list.add(new BankItem("信息区", UhfH.Bank.Cus_Info));
            list.add(new BankItem("编码区", UhfH.Bank.Cus_Encode));
            list.add(new BankItem("安全区", UhfH.Bank.Cus_Safe));
            list.add(new BankItem("用户子区0", UhfH.Bank.Cus_User0));
            list.add(new BankItem("用户子区1", UhfH.Bank.Cus_User1));
            list.add(new BankItem("用户子区2", UhfH.Bank.Cus_User2));
            list.add(new BankItem("用户子区3", UhfH.Bank.Cus_User3));
            list.add(new BankItem("用户子区4", UhfH.Bank.Cus_User4));
            list.add(new BankItem("用户子区5", UhfH.Bank.Cus_User5));
        }
        return list;
    }
}
