package com.thomas;

import android.os.Parcel;
import android.os.Parcelable;

import com.senter.iot.support.openapi.uhf.UhfH;


/**
 * Created by Administrator on 2017/7/21.
 */

public class BankItem implements Parcelable {
    
    private String name;
    private UhfH.Bank bank;
    
    public BankItem(String name, UhfH.Bank bank) {
        this.name = name;
        this.bank = bank;
    }
    
    protected BankItem(Parcel in) {
        name = in.readString();
        bank = UhfH.Bank.values()[in.readInt()];
    }
    
    public static final Creator<BankItem> CREATOR = new Creator<BankItem>() {
        @Override
        public BankItem createFromParcel(Parcel in) {
            return new BankItem(in);
        }
        
        @Override
        public BankItem[] newArray(int size) {
            return new BankItem[size];
        }
    };
    
    public String getName() {
        return name;
    }
    
    public UhfH.Bank getBank() {
        return bank;
    }
    
    @Override
    public String toString() {
        return name;
    }
    
    @Override
    public int describeContents() {
        return 0;
    }
    
    @Override
    public void writeToParcel(Parcel dest, int flags) {
        
        dest.writeString(name);
        dest.writeInt(bank.ordinal());
    }
}
