package com.thomas;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.RadioButton;
import android.widget.Spinner;
import android.widget.Toast;

import com.senter.iot.support.openapi.uhf.UhfH;


public class BaseSettingsActivity extends Activity {
	
	RadioButton RbTestMode;
	RadioButton RbHighEffMode;
	RadioButton RbOpenBeep;
	RadioButton RbCloseBeep;
	Spinner SpinnerProtocol;
	Spinner SpinnerWorkMode;
	Spinner SpinnerBaudrate;
	EditText EtDeviceAddress;
	EditText EtTimeout;
	EditText EtReadInfo;
	Button BtSetProtocol;
	Button BtGetProtocol;
	Button BtSetWorkMode;
	Button BtGetWorkMode;
	Button BtSetDeviceAddress;
	Button BtGetDeviceAddress;
	Button BtSetBaudrate;
	Button BtGetBaudrate;
	Button BtSetBeep;
	Button BtGetBeep;
	Button BtSetTimeout;
	Button BtGetTimeout;
	Button BtReadInfo;
	
	private UhfH uhfH;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.basesettings);
		uhfH = UhfH.getInstance();
		
		RbTestMode = (RadioButton) findViewById(R.id.RbTestMode);
		RbHighEffMode = (RadioButton) findViewById(R.id.RbHighEffMode);
		RbOpenBeep = (RadioButton) findViewById(R.id.RbOpenBeep);
		RbCloseBeep = (RadioButton) findViewById(R.id.RbCloseBeep);
		SpinnerProtocol = (Spinner) findViewById(R.id.SpinnerProtocol);
		SpinnerWorkMode = (Spinner) findViewById(R.id.SpinnerWorkMode);
		SpinnerBaudrate = (Spinner) findViewById(R.id.SpinnerBaudrate);
		EtDeviceAddress = (EditText) findViewById(R.id.EtDeviceAddress);
		EtTimeout = (EditText) findViewById(R.id.EtTimeout);
		EtReadInfo = (EditText) findViewById(R.id.EtReadInfo);
		BtSetProtocol = (Button) findViewById(R.id.BtSetProtocol);
		BtGetProtocol = (Button) findViewById(R.id.BtGetProtocol);
		BtSetWorkMode = (Button) findViewById(R.id.BtSetWorkMode);
		BtGetWorkMode = (Button) findViewById(R.id.BtGetWorkMode);
		BtSetDeviceAddress = (Button) findViewById(R.id.BtSetDeviceAddress);
		BtGetDeviceAddress = (Button) findViewById(R.id.BtGetDeviceAddress);
		BtSetBaudrate = (Button) findViewById(R.id.BtSetBaudrate);
		BtGetBaudrate = (Button) findViewById(R.id.BtGetBaudrate);
		BtSetBeep = (Button) findViewById(R.id.BtSetBeep);
		BtGetBeep = (Button) findViewById(R.id.BtGetBeep);
		BtSetTimeout = (Button) findViewById(R.id.BtSetTimeout);
		BtGetTimeout = (Button) findViewById(R.id.BtGetTimeout);
		BtReadInfo = (Button) findViewById(R.id.BtReadInfo);
		
		BtSetProtocol.setOnClickListener(new BtSetProtocolClickListener());
		BtGetProtocol.setOnClickListener(new BtGetProtocolClickListener());
		BtSetWorkMode.setOnClickListener(new BtSetWorkModeClickListener());
		BtGetWorkMode.setOnClickListener(new BtGetWorkModeClickListener());
		BtSetDeviceAddress.setOnClickListener(new BtSetDeviceAddressClickListener());
		BtGetDeviceAddress.setOnClickListener(new BtGetDeviceAddressClickListener());
		BtSetBaudrate.setOnClickListener(new BtSetBaudrateClickListener());
		BtGetBaudrate.setOnClickListener(new BtGetBaudrateClickListener());
		BtSetBeep.setOnClickListener(new BtSetBeepClickListener());
		BtGetBeep.setOnClickListener(new BtGetBeepClickListener());
		BtSetTimeout.setOnClickListener(new BtSetTimeoutClickListener());
		BtGetTimeout.setOnClickListener(new BtGetTimeoutClicklistener());
		BtReadInfo.setOnClickListener(new BtReadInfoClicklistener());
		
		GetBaseSettings();
	}
	
	class BtSetProtocolClickListener implements OnClickListener {
		
		@Override
		public void onClick(View arg0) {
			byte proType = 0;
			UhfH.ProtocolMode protocolMode = null;
			UhfH.Protocol protocol = null;
			if (RbTestMode.isChecked()) {
				protocolMode = UhfH.ProtocolMode.TestMode;
			} else {
				protocolMode = UhfH.ProtocolMode.HighEffMode;
			}
			if (SpinnerProtocol.getSelectedItemPosition() == 0) {
				protocol = UhfH.Protocol.ISO_18000_6C;
			} else if (SpinnerProtocol.getSelectedItemPosition() == 1) {
				protocol = UhfH.Protocol.GBT_29768_2013;
			} else if (SpinnerProtocol.getSelectedItemPosition() == 2) {
				protocol = UhfH.Protocol.GJB_73771_2011;
			} else {
				protocol = UhfH.Protocol.Customized_protocol;
			}
			boolean isSuccess = uhfH.setProSel(protocol, protocolMode);
			if (isSuccess) {
				Toast.makeText(BaseSettingsActivity.this, "设置工作协议 成功", Toast.LENGTH_SHORT).show();
			} else {
				Toast.makeText(BaseSettingsActivity.this, "设置工作协议 失败", Toast.LENGTH_SHORT).show();
			}
		}
	}
	
	class BtGetProtocolClickListener implements OnClickListener {
		
		@Override
		public void onClick(View arg0) {
			byte proType = 0;
			UhfH.Result.ProtocolResult result = uhfH.getProSel();
			if (result != null) {
				if (result.getMode() == UhfH.ProtocolMode.TestMode) {
					RbTestMode.setChecked(true);
				} else {
					RbHighEffMode.setChecked(true);
				}
				if (result.getProtocol() == UhfH.Protocol.ISO_18000_6C) {
					SpinnerProtocol.setSelection(0);
				} else if (result.getProtocol() == UhfH.Protocol.GBT_29768_2013) {
					SpinnerProtocol.setSelection(1);
				} else if (result.getProtocol() == UhfH.Protocol.GJB_73771_2011) {
					SpinnerProtocol.setSelection(2);
				} else {
					SpinnerProtocol.setSelection(3);
				}
				Toast.makeText(BaseSettingsActivity.this, "读取工作协议 成功", Toast.LENGTH_SHORT).show();
			} else {
				Toast.makeText(BaseSettingsActivity.this, "读取工作协议 失败", Toast.LENGTH_SHORT).show();
			}
		}
	}
	
	class BtSetWorkModeClickListener implements OnClickListener {
		
		@Override
		public void onClick(View arg0) {
			UhfH.WorkMode workMode = UhfH.WorkMode.Valueof(SpinnerWorkMode.getSelectedItemPosition());
			boolean isSuccess = uhfH.setWorkMode(workMode);
			if (isSuccess) {
				Toast.makeText(BaseSettingsActivity.this, "设置工作模式 成功", Toast.LENGTH_SHORT).show();
			} else {
				Toast.makeText(BaseSettingsActivity.this, "设置工作模式 失败", Toast.LENGTH_SHORT).show();
			}
		}
	}
	
	class BtGetWorkModeClickListener implements OnClickListener {
		
		@Override
		public void onClick(View arg0) {
			UhfH.WorkMode workMode = uhfH.getWorkMode();
			if (workMode != null) {
				SpinnerWorkMode.setSelection(workMode.getValue());
				Toast.makeText(BaseSettingsActivity.this, "读取工作模式 成功", Toast.LENGTH_SHORT).show();
			} else {
				Toast.makeText(BaseSettingsActivity.this, "读取工作模式 失败", Toast.LENGTH_SHORT).show();
			}
		}
	}
	
	class BtSetDeviceAddressClickListener implements OnClickListener {
		
		@Override
		public void onClick(View arg0) {
//			byte[] devAddr = new byte[2];
//			String addrStr = EtDeviceAddress.getText().toString().trim();
//			if (!fun.isHex(addrStr) || addrStr.length() != 4) {
//				Toast.makeText(BaseSettingsActivity.this, "设备地址 请输入2字节的16进制数据", Toast.LENGTH_SHORT).show();
//				return;
//			}
//			boolean isSuccess = uhfH.setDeviceAddress(addrStr);
//			if (isSuccess) {
//				Toast.makeText(BaseSettingsActivity.this, "设置 设备地址 成功", Toast.LENGTH_SHORT).show();
//			} else {
//				Toast.makeText(BaseSettingsActivity.this, "设置 设备地址 失败", Toast.LENGTH_SHORT).show();
//			}
		}
	}
	
	class BtGetDeviceAddressClickListener implements OnClickListener {
		
		@Override
		public void onClick(View arg0) {
//			String addressStr = uhfH.getDeviceAddress();
//			if (addressStr != null) {
//				EtDeviceAddress.setText(addressStr);
//				Toast.makeText(BaseSettingsActivity.this, "读取 设备地址 成功", Toast.LENGTH_SHORT).show();
//			} else {
//				Toast.makeText(BaseSettingsActivity.this, "读取 设备地址 失败", Toast.LENGTH_SHORT).show();
//			}
		}
	}
	
	class BtSetBaudrateClickListener implements OnClickListener {
		
		@Override
		public void onClick(View arg0) {
//			boolean isSuccess = uhfH.setBaud(UhfH.BaudRate.ValueOf(SpinnerBaudrate.getSelectedItemPosition()));
//			if (isSuccess) {
//				Toast.makeText(BaseSettingsActivity.this, "设置 波特率 成功", Toast.LENGTH_SHORT).show();
//			} else {
//				Toast.makeText(BaseSettingsActivity.this, "设置 波特率 失败", Toast.LENGTH_SHORT).show();
//			}
		}
	}
	
	class BtGetBaudrateClickListener implements OnClickListener {
		
		@Override
		public void onClick(View arg0) {
//			UhfH.BaudRate baudRate = uhfH.getBaud();
//			if (baudRate != null) {
//				SpinnerBaudrate.setSelection(baudRate.getValue());
//				Toast.makeText(BaseSettingsActivity.this, "读取 波特率 成功", Toast.LENGTH_SHORT).show();
//			} else {
//				Toast.makeText(BaseSettingsActivity.this, "读取 波特率 失败", Toast.LENGTH_SHORT).show();
//			}
		}
	}
	
	class BtSetBeepClickListener implements OnClickListener {
		
		@Override
		public void onClick(View arg0) {
//			boolean isSuccess = uhfH.setBuz(RbOpenBeep.isChecked());
//			if (isSuccess) {
//				Toast.makeText(BaseSettingsActivity.this, "设置 蜂鸣器 成功", Toast.LENGTH_SHORT).show();
//			} else {
//				Toast.makeText(BaseSettingsActivity.this, "设置 蜂鸣器 失败", Toast.LENGTH_SHORT).show();
//			}
		}
	}
	
	class BtGetBeepClickListener implements OnClickListener {
		
		@Override
		public void onClick(View arg0) {
//			Boolean buz = uhfH.getBuz();
//			if (buz != null) {
//				if (buz) {
//					RbOpenBeep.setChecked(true);
//				} else {
//					RbCloseBeep.setChecked(true);
//				}
//				Toast.makeText(BaseSettingsActivity.this, "读取 蜂鸣器 成功", Toast.LENGTH_SHORT).show();
//			} else {
//				Toast.makeText(BaseSettingsActivity.this, "读取 蜂鸣器 失败", Toast.LENGTH_SHORT).show();
//			}
		}
	}
	
	class BtSetTimeoutClickListener implements OnClickListener {
		
		@Override
		public void onClick(View arg0) {
			byte timeout = 0x00;
			String timeStr = EtTimeout.getText().toString().trim();
			if (!Function.isDecimal(timeStr)) {
				Toast.makeText(BaseSettingsActivity.this, "命令超时时间 请输入10进制数据", Toast.LENGTH_SHORT).show();
				return;
			}
			timeout = (byte) Integer.parseInt(timeStr);
			boolean isSuccess = uhfH.setTimeOut(timeout);
			if (isSuccess) {
				Toast.makeText(BaseSettingsActivity.this, "设置 命令超时时间 成功", Toast.LENGTH_SHORT).show();
			} else {
				Toast.makeText(BaseSettingsActivity.this, "设置 命令超时时间 失败", Toast.LENGTH_SHORT).show();
			}
		}
	}
	
	class BtGetTimeoutClicklistener implements OnClickListener {
		
		@Override
		public void onClick(View arg0) {
			Integer timeout = uhfH.getTimeout();
			if (timeout != null) {
				EtTimeout.setText(timeout + "");
				Toast.makeText(BaseSettingsActivity.this, "读取 命令超时时间 成功", Toast.LENGTH_SHORT).show();
			} else {
				Toast.makeText(BaseSettingsActivity.this, "读取 命令超时时间 失败", Toast.LENGTH_SHORT).show();
			}
		}
	}
	
	class BtReadInfoClicklistener implements OnClickListener {
		@Override
		public void onClick(View arg0) {
			UhfH.Device rlmInfo = uhfH.getDevice();
			if (rlmInfo != null) {
				String str = "uid:" + rlmInfo.getUid() + " serial:" + rlmInfo.getHardware() + " software:" + rlmInfo.getSoftware();
				EtReadInfo.setText(str);
				Toast.makeText(BaseSettingsActivity.this, "读取 设备信息 成功", Toast.LENGTH_SHORT).show();
			} else {
				Toast.makeText(BaseSettingsActivity.this, "读取 设备信息 失败", Toast.LENGTH_SHORT).show();
			}
		}
	}
	
	private void GetBaseSettings() {
		//读取工作协议
		UhfH.Result.ProtocolResult protocolResult = uhfH.getProSel();
		if (protocolResult != null) {
			if (protocolResult.getMode() == UhfH.ProtocolMode.TestMode) {
				RbTestMode.setChecked(true);
			} else {
				RbHighEffMode.setChecked(true);
			}
			switch (protocolResult.getProtocol()) {
				case ISO_18000_6C:
					SpinnerProtocol.setSelection(0);
					break;
				case GBT_29768_2013:
					SpinnerProtocol.setSelection(1);
					break;
				case GJB_73771_2011:
					SpinnerProtocol.setSelection(2);
					break;
				case Customized_protocol:
					SpinnerProtocol.setSelection(3);
					break;
			}
//            Toast.makeText(BaseSettingsActivity.this, "读取工作协议 成功", Toast.LENGTH_SHORT).show();
		} else {
			Toast.makeText(BaseSettingsActivity.this, "读取工作协议 失败", Toast.LENGTH_SHORT).show();
		}
		
		//读取工作模式
		UhfH.WorkMode workMode = uhfH.getWorkMode();
		if (workMode != null) {
			SpinnerWorkMode.setSelection(workMode.getValue());
//			Toast.makeText(BaseSettingsActivity.this, "读取工作模式 成功", Toast.LENGTH_SHORT).show();
		} else {
			Toast.makeText(BaseSettingsActivity.this, "读取工作模式 失败", Toast.LENGTH_SHORT).show();
		}
		
		//读取设备地址
//		String addStr = uhfH.getDeviceAddress();
//		if (addStr != null) {
//			EtDeviceAddress.setText(addStr);
////			Toast.makeText(BaseSettingsActivity.this, "读取 设备地址 成功", Toast.LENGTH_SHORT).show();
//		} else {
//			Toast.makeText(BaseSettingsActivity.this, "读取 设备地址 失败", Toast.LENGTH_SHORT).show();
//		}
		
		//读取波特率
		//UhfH.BaudRate baudRate = uhfH.getBaud();
//		if (baudRate != null) {
//			SpinnerBaudrate.setSelection(baudRate.getValue());
////			Toast.makeText(BaseSettingsActivity.this, "读取 波特率 成功", Toast.LENGTH_SHORT).show();
//		} else {
//			Toast.makeText(BaseSettingsActivity.this, "读取 波特率 失败", Toast.LENGTH_SHORT).show();
//		}
		
		//读取蜂鸣器状态
//		Boolean isOpen = uhfH.getBuz();
//		if (isOpen != null) {
//			if (isOpen) {
//				RbOpenBeep.setChecked(true);
//			} else {
//				RbCloseBeep.setChecked(true);
//			}
////			Toast.makeText(BaseSettingsActivity.this, "读取 蜂鸣器 成功", Toast.LENGTH_SHORT).show();
//		} else {
//			Toast.makeText(BaseSettingsActivity.this, "读取 蜂鸣器 失败", Toast.LENGTH_SHORT).show();
//		}
		
		//读取命令超时时间
		Integer timeout = uhfH.getTimeout();
		if (timeout != null) {
			EtTimeout.setText(timeout + "");
//			Toast.makeText(BaseSettingsActivity.this, "读取 命令超时时间 成功", Toast.LENGTH_SHORT).show();
		} else {
			Toast.makeText(BaseSettingsActivity.this, "读取 命令超时时间 失败", Toast.LENGTH_SHORT).show();
		}
	}
}
