package com.thomas;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import android.app.Activity;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.CompoundButton.OnCheckedChangeListener;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.RadioButton;
import android.widget.SimpleAdapter;
import android.widget.Spinner;
import android.widget.Toast;

import com.senter.iot.support.openapi.uhf.UhfH;


public class EraseTagActivity extends Activity {
    
    CheckBox CkWithUiiErase;
    RadioButton RbEraseSingle;
    RadioButton RbEraseLoop;
    EditText EtTagUiiErase;
    EditText EtPtrErase;
    EditText EtLenErase;
    Spinner SpinnerBankErase;
    ListView LvErase;
    Button BtUiiErase;
    Button BtErase;
    Button BtClearErase;
    
    List<BankItem> list = new ArrayList<>();
    @SuppressWarnings("rawtypes")
    ArrayAdapter adapterBank;
    static ArrayList<HashMap<String, String>> dataList;
    SimpleAdapter adapter;
    
    private UhfH uhfH;
    
    @SuppressWarnings({"unchecked", "rawtypes"})
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.erasetag);
        uhfH = UhfH.getInstance();
        dataList = new ArrayList<HashMap<String, String>>();
        adapter = new SimpleAdapter(EraseTagActivity.this,
                                    dataList,
                                    R.layout.erasedata_items,
                                    new String[]{"uii", "count"},
                                    new int[]{R.id.TvUii_Erase, R.id.TvCount_Erase});
        
        CkWithUiiErase = (CheckBox) findViewById(R.id.CkWithUiiErase);
        RbEraseSingle = (RadioButton) findViewById(R.id.RbEraseSingle);
        RbEraseLoop = (RadioButton) findViewById(R.id.RbEraseLoop);
        EtTagUiiErase = (EditText) findViewById(R.id.EtTagUiiErase);
        EtPtrErase = (EditText) findViewById(R.id.EtPtrErase);
        EtLenErase = (EditText) findViewById(R.id.EtLenErase);
        SpinnerBankErase = (Spinner) findViewById(R.id.SpinnerBankErase);
        LvErase = (ListView) findViewById(R.id.LvErase);
        BtUiiErase = (Button) findViewById(R.id.BtUiiErase);
        BtErase = (Button) findViewById(R.id.BtErase);
        BtClearErase = (Button) findViewById(R.id.BtClearErase);
        
        EtTagUiiErase.setEnabled(false);
        
        CkWithUiiErase.setOnCheckedChangeListener(new CkWithUiiEraseCheckedChangeListener());
        BtUiiErase.setOnClickListener(new BtUiiEraseClickListener());
        BtErase.setOnClickListener(new BtEraseClickListener());
        BtClearErase.setOnClickListener(new BtEraseClickListener());
        
        list = Bank.InitBankItemListByProType(uhfH.getProSel().getProtocol());
        adapterBank = new ArrayAdapter(this, R.layout.bank, R.id.TvBank, list);
        SpinnerBankErase.setAdapter(adapterBank);
    }
    
    class CkWithUiiEraseCheckedChangeListener implements OnCheckedChangeListener {
        
        @Override
        public void onCheckedChanged(CompoundButton arg0, boolean arg1) {
            if (arg1) {
                EtTagUiiErase.setEnabled(true);
            } else {
                EtTagUiiErase.setEnabled(false);
            }
        }
    }
    
    class BtUiiEraseClickListener implements OnClickListener {
        
        @Override
        public void onClick(View arg0) {
            if (CkWithUiiErase.isChecked()) {
                UhfH.UII uii = uhfH.inventorySingleTagOnce();
                if (uii != null) {
                    EtTagUiiErase.setText(Function.bytesToHexString(uii.getBytes(), uii.getUiiLength()));
                } else {
                    Toast.makeText(EraseTagActivity.this, "读取标签号失败", Toast.LENGTH_SHORT).show();
                }
            }
        }
    }
    
    class BtEraseClickListener implements OnClickListener {
        
        @Override
        public void onClick(View arg0) {
            if (BtErase.getText().toString().trim().equals("擦除数据")) {
                String ptrStr = EtPtrErase.getText().toString().trim();
                if (ptrStr.equals("")) {
                    Toast.makeText(EraseTagActivity.this, "地址 不能为空", Toast.LENGTH_SHORT).show();
                    return;
                }
                if (!Function.isDecimal(ptrStr)) {
                    Toast.makeText(EraseTagActivity.this, "地址 请输入十进制数据", Toast.LENGTH_SHORT).show();
                    return;
                }
                int _ptr = Integer.parseInt(ptrStr);
                String lenStr = EtLenErase.getText().toString().trim();
                if (lenStr.equals("")) {
                    Toast.makeText(EraseTagActivity.this, "长度 不能为空", Toast.LENGTH_SHORT).show();
                    return;
                }
                if (!Function.isDecimal(lenStr)) {
                    Toast.makeText(EraseTagActivity.this, "长度 请输入十进制数据", Toast.LENGTH_SHORT).show();
                    return;
                }
                int _len = Integer.parseInt(lenStr);
                if (RbEraseSingle.isChecked()) {//单步
                    if (CkWithUiiErase.isChecked()) {//指定标签
                        String uiiStr = EtTagUiiErase.getText().toString().trim();
                        if (uiiStr.equals("")) {
                            Toast.makeText(EraseTagActivity.this, "标签号不能为空", Toast.LENGTH_SHORT).show();
                            return;
                        }
                        if (!Function.isHex(uiiStr)) {
                            Toast.makeText(EraseTagActivity.this, "标签号必须为十六进制数据", Toast.LENGTH_SHORT).show();
                            return;
                        }
                        UhfH.Result.EraseResult result = uhfH.eraseOnceFromSingleTag(list.get(SpinnerBankErase.getSelectedItemPosition()).getBank(), _ptr, _len, UhfH.UII
                                .getNewInstanceByBytes(Function.HexStringToBytes(uiiStr), 0));
                        if (result.isSuccess()) {
                            HashMap<String, String> map = new HashMap<String, String>();
                            map.put("uii", uiiStr);
                            map.put("count", String.valueOf(1));
                            int index = checkIsExist(uiiStr, dataList);
                            if (index == -1) {
                                dataList.add(map);
                                LvErase.setAdapter(adapter);
                            } else {
                                int count = Integer.parseInt(dataList.get(index).get("count"), 10) + 1;
                                map.put("count", String.valueOf(count));
                                dataList.set(index, map);
                                adapter.notifyDataSetChanged();
                            }
                        } else {
                            Toast.makeText(EraseTagActivity.this, "指定标签擦除数据失败", Toast.LENGTH_SHORT).show();
                        }
                    } else {//不指定标签
                        UhfH.Result.EraseResult result = uhfH.eraseOnceFromUnSpecifiedTag(list.get(SpinnerBankErase.getSelectedItemPosition()).getBank(), _ptr, _len);
                        if (result.isSuccess()) {
                            String uiiStr = Function.bytesToHexString(result.getUii().getBytes(), result.getUii().getUiiLength());
                            HashMap<String, String> map = new HashMap<String, String>();
                            map.put("uii", uiiStr);
                            map.put("count", String.valueOf(1));
                            int index = checkIsExist(uiiStr, dataList);
                            if (index == -1) {
                                dataList.add(map);
                                LvErase.setAdapter(adapter);
                            } else {
                                int count = Integer.parseInt(dataList.get(index).get("count"), 10) + 1;
                                map.put("count", String.valueOf(count));
                                dataList.set(index, map);
                                adapter.notifyDataSetChanged();
                            }
                        } else {
                            Toast.makeText(EraseTagActivity.this, "不指定标签擦除数据失败", Toast.LENGTH_SHORT).show();
                        }
                    }
                } else {//循环
                    if (CkWithUiiErase.isChecked()) {//指定标签
                        String uiiStr = EtTagUiiErase.getText().toString().trim();
                        if (uiiStr.equals("")) {
                            Toast.makeText(EraseTagActivity.this, "标签号不能为空", Toast.LENGTH_SHORT).show();
                            return;
                        }
                        if (!Function.isHex(uiiStr)) {
                            Toast.makeText(EraseTagActivity.this, "标签号必须为十六进制数据", Toast.LENGTH_SHORT).show();
                            return;
                        }
                        boolean isSuccess = uhfH.startEraseLoopFromSingleTag(list.get(SpinnerBankErase.getSelectedItemPosition()).getBank(), _ptr, _len, UhfH.UII
                                .getNewInstanceByBytes(Function.HexStringToBytes(uiiStr), 0), new UhfH.OnEraseListener() {
                            @Override
                            public void onErase(UhfH.Result.EraseResult result) {
                                if (result.isSuccess()) {
                                    Message msg = handler.obtainMessage();
                                    Bundle bundle = new Bundle();
                                    bundle.putString("uii", Function.bytesToHexString(result.getUii().getBytes(), result.getUii().getUiiLength()));
                                    msg.setData(bundle);
                                    handler.sendMessage(msg);
                                }
                            }
                        });
                        if (isSuccess) {
                            BtUiiErase.setEnabled(false);
                            BtErase.setText("停止");
                        } else {
                            Toast.makeText(EraseTagActivity.this, "开启指定标签循环擦除数据失败", Toast.LENGTH_SHORT).show();
                        }
                    } else {//不指定标签
                        boolean isSuccess = uhfH.startEraseLoopFromUnSpecifiedTag(list.get(SpinnerBankErase.getSelectedItemPosition()).getBank(), _ptr, _len, new UhfH.OnEraseListener() {
                            @Override
                            public void onErase(UhfH.Result.EraseResult result) {
                                if (result.isSuccess()) {
                                    Message msg = handler.obtainMessage();
                                    Bundle bundle = new Bundle();
                                    bundle.putString("uii", Function.bytesToHexString(result.getUii().getBytes(), result.getUii().getUiiLength()));
                                    msg.setData(bundle);
                                    handler.sendMessage(msg);
                                }
                            }
                        });
                        if (isSuccess) {
                            BtUiiErase.setEnabled(false);
                            BtErase.setText("停止");
                        } else {
                            Toast.makeText(EraseTagActivity.this, "开启不指定标签循环擦除数据失败", Toast.LENGTH_SHORT).show();
                        }
                    }
                }
            } else {
                uhfH.stopLoopOperate();
                BtErase.setText("擦除数据");
                BtUiiErase.setEnabled(true);
            }
        }
    }
    
    public int checkIsExist(String uiiStr, ArrayList<HashMap<String, String>> tagList) {
        int existFlag = -1;
        String tempUiiStr = "";
        
        for (int i = 0; i < tagList.size(); i++) {
            HashMap<String, String> temp = new HashMap<String, String>();
            temp = tagList.get(i);
            tempUiiStr = temp.get("uii");
            if (uiiStr != "" && uiiStr.equals(tempUiiStr)) {
                existFlag = i;
            }
        }
        
        return existFlag;
    }
    
    Handler handler = new Handler() {
        
        @Override
        public void handleMessage(Message msg) {
            Bundle bundle = msg.getData();
            String uiiStr = bundle.getString("uii");
            
            HashMap<String, String> map = new HashMap<String, String>();
            map.put("uii", uiiStr);
            map.put("count", String.valueOf(1));
            
            int index = -1;
            if (!uiiStr.equals(null)) {
                index = checkIsExist(uiiStr, dataList);
                if (index == -1) {
                    dataList.add(map);
                    LvErase.setAdapter(adapter);
                } else {
                    int count = Integer.parseInt(dataList.get(index).get("count"), 10) + 1;
                    map.put("count", String.valueOf(count));
                    dataList.set(index, map);
                    adapter.notifyDataSetChanged();
                }
            }
        }
    };
    
    class BtClearEraseClickListener implements OnClickListener {
        
        @Override
        public void onClick(View arg0) {
            
            dataList.clear();
            adapter.notifyDataSetChanged();
        }
    }
    
    @Override
    public void onBackPressed() {
        uhfH.stopLoopOperate();
        super.onBackPressed();
    }
}
