package com.thomas;

import java.util.ArrayList;
import java.util.List;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.Spinner;
import android.widget.Toast;

import com.senter.iot.support.openapi.uhf.UhfH;


public class InitActivity extends Activity {
    
    List<String> list;
    @SuppressWarnings("rawtypes")
    ArrayAdapter adapter;
    private String comStr;
    
    private Spinner SpinnerCom;
    private Spinner SpinnerBaud;
    private Spinner SpinnerProtocol;
    private Button BtConnect;
    
    private UhfH uhfH;
    
    @SuppressWarnings({"unchecked", "rawtypes"})
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.init);
        
        SpinnerCom = (Spinner) findViewById(R.id.SpinnerCom);
        SpinnerBaud = (Spinner) findViewById(R.id.SpinnerBaud);
        SpinnerProtocol = (Spinner) findViewById(R.id.SpinnerProtocol);
        BtConnect = (Button) findViewById(R.id.BtConnect);
        
        list = new ArrayList<>();
        list.add("/dev/ttyHSL0");//(SDXT)
        
        adapter = new ArrayAdapter(this, R.layout.comitems, R.id.TvCom, list);
        SpinnerCom.setAdapter(adapter);
        SpinnerCom.setPrompt("选择COM口");
        SpinnerBaud.setSelection(2);
        BtConnect.setOnClickListener(new BtConnectListener());
        uhfH = UhfH.getInstance();
        BtConnect.setText(uhfH.isInited() ? "断开连接" : "连接设备");
    }
    
    private class BtConnectListener implements OnClickListener {
        
        @Override
        public void onClick(View v) {
            
            String infoStr = "";
            if (BtConnect.getText().toString().equals("连接设备")) {
                comStr = (String) SpinnerCom.getSelectedItem();
                boolean isSuccess = uhfH.init();
                if (isSuccess) {
                    UhfH.Protocol protocol = null;
                    switch (SpinnerProtocol.getSelectedItemPosition()) {
                        case 0:
                            protocol = UhfH.Protocol.ISO_18000_6C;
                            break;
                        case 1:
                            protocol = UhfH.Protocol.GBT_29768_2013;
                            break;
                        case 2:
                            protocol = UhfH.Protocol.GJB_73771_2011;
                            break;
                        case 3:
                            protocol = UhfH.Protocol.Customized_protocol;
                            break;
                    }
                    if (!uhfH.setProSel(protocol, UhfH.ProtocolMode.TestMode)) {
                        infoStr += "设置工作协议失败\n";
                        infoStr += "连接失败\n";
                        uhfH.uninit();
                    } else {
                        BtConnect.setText("断开连接");
                        infoStr += "设置工作协议成功\n";
                    }
                    
                } else {
                    infoStr += "连接失败\n";
                }
                
                Toast.makeText(getApplicationContext(), infoStr, Toast.LENGTH_SHORT).show();
            } else {
                uhfH.uninit();
                BtConnect.setText("连接设备");
                Toast.makeText(getApplicationContext(), "断开成功", Toast.LENGTH_SHORT).show();
            }
        }
    }
}
