package com.thomas;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;

import android.app.Activity;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.CompoundButton.OnCheckedChangeListener;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.RadioButton;
import android.widget.SimpleAdapter;
import android.widget.Toast;

import com.senter.iot.support.openapi.uhf.UhfH;


public class KillTagActivity extends Activity {
    CheckBox CkWithUiiKill;
    RadioButton RbKillSingle;
    RadioButton RbKillLoop;
    EditText EtTagUiiKill;
    ListView LvKill;
    Button BtUiiKill;
    Button BtKill;
    Button BtClearKill;
    
    static ArrayList<HashMap<String, String>> dataList;
    SimpleAdapter adapter;
    
    private UhfH uhfH;
    
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.killtag);
        uhfH = UhfH.getInstance();
        dataList = new ArrayList<HashMap<String, String>>();
        adapter = new SimpleAdapter(KillTagActivity.this,
                                    dataList,
                                    R.layout.killtag_items,
                                    new String[]{"uii", "count"},
                                    new int[]{R.id.TvUii_Kill, R.id.TvCount_Kill});
        
        CkWithUiiKill = (CheckBox) findViewById(R.id.CkWithUiiKill);
        RbKillSingle = (RadioButton) findViewById(R.id.RbKillSingle);
        RbKillLoop = (RadioButton) findViewById(R.id.RbKillLoop);
        EtTagUiiKill = (EditText) findViewById(R.id.EtTagUiiKill);
        LvKill = (ListView) findViewById(R.id.LvKill);
        BtUiiKill = (Button) findViewById(R.id.BtUiiKill);
        BtKill = (Button) findViewById(R.id.BtKill);
        BtClearKill = (Button) findViewById(R.id.BtClearKill);
        
        CkWithUiiKill.setOnCheckedChangeListener(new CkWithUiiKillCheckedChangeListener());
        BtUiiKill.setOnClickListener(new BtUiiKillClickListener());
        BtKill.setOnClickListener(new BtLockClickListener());
        BtClearKill.setOnClickListener(new BtClearKillClickListener());
    }
    
    class CkWithUiiKillCheckedChangeListener implements OnCheckedChangeListener {
        
        @Override
        public void onCheckedChanged(CompoundButton arg0, boolean arg1) {
            if (arg1) {
                EtTagUiiKill.setEnabled(true);
            } else {
                EtTagUiiKill.setEnabled(false);
            }
        }
    }
    
    class BtUiiKillClickListener implements OnClickListener {
        
        @Override
        public void onClick(View arg0) {
            if (CkWithUiiKill.isChecked()) {
                UhfH.UII uii = uhfH.inventorySingleTagOnce();
                if (uii != null) {
                    EtTagUiiKill.setText(Function.bytesToHexString(uii.getBytes(), uii.getUiiLength()));
                } else {
                    Toast.makeText(KillTagActivity.this, "读取标签号失败", Toast.LENGTH_SHORT).show();
                }
            }
        }
    }
    
    class BtLockClickListener implements OnClickListener {
        
        @Override
        public void onClick(View arg0) {
            if (BtKill.getText().toString().trim().equals("销毁标签")) {
                
                if (RbKillSingle.isChecked()) {//单步
                    if (CkWithUiiKill.isChecked()) {//指定标签
                        String uiiStr = EtTagUiiKill.getText().toString().trim();
                        if (uiiStr.equals("")) {
                            Toast.makeText(KillTagActivity.this, "标签号不能为空", Toast.LENGTH_SHORT).show();
                            return;
                        }
                        if (!Function.isHex(uiiStr)) {
                            Toast.makeText(KillTagActivity.this, "标签号必须为十六进制数据", Toast.LENGTH_SHORT).show();
                            return;
                        }
                        UhfH.Result.KillResult result = uhfH.killOnceFromSingleTag(UhfH.UII.getNewInstanceByBytes(Function.HexStringToBytes(uiiStr), 0));
                        if (result.isSuccess()) {
                            HashMap<String, String> map = new HashMap<String, String>();
                            map.put("uii", uiiStr);
                            map.put("count", String.valueOf(1));
                            int index = checkIsExist(uiiStr, dataList);
                            if (index == -1) {
                                dataList.add(map);
                                LvKill.setAdapter(adapter);
                            } else {
                                int count = Integer.parseInt(dataList.get(index).get("count"), 10) + 1;
                                map.put("count", String.valueOf(count));
                                dataList.set(index, map);
                                adapter.notifyDataSetChanged();
                            }
                        } else {
                            Toast.makeText(KillTagActivity.this, "指定标签销毁标签失败", Toast.LENGTH_SHORT).show();
                        }
                    } else {//不指定标签
                        UhfH.Result.KillResult result = uhfH.killOnceFromUnSpecifiedTag();
                        if (result.isSuccess()) {
                            String uiiStr = Function.bytesToHexString(result.getUii().getBytes(), result.getUii().getUiiLength());
                            HashMap<String, String> map = new HashMap<String, String>();
                            map.put("uii", uiiStr);
                            map.put("count", String.valueOf(1));
                            int index = checkIsExist(uiiStr, dataList);
                            if (index == -1) {
                                dataList.add(map);
                                LvKill.setAdapter(adapter);
                            } else {
                                int count = Integer.parseInt(dataList.get(index).get("count"), 10) + 1;
                                map.put("count", String.valueOf(count));
                                dataList.set(index, map);
                                adapter.notifyDataSetChanged();
                            }
                        } else {
                            Toast.makeText(KillTagActivity.this, "不指定标签销毁标签失败", Toast.LENGTH_SHORT).show();
                        }
                    }
                } else {//循环
                    if (CkWithUiiKill.isChecked()) {//指定标签
                        String uiiStr = EtTagUiiKill.getText().toString().trim();
                        if (uiiStr.equals("")) {
                            Toast.makeText(KillTagActivity.this, "标签号不能为空", Toast.LENGTH_SHORT).show();
                            return;
                        }
                        if (!Function.isHex(uiiStr)) {
                            Toast.makeText(KillTagActivity.this, "标签号必须为十六进制数据", Toast.LENGTH_SHORT).show();
                            return;
                        }
                        boolean isSuccess = uhfH.startKillLoopFromSingleTag(UhfH.UII.getNewInstanceByBytes(Function.HexStringToBytes(uiiStr), 0), new UhfH.OnKillListener() {
                            @Override
                            public void onKill(UhfH.Result.KillResult result) {
                                if (result.isSuccess()) {
                                    Message msg = handler.obtainMessage();
                                    Bundle bundle = new Bundle();
                                    bundle.putString("uii", Function.bytesToHexString(result.getUii().getBytes(), result.getUii().getUiiLength()));
                                    msg.setData(bundle);
                                    handler.sendMessage(msg);
                                }
                            }
                        });
                        if (isSuccess) {
                            BtUiiKill.setEnabled(false);
                            BtKill.setText("停止");
                        } else {
                            Toast.makeText(KillTagActivity.this, "开启指定标签循销毁标签失败", Toast.LENGTH_SHORT).show();
                        }
                    } else {//不指定标签
                        boolean isSuccess = uhfH.startKillLoopFromUnSpecifiedTag(new UhfH.OnKillListener() {
                            @Override
                            public void onKill(UhfH.Result.KillResult result) {
                                if (result.isSuccess()) {
                                    Message msg = handler.obtainMessage();
                                    Bundle bundle = new Bundle();
                                    bundle.putString("uii", Function.bytesToHexString(result.getUii().getBytes(), result.getUii().getUiiLength()));
                                    msg.setData(bundle);
                                    handler.sendMessage(msg);
                                }
                            }
                        });
                        if (isSuccess) {
                            BtUiiKill.setEnabled(false);
                            BtKill.setText("停止");
                        } else {
                            Toast.makeText(KillTagActivity.this, "开启不指定标签循环销毁标签失败", Toast.LENGTH_SHORT).show();
                        }
                    }
                }
            } else {
                uhfH.stopLoopOperate();
                BtKill.setText("销毁标签");
                BtUiiKill.setEnabled(true);
            }
        }
    }
    
    public int checkIsExist(String uiiStr, ArrayList<HashMap<String, String>> tagList) {
        int existFlag = -1;
        String tempUiiStr = "";
        
        for (int i = 0; i < tagList.size(); i++) {
            HashMap<String, String> temp = new HashMap<String, String>();
            temp = tagList.get(i);
            tempUiiStr = temp.get("uii");
            if (uiiStr != "" && uiiStr.equals(tempUiiStr)) {
                existFlag = i;
            }
        }
        
        return existFlag;
    }
    
    Handler handler = new Handler() {
        
        @Override
        public void handleMessage(Message msg) {
            Bundle bundle = msg.getData();
            String uiiStr = bundle.getString("uii");
            
            HashMap<String, String> map = new HashMap<String, String>();
            map.put("uii", uiiStr);
            map.put("count", String.valueOf(1));
            
            int index = -1;
            if (!uiiStr.equals(null)) {
                index = checkIsExist(uiiStr, dataList);
                if (index == -1) {
                    dataList.add(map);
                    LvKill.setAdapter(adapter);
                } else {
                    int count = Integer.parseInt(dataList.get(index).get("count"), 10) + 1;
                    map.put("count", String.valueOf(count));
                    dataList.set(index, map);
                    adapter.notifyDataSetChanged();
                }
            }
        }
    };
    
    class BtClearKillClickListener implements OnClickListener {
        
        @Override
        public void onClick(View arg0) {
            
            dataList.clear();
            adapter.notifyDataSetChanged();
        }
    }
    
    @Override
    public void onBackPressed() {
        uhfH.stopLoopOperate();
        super.onBackPressed();
    }
}
