package com.thomas;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import android.app.Activity;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.CompoundButton.OnCheckedChangeListener;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.RadioButton;
import android.widget.SimpleAdapter;
import android.widget.Spinner;
import android.widget.Toast;

import com.senter.iot.support.openapi.uhf.UhfH;


public class LockTagActivity extends Activity {
    CheckBox CkWithUiiLock;
    RadioButton RbLockSingle;
    RadioButton RbLockLoop;
    Spinner SpinnerBankLock;
    Spinner SpinnerLockStyle;
    Spinner SpinnerLockProperty;
    Spinner SpinnerSafetyProperty;
    ListView LvLock;
    EditText EtTagUiiLock;
    Button BtUiiLock;
    Button BtLock;
    Button BtClearLock;
    
    List<BankItem> list = new ArrayList<>();
    @SuppressWarnings("rawtypes")
    ArrayAdapter adapterBank;
    static ArrayList<HashMap<String, String>> dataList;
    SimpleAdapter adapter;
    
    private UhfH uhfH;
    
    @SuppressWarnings({"unchecked", "rawtypes"})
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.locktag);
        uhfH = UhfH.getInstance();
        
        dataList = new ArrayList<HashMap<String, String>>();
        adapter = new SimpleAdapter(LockTagActivity.this,
                                    dataList,
                                    R.layout.locktag_items,
                                    new String[]{"uii", "count"},
                                    new int[]{R.id.TvUii_Lock, R.id.TvCount_Lock});
        
        CkWithUiiLock = (CheckBox) findViewById(R.id.CkWithUiiLock);
        RbLockSingle = (RadioButton) findViewById(R.id.RbLockSingle);
        RbLockLoop = (RadioButton) findViewById(R.id.RbLockLoop);
        SpinnerBankLock = (Spinner) findViewById(R.id.SpinnerBankLock);
        SpinnerLockStyle = (Spinner) findViewById(R.id.SpinnerLockStyle);
        SpinnerLockProperty = (Spinner) findViewById(R.id.SpinnerLockProperty);
        SpinnerSafetyProperty = (Spinner) findViewById(R.id.SpinnerSafetyProperty);
        EtTagUiiLock = (EditText) findViewById(R.id.EtTagUiiLock);
        LvLock = (ListView) findViewById(R.id.LvLock);
        BtUiiLock = (Button) findViewById(R.id.BtUiiLock);
        BtLock = (Button) findViewById(R.id.BtLock);
        BtClearLock = (Button) findViewById(R.id.BtClearLock);
        
        CkWithUiiLock.setOnCheckedChangeListener(new CkWithUiiLockCheckedChangeListener());
        BtUiiLock.setOnClickListener(new BtUiiLockClickListener());
        BtClearLock.setOnClickListener(new BtClearLockClickListener());
        BtLock.setOnClickListener(new BtLockClickListener());
        
        list = Bank.InitBankItemListByProType(uhfH.getProSel().getProtocol());
        adapterBank = new ArrayAdapter(this, R.layout.bank, R.id.TvBank, list);
        SpinnerBankLock.setAdapter(adapterBank);
    }
    
    class CkWithUiiLockCheckedChangeListener implements OnCheckedChangeListener {
        
        @Override
        public void onCheckedChanged(CompoundButton arg0, boolean arg1) {
            if (arg1) {
                EtTagUiiLock.setEnabled(true);
            } else {
                EtTagUiiLock.setEnabled(false);
            }
        }
    }
    
    class BtUiiLockClickListener implements OnClickListener {
        
        @Override
        public void onClick(View arg0) {
            if (CkWithUiiLock.isChecked()) {
                UhfH.UII uii = uhfH.inventorySingleTagOnce();
                if (uii != null) {
                    EtTagUiiLock.setText(Function.bytesToHexString(uii.getBytes(), uii.getUiiLength()));
                } else {
                    Toast.makeText(LockTagActivity.this, "读取标签号失败", Toast.LENGTH_SHORT).show();
                }
            }
        }
    }
    
    class BtLockClickListener implements OnClickListener {
        
        @Override
        public void onClick(View arg0) {
            if (BtLock.getText().toString().trim().equals("锁定标签")) {
                UhfH.LockStyle lockStyle = null;
                switch (SpinnerLockStyle.getSelectedItemPosition()) {
                    case 0:
                        lockStyle = UhfH.LockStyle.StorageAreaProperty;
                        break;
                    case 1:
                        lockStyle = UhfH.LockStyle.SafeMode;
                        break;
                }
                
                UhfH.LockProperty lockProperty = null;
                switch (SpinnerLockProperty.getSelectedItemPosition()) {
                    case 0:
                        lockProperty = UhfH.LockProperty.Read_Write;
                        break;
                    case 1:
                        lockProperty = UhfH.LockProperty.Read_noWrite;
                        break;
                    case 2:
                        lockProperty = UhfH.LockProperty.noRead_Write;
                        break;
                    case 3:
                        lockProperty = UhfH.LockProperty.noRead_noWrite;
                        break;
                }
                
                UhfH.SafetyProperty safetyProperty = null;
                switch (SpinnerSafetyProperty.getSelectedItemPosition()) {
                    case 0:
                        safetyProperty = UhfH.SafetyProperty.Reserve;
                        break;
                    case 1:
                        safetyProperty = UhfH.SafetyProperty.noIdentity;
                        break;
                    case 2:
                        safetyProperty = UhfH.SafetyProperty.Identity_noSafe_Communication;
                        break;
                    case 3:
                        safetyProperty = UhfH.SafetyProperty.Identity_Safe_Communication;
                        break;
                }
                
                if (RbLockSingle.isChecked()) {//单步
                    if (CkWithUiiLock.isChecked()) {//指定标签
                        String uiiStr = EtTagUiiLock.getText().toString().trim();
                        if (uiiStr.equals("")) {
                            Toast.makeText(LockTagActivity.this, "标签号不能为空", Toast.LENGTH_SHORT).show();
                            return;
                        }
                        if (!Function.isHex(uiiStr)) {
                            Toast.makeText(LockTagActivity.this, "标签号必须为十六进制数据", Toast.LENGTH_SHORT).show();
                            return;
                        }
                        UhfH.Result.LockResult result = uhfH.lockOnceFromSingleTag(list.get(SpinnerBankLock.getSelectedItemPosition()).getBank(), UhfH.UII.getNewInstanceByBytes
                                                                                           (Function.HexStringToBytes(uiiStr), 0), lockStyle,
                                                                                   lockProperty,
                                                                                   safetyProperty);
                        if (result.isSuccess()) {
                            HashMap<String, String> map = new HashMap<String, String>();
                            map.put("uii", uiiStr);
                            map.put("count", String.valueOf(1));
                            int index = checkIsExist(uiiStr, dataList);
                            if (index == -1) {
                                dataList.add(map);
                                LvLock.setAdapter(adapter);
                            } else {
                                int count = Integer.parseInt(dataList.get(index).get("count"), 10) + 1;
                                map.put("count", String.valueOf(count));
                                dataList.set(index, map);
                                adapter.notifyDataSetChanged();
                            }
                        } else {
                            Toast.makeText(LockTagActivity.this, "指定标签锁定标签失败", Toast.LENGTH_SHORT).show();
                        }
                    } else {//不指定标签
                        UhfH.Result.LockResult result = uhfH.lockOnceFromUnSpecifiedTag(list.get(SpinnerBankLock.getSelectedItemPosition()).getBank(), lockStyle, lockProperty, safetyProperty);
                        if (result.isSuccess()) {
                            String uiiStr = Function.bytesToHexString(result.getUii().getBytes(), result.getUii().getUiiLength());
                            HashMap<String, String> map = new HashMap<String, String>();
                            map.put("uii", uiiStr);
                            map.put("count", String.valueOf(1));
                            int index = checkIsExist(uiiStr, dataList);
                            if (index == -1) {
                                dataList.add(map);
                                LvLock.setAdapter(adapter);
                            } else {
                                int count = Integer.parseInt(dataList.get(index).get("count"), 10) + 1;
                                map.put("count", String.valueOf(count));
                                dataList.set(index, map);
                                adapter.notifyDataSetChanged();
                            }
                        } else {
                            Toast.makeText(LockTagActivity.this, "不指定标签锁定标签失败", Toast.LENGTH_SHORT).show();
                        }
                    }
                } else {//循环
                    if (CkWithUiiLock.isChecked()) {//指定标签
                        String uiiStr = EtTagUiiLock.getText().toString().trim();
                        if (uiiStr.equals("")) {
                            Toast.makeText(LockTagActivity.this, "标签号不能为空", Toast.LENGTH_SHORT).show();
                            return;
                        }
                        if (!Function.isHex(uiiStr)) {
                            Toast.makeText(LockTagActivity.this, "标签号必须为十六进制数据", Toast.LENGTH_SHORT).show();
                            return;
                        }
                        boolean isSuccess = uhfH.startLockLoopFromSingleTag(list.get(SpinnerBankLock.getSelectedItemPosition()).getBank(), UhfH.UII.getNewInstanceByBytes(Function.HexStringToBytes(uiiStr), 0),
                                                                            lockStyle, lockProperty,
                                                                            safetyProperty, new UhfH.OnLockListener() {
                                    @Override
                                    public void onLock(UhfH.Result.LockResult result) {
                                        if (result.isSuccess()) {
                                            Message msg = handler.obtainMessage();
                                            Bundle bundle = new Bundle();
                                            bundle.putString("uii", Function.bytesToHexString(result.getUii().getBytes(), result.getUii().getUiiLength()));
                                            msg.setData(bundle);
                                            handler.sendMessage(msg);
                                        }
                                    }
                                });
                        if (isSuccess) {
                            BtUiiLock.setEnabled(false);
                            BtLock.setText("停止");
                        } else {
                            Toast.makeText(LockTagActivity.this, "开启指定标签循锁定标签失败", Toast.LENGTH_SHORT).show();
                        }
                    } else {//不指定标签
                        boolean isSuccess = uhfH.startLockLoopFromUnSpecifiedTag(list.get(SpinnerBankLock.getSelectedItemPosition()).getBank(), lockStyle, lockProperty, safetyProperty, new
                                UhfH.OnLockListener() {
                                    @Override
                                    public void onLock(UhfH.Result.LockResult result) {
                                        if (result.isSuccess()) {
                                            Message msg = handler.obtainMessage();
                                            Bundle bundle = new Bundle();
                                            bundle.putString("uii", Function.bytesToHexString(result.getUii().getBytes(), result.getUii().getUiiLength()));
                                            msg.setData(bundle);
                                            handler.sendMessage(msg);
                                        }
                                    }
                                });
                        if (isSuccess) {
                            BtUiiLock.setEnabled(false);
                            BtLock.setText("停止");
                        } else {
                            Toast.makeText(LockTagActivity.this, "开启不指定标签循环锁定标签失败", Toast.LENGTH_SHORT).show();
                        }
                    }
                }
            } else {
                uhfH.stopLoopOperate();
                BtLock.setText("锁定标签");
                BtUiiLock.setEnabled(true);
            }
        }
    }
    
    public int checkIsExist(String uiiStr, ArrayList<HashMap<String, String>> tagList) {
        int existFlag = -1;
        String tempUiiStr = "";
        
        for (int i = 0; i < tagList.size(); i++) {
            HashMap<String, String> temp = new HashMap<String, String>();
            temp = tagList.get(i);
            tempUiiStr = temp.get("uii");
            if (uiiStr != "" && uiiStr.equals(tempUiiStr)) {
                existFlag = i;
            }
        }
        
        return existFlag;
    }
    
    Handler handler = new Handler() {
        
        @Override
        public void handleMessage(Message msg) {
            Bundle bundle = msg.getData();
            String uiiStr = bundle.getString("uii");
            
            HashMap<String, String> map = new HashMap<String, String>();
            map.put("uii", uiiStr);
            map.put("count", String.valueOf(1));
            
            int index = -1;
            if (!uiiStr.equals(null)) {
                index = checkIsExist(uiiStr, dataList);
                if (index == -1) {
                    dataList.add(map);
                    LvLock.setAdapter(adapter);
                } else {
                    int count = Integer.parseInt(dataList.get(index).get("count"), 10) + 1;
                    map.put("count", String.valueOf(count));
                    dataList.set(index, map);
                    adapter.notifyDataSetChanged();
                }
            }
        }
    };
    
    class BtClearLockClickListener implements OnClickListener {
        
        @Override
        public void onClick(View arg0) {
            
            dataList.clear();
            adapter.notifyDataSetChanged();
        }
    }
    
    @Override
    public void onBackPressed() {
        uhfH.stopLoopOperate();
        super.onBackPressed();
    }
}
