package com.thomas;

import java.util.ArrayList;
import java.util.HashMap;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.view.Menu;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ListView;
import android.widget.SimpleAdapter;
import android.widget.Toast;

import com.senter.iot.support.openapi.uhf.UhfH;

public class MainActivity extends Activity {
    
    ListView LvMain;
    private ArrayList<HashMap<String, String>> arrayMenu;
    private SimpleAdapter adapter;
    
    private UhfH uhfH;
    
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        uhfH = UhfH.getInstance();
        arrayMenu = new ArrayList<HashMap<String, String>>();
        
        LvMain = (ListView) findViewById(R.id.mainLv);
        /**/
        
        //初始化arrayMenu
        String[] array = {"通信初始化", "盘点标签", "防碰撞读数据", "读取数据", "写入数据", "擦除数据", "锁定标签", "销毁标签",
                "功率设置", "频率设置", "天线设置", "寄存器访问", "基本设置", "协议参数设置", "安全管理", "获取随机数", "固件升级",
                "退出"};
        
        for (int i = 0; i < array.length; i++) {
            HashMap<String, String> item = new HashMap<String, String>();
            item.put("menuItem", array[i]);
            arrayMenu.add(item);
        }
        
        adapter = new SimpleAdapter(this,
                                    arrayMenu, //数据源
        
                                    R.layout.mainlv_items,//ListItem的XML实现
                                    new String[]{"menuItem"}, //动态数组与Item对应的子项
                                    new int[]{R.id.TvMenu //子项的id定义
                                    });
        
        LvMain.setAdapter(adapter);
        LvMain.setOnItemClickListener(new LvMainItemClickListener());
    }
    
    @SuppressWarnings("unchecked")
    class LvMainItemClickListener implements OnItemClickListener {
        
        @Override
        public void onItemClick(AdapterView<?> parent, View view, int position,
                                long id) {
            HashMap<String, String> item = (HashMap<String, String>) LvMain.getItemAtPosition(position);
            String itemStr = item.get("menuItem");
            
            if (itemStr.equals("通信初始化")) {
                Intent intent = new Intent();
                intent.setClass(MainActivity.this, InitActivity.class);
                startActivity(intent);
            } else if (itemStr.equals("盘点标签")) {
                if (!UhfH.getInstance().isInited()) {
                    Toast.makeText(getApplicationContext(), "请先进行连接", Toast.LENGTH_SHORT).show();
                    return;
                }
                Intent intent = new Intent();
                intent.setClass(MainActivity.this, InventoryActivity.class);
                startActivity(intent);
            } else if (itemStr.equals("防碰撞读数据")) {
                if (!UhfH.getInstance().isInited()) {
                    Toast.makeText(getApplicationContext(), "请先进行连接", Toast.LENGTH_SHORT).show();
                    return;
                }
                Intent intent = new Intent();
                intent.setClass(MainActivity.this, ReadMultiTagsActivity.class);
                startActivity(intent);
            } else if (itemStr.equals("读取数据")) {
                if (!UhfH.getInstance().isInited()) {
                    Toast.makeText(getApplicationContext(), "请先进行连接", Toast.LENGTH_SHORT).show();
                    return;
                }
                Intent intent = new Intent();
                intent.setClass(MainActivity.this, ReadTagActivity.class);
                startActivity(intent);
            } else if (itemStr.equals("写入数据")) {
                if (!UhfH.getInstance().isInited()) {
                    Toast.makeText(getApplicationContext(), "请先进行连接", Toast.LENGTH_SHORT).show();
                    return;
                }
                Intent intent = new Intent();
                intent.setClass(MainActivity.this, WriteTagActivity.class);
                startActivity(intent);
            } else if (itemStr.equals("擦除数据")) {
                if (!UhfH.getInstance().isInited()) {
                    Toast.makeText(getApplicationContext(), "请先进行连接", Toast.LENGTH_SHORT).show();
                    return;
                }
                Intent intent = new Intent();
                intent.setClass(MainActivity.this, EraseTagActivity.class);
                startActivity(intent);
            } else if (itemStr.equals("锁定标签")) {
                if (!UhfH.getInstance().isInited()) {
                    Toast.makeText(getApplicationContext(), "请先进行连接", Toast.LENGTH_SHORT).show();
                    return;
                }
                Intent intent = new Intent();
                intent.setClass(MainActivity.this, LockTagActivity.class);
                startActivity(intent);
            } else if (itemStr.equals("销毁标签")) {
                if (!UhfH.getInstance().isInited()) {
                    Toast.makeText(getApplicationContext(), "请先进行连接", Toast.LENGTH_SHORT).show();
                    return;
                }
                Intent intent = new Intent();
                intent.setClass(MainActivity.this, KillTagActivity.class);
                startActivity(intent);
            } else if (itemStr.equals("功率设置")) {
                if (!UhfH.getInstance().isInited()) {
                    Toast.makeText(getApplicationContext(), "请先进行连接", Toast.LENGTH_SHORT).show();
                    return;
                }
                Intent intent = new Intent();
                intent.setClass(MainActivity.this, PowerSettingsActivity.class);
                startActivity(intent);
            } else if (itemStr.equals("频率设置")) {
                if (!UhfH.getInstance().isInited()) {
                    Toast.makeText(getApplicationContext(), "请先进行连接", Toast.LENGTH_SHORT).show();
                    return;
                }
                Intent intent = new Intent();
                intent.setClass(MainActivity.this, FrequencySettingsActivity.class);
                startActivity(intent);
            } else if (itemStr.equals("天线设置")) {
                if (!UhfH.getInstance().isInited()) {
                    Toast.makeText(getApplicationContext(), "请先进行连接", Toast.LENGTH_SHORT).show();
                    return;
                }
                Intent intent = new Intent();
                intent.setClass(MainActivity.this, AntennaSettingsActivity.class);
                startActivity(intent);
            } else if (itemStr.equals("寄存器访问")) {
                if (!UhfH.getInstance().isInited()) {
                    Toast.makeText(getApplicationContext(), "请先进行连接", Toast.LENGTH_SHORT).show();
                    return;
                }
                Intent intent = new Intent();
                intent.setClass(MainActivity.this, RegisterSettingsActivity.class);
                startActivity(intent);
            } else if (itemStr.equals("基本设置")) {
                if (!UhfH.getInstance().isInited()) {
                    Toast.makeText(getApplicationContext(), "请先进行连接", Toast.LENGTH_SHORT).show();
                    return;
                }
                Intent intent = new Intent();
                intent.setClass(MainActivity.this, BaseSettingsActivity.class);
                startActivityForResult(intent, 2);
            } else if (itemStr.equals("协议参数设置")) {
                if (!UhfH.getInstance().isInited()) {
                    Toast.makeText(getApplicationContext(), "请先进行连接", Toast.LENGTH_SHORT).show();
                    return;
                }
                Intent intent = new Intent();
                intent.setClass(MainActivity.this, ProtocolParameterActivity.class);
                startActivity(intent);
            } else if (itemStr.equals("安全管理")) {
                if (!UhfH.getInstance().isInited()) {
                    Toast.makeText(getApplicationContext(), "请先进行连接", Toast.LENGTH_SHORT).show();
                    return;
                }
                Intent intent = new Intent();
                intent.setClass(MainActivity.this, SafetyManageActivity.class);
                startActivity(intent);
            } else if (itemStr.equals("获取随机数")) {
                if (!UhfH.getInstance().isInited()) {
                    Toast.makeText(getApplicationContext(), "请先进行连接", Toast.LENGTH_SHORT).show();
                    return;
                }
                Intent intent = new Intent();
                intent.setClass(MainActivity.this, RandomActivity.class);
                startActivity(intent);
            } else if (itemStr.equals("固件升级")) {
                if (!UhfH.getInstance().isInited()) {
                    Toast.makeText(getApplicationContext(), "请先进行连接", Toast.LENGTH_SHORT).show();
                    return;
                }
                Intent intent = new Intent();
                intent.setClass(MainActivity.this, UpdateActivity.class);
                startActivity(intent);
            } else if (itemStr.equals("退出")) {
                exit();
            }
        }
    }
    
    public void exit() {
        new AlertDialog.Builder(this)
                .setTitle("消息")
                .setMessage("确认退出！")
                .setPositiveButton("确定", new DialogInterface.OnClickListener() {
                    
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        if (uhfH.isInited()) {
                            uhfH.uninit();
                        }
                        System.exit(0);
                    }
                }).setNegativeButton("取消", new DialogInterface.OnClickListener() {
            
            @Override
            public void onClick(DialogInterface dialog, int which) {
                
            }
        }).show();
    }
    
    @Override
    public void onBackPressed() {
        exit();
    }
}
