package com.thomas;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.Spinner;
import android.widget.Toast;

import com.senter.iot.support.openapi.uhf.UhfH;


public class PowerSettingsActivity extends Activity {
    Spinner SpinnerPower;
    Button BtSetPower;
    Button BtGetPower;
    
    private UhfH uhfH;
    
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.powersettings);
        uhfH = UhfH.getInstance();
        SpinnerPower = (Spinner) findViewById(R.id.SpinnerPower);
        BtSetPower = (Button) findViewById(R.id.BtSetPower);
        BtGetPower = (Button) findViewById(R.id.BtGetPower);
        
        BtSetPower.setOnClickListener(new BtSetPowerClickListener());
        BtGetPower.setOnClickListener(new BtGetPowerClickListener());
    }
    
    class BtSetPowerClickListener implements OnClickListener {
        
        @Override
        public void onClick(View arg0) {
            int power = (byte) (SpinnerPower.getSelectedItemPosition() + 10);
            boolean isSuccess = uhfH.setPower(power);
            if (isSuccess) {
                Toast.makeText(PowerSettingsActivity.this, "设置功率成功，功率为：" + power + "dBm", Toast.LENGTH_SHORT).show();
            } else {
                Toast.makeText(PowerSettingsActivity.this, "设置功率失败", Toast.LENGTH_SHORT).show();
            }
        }
    }
    
    class BtGetPowerClickListener implements OnClickListener {
        
        @Override
        public void onClick(View arg0) {
            Integer power = uhfH.getPower();
            if (power != null) {
                SpinnerPower.setSelection(power - 10);
                Toast.makeText(PowerSettingsActivity.this, "读取功率成功，功率为：" + power + "dBm", Toast.LENGTH_SHORT).show();
            } else {
                Toast.makeText(PowerSettingsActivity.this, "读取功率失败", Toast.LENGTH_SHORT).show();
            }
        }
    }
    
}
