package com.thomas;

import java.util.ArrayList;
import java.util.List;

import android.app.Activity;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.Spinner;
import android.widget.Toast;

import com.senter.iot.support.openapi.uhf.UhfH;


public class ProtocolParameterActivity extends Activity {
    List<String> list = new ArrayList<String>();
    @SuppressWarnings("rawtypes")
    ArrayAdapter adapterBlf;
    
    Spinner SpinnerTc;
    Spinner SpinnerEncode;
    Spinner SpinnerBlf;
    Spinner SpinnerTRext;
    Spinner SpinnerSession;
    Button BtSetProCfg;
    Button BtGetProCfg;
    Button BtSetTRext;
    Button BtGetTRext;
    Button BtSetSession;
    Button BtGetSession;
    
    private UhfH uhfH;
    
    @SuppressWarnings({"unchecked", "rawtypes"})
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.protocolparameter);
        uhfH = UhfH.getInstance();
        
        SpinnerTc = (Spinner) findViewById(R.id.SpinnerTc);
        SpinnerEncode = (Spinner) findViewById(R.id.SpinnerEncode);
        SpinnerBlf = (Spinner) findViewById(R.id.SpinnerBlf);
        SpinnerTRext = (Spinner) findViewById(R.id.SpinnerTRext);
        SpinnerSession = (Spinner) findViewById(R.id.SpinnerSession);
        BtSetProCfg = (Button) findViewById(R.id.BtSetProCfg);
        BtGetProCfg = (Button) findViewById(R.id.BtGetProCfg);
        BtSetTRext = (Button) findViewById(R.id.BtSetTRext);
        BtGetTRext = (Button) findViewById(R.id.BtGetTRext);
        BtSetSession = (Button) findViewById(R.id.BtSetSession);
        BtGetSession = (Button) findViewById(R.id.BtGetSession);
        
        UhfH.Result.ProtocolResult result = uhfH.getProSel();
        list = GetBlf(result.getValue() & 0xFF);
        adapterBlf = new ArrayAdapter(this, R.layout.blf, R.id.TvBlf, list);
        SpinnerBlf.setAdapter(adapterBlf);
        
        BtSetProCfg.setOnClickListener(new BtSetProCfgClickListener());
        BtGetProCfg.setOnClickListener(new BtGetProCfgClickListener());
        BtSetTRext.setOnClickListener(new BtSetTRextClickListener());
        BtGetTRext.setOnClickListener(new BtGetTRextClickListener());
        BtSetSession.setOnClickListener(new BtSetSessionClickListener());
        BtGetSession.setOnClickListener(new BtGetSessionClickListener());
        
        GetProtocolParameter();
    }
    
    class BtSetProCfgClickListener implements OnClickListener {
        
        @Override
        public void onClick(View arg0) {
            
            UhfH.ProCfgTC tc = null;
            UhfH.ProCfgEncode encode = null;
            UhfH.ProCfgBLF blf = null;
            tc = UhfH.ProCfgTC.ValueOf(SpinnerTc.getSelectedItemPosition());
            encode = UhfH.ProCfgEncode.ValueOf(SpinnerEncode.getSelectedItemPosition());
            blf = UhfH.ProCfgBLF.ValueOf(uhfH.getProSel().getProtocol(), SpinnerBlf.getSelectedItemPosition());
            boolean isSuccess = uhfH.setProCfg(tc, encode, blf);
            if (isSuccess) {
                Toast.makeText(ProtocolParameterActivity.this, "设置 协议参数 成功", Toast.LENGTH_SHORT).show();
            } else {
                Toast.makeText(ProtocolParameterActivity.this, "设置 协议参数 失败", Toast.LENGTH_SHORT).show();
            }
        }
    }
    
    class BtGetProCfgClickListener implements OnClickListener {
        
        @Override
        public void onClick(View arg0) {
            UhfH.Result.ProCfgResult result = uhfH.getProCfg();
            if (result != null) {
                SpinnerTc.setSelection(result.getTc().getValue());
                SpinnerEncode.setSelection(result.getEncode().getValue());
                SpinnerBlf.setSelection(result.getBlf().getValue());
                Toast.makeText(ProtocolParameterActivity.this, "读取 协议参数 成功", Toast.LENGTH_SHORT).show();
            } else {
                Toast.makeText(ProtocolParameterActivity.this, "读取 协议参数 失败", Toast.LENGTH_SHORT).show();
            }
        }
    }
    
    class BtSetTRextClickListener implements OnClickListener {
        
        @Override
        public void onClick(View arg0) {
            UhfH.TRext trext = null;
            switch (SpinnerTRext.getSelectedItemPosition()) {
                case 0:
                    trext = UhfH.TRext.Reverse_Link_Preamble_Without_Preamble_Signal;
                    break;
                case 1:
                    trext = UhfH.TRext.Reverse_Link_Preamble_With_Preamble_Signal;
                    break;
            }
            boolean isSuccess = uhfH.setTRext(trext);
            if (isSuccess) {
                Toast.makeText(ProtocolParameterActivity.this, "设置 TRext 成功", Toast.LENGTH_SHORT).show();
            } else {
                Toast.makeText(ProtocolParameterActivity.this, "设置 TRext 失败", Toast.LENGTH_SHORT).show();
            }
        }
    }
    
    class BtGetTRextClickListener implements OnClickListener {
        
        @Override
        public void onClick(View arg0) {
            UhfH.TRext trext = uhfH.getTRext();
            if (trext != null) {
                SpinnerTRext.setSelection(trext.getValue());
                Toast.makeText(ProtocolParameterActivity.this, "读取 TRext 成功", Toast.LENGTH_SHORT).show();
            } else {
                Toast.makeText(ProtocolParameterActivity.this, "读取 TRext 失败", Toast.LENGTH_SHORT).show();
            }
        }
    }
    
    class BtSetSessionClickListener implements OnClickListener {
        
        @Override
        public void onClick(View arg0) {
            UhfH.Session session = null;
            switch (SpinnerSession.getSelectedItemPosition()) {
                case 0:
                    session = UhfH.Session.S0;
                    break;
                case 1:
                    session = UhfH.Session.S1;
                    break;
                case 2:
                    session = UhfH.Session.S2;
                    break;
                case 3:
                    session = UhfH.Session.S3;
                    break;
                case 4:
                    session = UhfH.Session.MatchFlag;
                    break;
            }
            boolean isSuccess = uhfH.setSession(session);
            if (isSuccess) {
                Toast.makeText(ProtocolParameterActivity.this, "设置 SESSION 成功", Toast.LENGTH_SHORT).show();
            } else {
                Toast.makeText(ProtocolParameterActivity.this, "设置 SESSION 失败", Toast.LENGTH_SHORT).show();
            }
        }
    }
    
    class BtGetSessionClickListener implements OnClickListener {
        
        @Override
        public void onClick(View arg0) {
            UhfH.Session session = uhfH.getSession();
            if (session != null) {
                SpinnerSession.setSelection(session.getValue());
                Toast.makeText(ProtocolParameterActivity.this, "读取 SESSION 成功", Toast.LENGTH_SHORT).show();
            } else {
                Toast.makeText(ProtocolParameterActivity.this, "读取 SESSION 失败", Toast.LENGTH_SHORT).show();
            }
        }
    }
    
    private void GetProtocolParameter() {
        //读取ProCfg
        UhfH.Result.ProCfgResult proCfgResult = uhfH.getProCfg();
        if (proCfgResult != null) {
            SpinnerTc.setSelection(proCfgResult.getTc().getValue());
            SpinnerEncode.setSelection(proCfgResult.getEncode().getValue());
            SpinnerBlf.setSelection(proCfgResult.getBlf().getValue());
//			Toast.makeText(ProtocolParameterActivity.this, "读取 协议参数 成功", Toast.LENGTH_SHORT).show();
        } else {
            Toast.makeText(ProtocolParameterActivity.this, "读取 协议参数 失败", Toast.LENGTH_SHORT).show();
        }
        
        //读取TREXT
        UhfH.TRext trext = uhfH.getTRext();
        if (trext != null) {
            SpinnerTRext.setSelection(trext.getValue());
//			Toast.makeText(ProtocolParameterActivity.this, "读取 TRext 成功", Toast.LENGTH_SHORT).show();
        } else {
            Toast.makeText(ProtocolParameterActivity.this, "读取 TRext 失败", Toast.LENGTH_SHORT).show();
        }
        
        //读取SESSION
        UhfH.Session session = uhfH.getSession();
        if (session != null) {
            SpinnerSession.setSelection(session.getValue());
//			Toast.makeText(ProtocolParameterActivity.this, "读取 SESSION 成功", Toast.LENGTH_SHORT).show();
        } else {
            Toast.makeText(ProtocolParameterActivity.this, "读取 SESSION 失败", Toast.LENGTH_SHORT).show();
        }
    }
    
    private List<String> GetBlf(int proType) {
        
        List<String> list = new ArrayList<String>();
        
        if (proType == 0x01 || proType == 0x81) {
            list.clear();
            
            list.add("80KHz");
            list.add("128KHz");
            list.add("160KHz");
            list.add("213.3333333KHz");
            list.add("284.4444444KHz");
            list.add("341.3333333KHz");
            list.add("426.6666667KHz");
            list.add("568.8888889KHz");
        } else if (proType == 0x02 || proType == 0x82 || proType == 0x08 || proType == 0x88) {
            list.clear();
            list.add("64KHz");
            list.add("137.14KHz");
            list.add("174.55KHz");
            list.add("320KHz");
            list.add("128KHz");
            list.add("274.29KHz");
            list.add("349.09KHz");
            list.add("640KHz");
        } else if (proType == 0x04 || proType == 0x84) {
            list.clear();
            list.add("640KHz");
            list.add("320KHz");
            list.add("160KHz");
        }
        
        return list;
    }
}
