package com.thomas;

import android.app.Activity;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.RadioButton;
import android.widget.Toast;

import com.senter.iot.support.openapi.uhf.UhfH;


public class RandomActivity extends Activity {
    
    RadioButton Rb8Bytes;
    RadioButton Rb16Bytes;
    EditText EtRandom;
    Button BtRandom;
    
    private UhfH uhfH;
    
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.random);
        uhfH = UhfH.getInstance();
        
        Rb8Bytes = (RadioButton) findViewById(R.id.Rb8Bytes);
        Rb16Bytes = (RadioButton) findViewById(R.id.Rb16Bytes);
        EtRandom = (EditText) findViewById(R.id.EtRandom);
        BtRandom = (Button) findViewById(R.id.BtRandom);
        
        BtRandom.setOnClickListener(new BtRandomClickListener());
    }
    
    class BtRandomClickListener implements OnClickListener {
        
        @Override
        public void onClick(View arg0) {
            UhfH.RandomOption randomOption = null;
            if (Rb8Bytes.isChecked()) {
                randomOption = UhfH.RandomOption.Random8;
            } else {
                randomOption = UhfH.RandomOption.Random16;
            }
            String randomStr = uhfH.getRandom(randomOption);
            if (randomStr != null) {
                EtRandom.setText(randomStr);
                Toast.makeText(RandomActivity.this, "获取随机数 成功", Toast.LENGTH_SHORT).show();
            } else {
                Toast.makeText(RandomActivity.this, "获取随机数 失败", Toast.LENGTH_SHORT).show();
            }
        }
    }
}
