package com.thomas;

import java.util.ArrayList;
import java.util.HashMap;

import android.app.Activity;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.ListView;
import android.widget.SimpleAdapter;
import android.widget.TextView;
import android.widget.Toast;

import com.senter.iot.support.openapi.uhf.UhfH;


public class ReadDataShowActivity extends Activity {
    
    private static String optionRead;
    private BankItem bank1;
    private int ptr1;
    private int cnt1;
    private BankItem bank2;
    private int ptr2;
    private int cnt2;
    byte[] address = new byte[2];
    byte[] status = new byte[1];
    
    static ArrayList<HashMap<String, String>> dataList;
    SimpleAdapter adapter;
    
    ListView LvAntiRead;
    Button BtStop;
    Button BtBack1;
    TextView TvTagUii_Data;
    TextView TvBank_Data;
    TextView TvPtr_Data;
    TextView TvLen_Data;
    TextView TvCount_Data;
    TextView TvData_Data;
    TextView TvStatus_Data;
    
    private UhfH uhfH;
    
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.antireaddatalist);
        uhfH = UhfH.getInstance();
        optionRead = this.getIntent().getStringExtra("optionRead");
        
        bank1 = this.getIntent().getParcelableExtra("bank1");
        Log.d("mine", "bank1-->" + (bank1 != null));
        ptr1 = this.getIntent().getIntExtra("ptr1", 0);
        cnt1 = this.getIntent().getIntExtra("cnt1", 0);
        if (optionRead == "2级") {
            bank2 = this.getIntent().getParcelableExtra("bank2");
            ptr2 = this.getIntent().getIntExtra("ptr2", 0);
            cnt2 = this.getIntent().getIntExtra("cnt2", 0);
        }
        
        dataList = new ArrayList<HashMap<String, String>>();
        
        adapter = new SimpleAdapter(ReadDataShowActivity.this,
                                    dataList,
                                    R.layout.antireaddatalist_items,
                                    new String[]{"tagUii_Data", "bank_Data", "ptr_Data", "len_Data", "count_Data", "data_Data", "status_Data"},
                                    new int[]{R.id.TvTagUii_Data, R.id.TvBank_Data, R.id.TvPtr_Data, R.id.TvLen_Data, R.id.TvCount_Data, R.id.TvData_Data, R.id.TvStatus_Data});
        
        LvAntiRead = (ListView) findViewById(R.id.LvAntiRead);
        BtStop = (Button) findViewById(R.id.BtStop);
        BtBack1 = (Button) findViewById(R.id.BtBack1);
        TvTagUii_Data = (TextView) findViewById(R.id.TvTagUii_Data);
        TvBank_Data = (TextView) findViewById(R.id.TvBank_Data);
        TvPtr_Data = (TextView) findViewById(R.id.TvPtr_Data);
        TvLen_Data = (TextView) findViewById(R.id.TvLen_Data);
        TvCount_Data = (TextView) findViewById(R.id.TvCount_Data);
        TvData_Data = (TextView) findViewById(R.id.TvData_Data);
        TvStatus_Data = (TextView) findViewById(R.id.TvStatus_Data);
        
        BtStop.setOnClickListener(new BtStopClickListener());
        BtBack1.setOnClickListener(new BtBackClickListener());
        
        startReadData();
    }
    
    class BtStopClickListener implements OnClickListener {
        
        @Override
        public void onClick(View arg0) {
            
            if (BtStop.getText().equals("停止")) {
                uhfH.stopLoopOperate();
                BtStop.setText("继续");
            } else {
                startReadData();
                BtStop.setText("停止");
            }
        }
    }
    
    class BtBackClickListener implements OnClickListener {
        
        @Override
        public void onClick(View arg0) {
            
            onBackPressed();
        }
    }
    
    private void startReadData() {
        if (optionRead.equals("1级")) {
            boolean isSuccess = uhfH.startReadMultiTagsOneBankLoop(bank1.getBank(), ptr1, cnt1, new UhfH.OnReadListener() {
                @Override
                public void onRead(UhfH.Result.ReadResult result) {
                    Message msg = handler.obtainMessage();
                    Bundle bundle = new Bundle();
                    bundle.putString("uiiStr", Function.bytesToHexString(result.getUii().getBytes(), result.getUii().getUiiLength()));
                    bundle.putString("dataStr", Function.bytesToHexString(result.getData(), result.getData().length));
                    bundle.putString("bank", bank1.getName());
                    bundle.putString("ptr", String.valueOf(ptr1));
                    bundle.putString("cnt", String.valueOf(cnt1));
                    bundle.putString("status", "成功");
                    msg.setData(bundle);
                    handler.sendMessage(msg);
                }
            });
            if (!isSuccess) {
                Toast.makeText(getApplicationContext(), "开启防碰撞读数据失败", Toast.LENGTH_SHORT).show();
                return;
            }
        } else {
            boolean isSuccess = uhfH.startReadMultiTagsTwoBankLoop(bank1.getBank(), ptr1, cnt1, bank2.getBank(), ptr2, cnt2, new UhfH.OnTwoBankReadListener() {
                @Override
                public void onRead(UhfH.Result.ReadTwoBankResult result) {
                    Message msg = handler.obtainMessage();
                    Bundle bundle = new Bundle();
                    //1级存储区
                    bundle.putString("uiiStr", Function.bytesToHexString(result.getUii().getBytes(), result.getUii().getUiiLength()));
                    bundle.putString("dataStr", Function.bytesToHexString(result.getData1(), result.getData1().length));
                    
                    bundle.putString("bank", bank1.getName());
                    /*
                    if(bank1 == 0)
						bundle.putString("bank", "RESERVED");
					else if(bank1 == 1)
						bundle.putString("bank", "UII");
					else if(bank1 == 2)
						bundle.putString("bank", "TID");
					else
						bundle.putString("bank", "USER");
					*/
                    bundle.putString("ptr", String.valueOf(ptr1));
                    bundle.putString("cnt", String.valueOf(cnt1));
                    bundle.putString("status", "成功");
                    
                    msg.setData(bundle);
                    handler.sendMessage(msg);
                    //2级存储区
                    Message msg1 = handler.obtainMessage();
                    Bundle bundle1 = new Bundle();
                    bundle1.putString("uiiStr", Function.bytesToHexString(result.getUii().getBytes(), result.getUii().getUiiLength()));
                    bundle1.putString("dataStr", Function.bytesToHexString(result.getData2(), result.getData2().length));
                    
                    bundle.putString("bank", bank2.getName());
                    /*
                    if(bank2 == 0)
						bundle1.putString("bank", "RESERVED");
					else if(bank2 == 1)
						bundle1.putString("bank", "UII");
					else if(bank2 == 2)
						bundle1.putString("bank", "TID");
					else
						bundle1.putString("bank", "USER");
					*/
                    bundle1.putString("ptr", String.valueOf(ptr2));
                    bundle1.putString("cnt", String.valueOf(cnt2));
                    bundle1.putString("status", "成功");
                    
                    msg1.setData(bundle1);
                    handler.sendMessage(msg1);
                }
            });
            if (!isSuccess) {
                Toast.makeText(getApplicationContext(), "开启防碰撞读数据失败", Toast.LENGTH_SHORT).show();
                return;
            }
        }
    }
    
    public int checkIsExist(String uiiStr, String bankStr, String ptrStr, String lenStr, String dataStr, String errorStr, ArrayList<HashMap<String, String>> tagList) {
        int existFlag = -1;
        String tempUiiStr = "";
        String tempBankStr = "";
        String tempPtrStr = "";
        String tempLenStr = "";
        String tempDataStr = "";
        String tempStatusStr = "";
        
        for (int i = 0; i < tagList.size(); i++) {
            HashMap<String, String> temp = new HashMap<String, String>();
            temp = dataList.get(i);
            
            tempUiiStr = temp.get("tagUii_Data");
            tempBankStr = temp.get("bank_Data");
            tempPtrStr = temp.get("ptr_Data");
            tempLenStr = temp.get("len_Data");
            tempDataStr = temp.get("data_Data");
            tempStatusStr = temp.get("status_Data");
            
            if (uiiStr.equals(tempUiiStr) && bankStr.equals(tempBankStr) && ptrStr.equals(tempPtrStr) && lenStr.equals(tempLenStr) && dataStr.equals(tempDataStr) && errorStr.equals(tempStatusStr)) {
                existFlag = i;
            }
        }
        
        return existFlag;
    }
    
    Handler handler = new Handler() {
        
        @Override
        public void handleMessage(Message msg) {
            
            Bundle bundle = msg.getData();
            String uiiStr = bundle.getString("uiiStr");
            String dataStr = bundle.getString("dataStr");
            String bank = bundle.getString("bank");
            String ptr = bundle.getString("ptr");
            String cnt = bundle.getString("cnt");
            String status = bundle.getString("status");
            
            HashMap<String, String> map = new HashMap<String, String>();
            
            map.put("tagUii_Data", uiiStr);
            map.put("bank_Data", bank);
            map.put("ptr_Data", ptr);
            map.put("len_Data", cnt);
            map.put("count_Data", String.valueOf(1));
            map.put("data_Data", dataStr);
            map.put("status_Data", status);
            
            boolean bool = false;
            int index = -1;
            bool = (!uiiStr.equals(""));
            
            if (bool) {
                index = checkIsExist(uiiStr, bank, ptr, cnt, dataStr, status, dataList);
                
                if (index == -1) {
                    dataList.add(map);
                    LvAntiRead.setAdapter(adapter);
                } else {
                    int count = Integer.parseInt(dataList.get(index).get("count_Data"), 10) + 1;
                    
                    map.put("count_Data", String.valueOf(count));
                    
                    dataList.set(index, map);
                    adapter.notifyDataSetChanged();
                }
            }
        }
    };
    
    
    @Override
    public void onBackPressed() {
        uhfH.stopLoopOperate();
        super.onBackPressed();
    }
    
}
