package com.thomas;

import java.util.ArrayList;
import java.util.List;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.CompoundButton.OnCheckedChangeListener;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.Toast;

import com.senter.iot.support.openapi.uhf.UhfH;


public class ReadMultiTagsActivity extends Activity {
    
    List<BankItem> list = new ArrayList<>();
    List<BankItem> list2 = new ArrayList<>();
    @SuppressWarnings("rawtypes")
    ArrayAdapter adapterBank;
    @SuppressWarnings("rawtypes")
    ArrayAdapter adapterBank2;
    
    CheckBox ChkBoxSecondLevel;
    Spinner SpinnerBankAntiRead;
    Spinner SpinnerBank2AntiRead;
    EditText EtPtrAntiRead;
    EditText EtLenAntiRead;
    EditText EtPtr2AntiRead;
    EditText EtLen2AntiRead;
    
    Button BtAntiRead;
    
    private UhfH uhfH;
    
    @SuppressWarnings({"rawtypes", "unchecked"})
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.readmultitags);
        uhfH = UhfH.getInstance();
        
        ChkBoxSecondLevel = (CheckBox) findViewById(R.id.ChkBoxSecondLevel);
        SpinnerBankAntiRead = (Spinner) findViewById(R.id.SpinnerBankAntiRead);
        SpinnerBank2AntiRead = (Spinner) findViewById(R.id.SpinnerBank2AntiRead);
        EtPtrAntiRead = (EditText) findViewById(R.id.EtPtrAntiRead);
        EtLenAntiRead = (EditText) findViewById(R.id.EtLenAntiRead);
        EtPtr2AntiRead = (EditText) findViewById(R.id.EtPtr2AntiRead);
        EtLen2AntiRead = (EditText) findViewById(R.id.EtLen2AntiRead);
        BtAntiRead = (Button) findViewById(R.id.BtAntiRead);
        
        ChkBoxSecondLevel.setOnCheckedChangeListener(new ChkBoxSecondLevelCheckedChangeListener());
        BtAntiRead.setOnClickListener(new BtAntiReadClickListener());

//		EtPtrAntiRead.setKeyListener(null);
//		EtLenAntiRead.setKeyListener(null);
//		EtPtr2AntiRead.setKeyListener(null);
//		EtLen2AntiRead.setKeyListener(null);
        
        SpinnerBank2AntiRead.setEnabled(false);
        EtPtr2AntiRead.setEnabled(false);
        EtLen2AntiRead.setEnabled(false);
        
        UhfH.Protocol proSel = uhfH.getProSel().getProtocol();
        list = Bank.InitBankItemListByProType(proSel);
        list2 = Bank.InitBankItemListByProType(proSel);
        adapterBank = new ArrayAdapter(this, R.layout.bank, R.id.TvBank, list);
        adapterBank2 = new ArrayAdapter(this, R.layout.bank, R.id.TvBank, list2);
        SpinnerBankAntiRead.setAdapter(adapterBank);
        SpinnerBank2AntiRead.setAdapter(adapterBank2);
    }
    
    class BtAntiReadClickListener implements OnClickListener {
        
        @Override
        public void onClick(View arg0) {
            
            String ptrStr = EtPtrAntiRead.getText().toString().trim();
            if (ptrStr.equals("")) {
                Toast.makeText(getApplicationContext(), "地址不能为空", Toast.LENGTH_SHORT).show();
                return;
            } else if (!Function.isDecimal(ptrStr)) {
                Toast.makeText(getApplicationContext(), "地址必须为十进制数据", Toast.LENGTH_SHORT).show();
                return;
            }
            
            String lenStr = EtLenAntiRead.getText().toString().trim();
            if (lenStr.equals("")) {
                Toast.makeText(getApplicationContext(), "长度不能为空", Toast.LENGTH_SHORT).show();
                return;
            } else if (!Function.isDecimal(ptrStr)) {
                Toast.makeText(getApplicationContext(), "长度必须为十进制数据", Toast.LENGTH_SHORT).show();
                return;
            }
            
            if (!ChkBoxSecondLevel.isChecked()) {
                Intent intent = new Intent();
                intent.putExtra("optionRead", "1级");
                intent.putExtra("bank1", list.get(SpinnerBankAntiRead.getSelectedItemPosition()));
                intent.putExtra("ptr1", Integer.parseInt(ptrStr));
                intent.putExtra("cnt1", Integer.parseInt(lenStr));
                intent.setClass(ReadMultiTagsActivity.this, ReadDataShowActivity.class);
                startActivity(intent);
                
            } else {
                ptrStr = EtPtr2AntiRead.getText().toString().trim();
                if (ptrStr.equals("")) {
                    Toast.makeText(getApplicationContext(), "地址不能为空", Toast.LENGTH_SHORT).show();
                    return;
                } else if (!Function.isDecimal(ptrStr)) {
                    Toast.makeText(getApplicationContext(), "地址必须为十进制数据", Toast.LENGTH_SHORT).show();
                    return;
                }
                lenStr = EtLenAntiRead.getText().toString().trim();
                if (lenStr.equals("")) {
                    Toast.makeText(getApplicationContext(), "长度不能为空", Toast.LENGTH_SHORT).show();
                    return;
                } else if (!Function.isDecimal(ptrStr)) {
                    Toast.makeText(getApplicationContext(), "长度必须为十进制数据", Toast.LENGTH_SHORT).show();
                    return;
                }
                
                Intent intent = new Intent();
                intent.putExtra("optionRead", "2级");
                intent.putExtra("bank1", list.get(SpinnerBankAntiRead.getSelectedItemPosition()));
                intent.putExtra("ptr1", Integer.parseInt(ptrStr));
                intent.putExtra("cnt1", Integer.parseInt(lenStr));
                intent.putExtra("bank2", list2.get(SpinnerBank2AntiRead.getSelectedItemPosition()));
                intent.putExtra("ptr2", Integer.parseInt(ptrStr));
                intent.putExtra("cnt2", Integer.parseInt(lenStr));
                intent.setClass(ReadMultiTagsActivity.this, ReadDataShowActivity.class);
                startActivity(intent);
            }
        }
    }
    
    class ChkBoxSecondLevelCheckedChangeListener implements OnCheckedChangeListener {
        
        @Override
        public void onCheckedChanged(CompoundButton arg0, boolean arg1) {
            
            if (arg1) {
                SpinnerBank2AntiRead.setEnabled(true);
                EtPtr2AntiRead.setEnabled(true);
                EtLen2AntiRead.setEnabled(true);
            } else {
                SpinnerBank2AntiRead.setEnabled(false);
                EtPtr2AntiRead.setEnabled(false);
                EtLen2AntiRead.setEnabled(false);
            }
        }
    }
}
