package com.thomas;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import android.app.Activity;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.CompoundButton.OnCheckedChangeListener;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.RadioButton;
import android.widget.RadioGroup;
import android.widget.SimpleAdapter;
import android.widget.Spinner;
import android.widget.Toast;

import com.senter.iot.support.openapi.uhf.UhfH;


public class ReadTagActivity extends Activity {
    
    CheckBox CkWithUiiRead;
    RadioGroup RgRead;
    RadioButton RbReadSingle;
    RadioButton RbReadLoop;
    Spinner SpinnerBankRead;
    EditText EtTagUiiRead;
    EditText EtPtrRead;
    EditText EtLenRead;
    Button BtUiiRead;
    Button BtRead;
    Button BtClearRead;
    ListView LvRead;
    
    List<BankItem> list = new ArrayList<>();
    @SuppressWarnings("rawtypes")
    ArrayAdapter adapterBank;
    static ArrayList<HashMap<String, String>> dataList;
    SimpleAdapter adapter;
    
    private UhfH uhfH;
    
    @SuppressWarnings({"unchecked", "rawtypes"})
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.readtag);
        uhfH = UhfH.getInstance();
        dataList = new ArrayList<HashMap<String, String>>();
        adapter = new SimpleAdapter(ReadTagActivity.this,
                                    dataList,
                                    R.layout.readdata_items,
                                    new String[]{"uii", "data", "count"},
                                    new int[]{R.id.TvUii_Read, R.id.TvData_Read, R.id.TvCount_Read});
        
        CkWithUiiRead = (CheckBox) findViewById(R.id.CkWithUiiRead);
        RgRead = (RadioGroup) findViewById(R.id.RgRead);
        RbReadSingle = (RadioButton) findViewById(R.id.RbReadSingle);
        RbReadLoop = (RadioButton) findViewById(R.id.RbReadLoop);
        SpinnerBankRead = (Spinner) findViewById(R.id.SpinnerBank_Read);
        EtTagUiiRead = (EditText) findViewById(R.id.EtTagUiiRead);
        EtPtrRead = (EditText) findViewById(R.id.EtPtrRead);
        EtLenRead = (EditText) findViewById(R.id.EtLenRead);
        BtUiiRead = (Button) findViewById(R.id.BtUiiRead);
        BtRead = (Button) findViewById(R.id.BtRead);
        BtClearRead = (Button) findViewById(R.id.BtClearRead);
        LvRead = (ListView) findViewById(R.id.LvRead);

//		BtUiiRead.setEnabled(false);
        EtTagUiiRead.setEnabled(false);
        
        CkWithUiiRead.setOnCheckedChangeListener(new CkWithUiiReadCheckedChangeListener());
        BtUiiRead.setOnClickListener(new BtUiiReadClickListener());
        BtRead.setOnClickListener(new BtReadClickListener());
        BtClearRead.setOnClickListener(new BtClearReadClickListener());
        
        list = Bank.InitBankItemListByProType(uhfH.getProSel().getProtocol());
        adapterBank = new ArrayAdapter(this, R.layout.bank, R.id.TvBank, list);
        SpinnerBankRead.setAdapter(adapterBank);
    }
    
    class CkWithUiiReadCheckedChangeListener implements OnCheckedChangeListener {
        
        @Override
        public void onCheckedChanged(CompoundButton arg0, boolean arg1) {
            if (arg1) {
                EtTagUiiRead.setEnabled(true);
            } else {
                EtTagUiiRead.setEnabled(false);
            }
        }
    }
    
    class BtClearReadClickListener implements OnClickListener {
        
        @Override
        public void onClick(View arg0) {
            
            dataList.clear();
            adapter.notifyDataSetChanged();
        }
    }
    
    class BtUiiReadClickListener implements OnClickListener {
        
        @Override
        public void onClick(View arg0) {
            UhfH.UII uii = uhfH.inventorySingleTagOnce();
            if (uii != null) {
                String uiiStr = Function.bytesToHexString(uii.getBytes(), uii.getUiiLength());
                EtTagUiiRead.setText(uiiStr);
            } else {
                Toast.makeText(ReadTagActivity.this, "读取标签号失败", Toast.LENGTH_SHORT).show();
            }
        }
    }
    
    class BtReadClickListener implements OnClickListener {
        
        @Override
        public void onClick(View arg0) {
            if (BtRead.getText().toString().trim().equals("读取数据")) {
                String ptrStr = EtPtrRead.getText().toString().trim();
                if (ptrStr.equals("")) {
                    Toast.makeText(ReadTagActivity.this, "地址 不能为空", Toast.LENGTH_SHORT).show();
                    return;
                }
                if (!Function.isDecimal(ptrStr)) {
                    Toast.makeText(ReadTagActivity.this, "地址 请输入十进制数据", Toast.LENGTH_SHORT).show();
                    return;
                }
                int _ptr = Integer.parseInt(ptrStr);
                String lenStr = EtLenRead.getText().toString().trim();
                if (lenStr.equals("")) {
                    Toast.makeText(ReadTagActivity.this, "长度 不能为空", Toast.LENGTH_SHORT).show();
                    return;
                }
                if (!Function.isDecimal(lenStr)) {
                    Toast.makeText(ReadTagActivity.this, "长度 请输入十进制数据", Toast.LENGTH_SHORT).show();
                    return;
                }
                int _len = Integer.parseInt(lenStr);
                
                if (RbReadSingle.isChecked()) {//单步
                    if (CkWithUiiRead.isChecked()) {//指定标签
                        String uiiStr = EtTagUiiRead.getText().toString().trim();
                        if (uiiStr.equals("")) {
                            Toast.makeText(ReadTagActivity.this, "标签号不能为空", Toast.LENGTH_SHORT).show();
                            return;
                        }
                        if (!Function.isHex(uiiStr)) {
                            Toast.makeText(ReadTagActivity.this, "标签号必须为十六进制数据", Toast.LENGTH_SHORT).show();
                            return;
                        }
                        UhfH.Result.ReadResult result = uhfH.readOnceFromSingleTag(list.get(SpinnerBankRead.getSelectedItemPosition()).getBank(), _ptr, _len, UhfH.UII
                                .getNewInstanceByBytes(Function.HexStringToBytes(uiiStr), 0));
                        if (result != null) {
                            String dataStr = Function.bytesToHexString(result.getData(), result.getData().length);
                            HashMap<String, String> map = new HashMap<String, String>();
                            map.put("uii", uiiStr);
                            map.put("data", dataStr);
                            map.put("count", String.valueOf(1));
                            int index = checkIsExist(uiiStr, dataStr, dataList);
                            if (index == -1) {
                                dataList.add(map);
                                LvRead.setAdapter(adapter);
                            } else {
                                int count = Integer.parseInt(dataList.get(index).get("count"), 10) + 1;
                                map.put("count", String.valueOf(count));
                                dataList.set(index, map);
                                adapter.notifyDataSetChanged();
                            }
                        } else {
                            Toast.makeText(ReadTagActivity.this, "指定标签读取数据失败", Toast.LENGTH_SHORT).show();
                        }
                    } else {//不指定标签
                        UhfH.Result.ReadResult result = uhfH.readOnceFromUnSpecifiedTag(list.get(SpinnerBankRead.getSelectedItemPosition()).getBank(), _ptr, _len);
                        if (result != null) {
                            String dataStr = Function.bytesToHexString(result.getData(), result.getData().length);
                            String uiiStr = Function.bytesToHexString(result.getUii().getBytes(), result.getUii().getUiiLength());
                            EtTagUiiRead.setText(uiiStr);
                            HashMap<String, String> map = new HashMap<String, String>();
                            map.put("uii", uiiStr);
                            map.put("data", dataStr);
                            map.put("count", String.valueOf(1));
                            int index = checkIsExist(uiiStr, dataStr, dataList);
                            if (index == -1) {
                                dataList.add(map);
                                LvRead.setAdapter(adapter);
                            } else {
                                int count = Integer.parseInt(dataList.get(index).get("count"), 10) + 1;
                                map.put("count", String.valueOf(count));
                                dataList.set(index, map);
                                adapter.notifyDataSetChanged();
                            }
                        } else {
                            Toast.makeText(ReadTagActivity.this, "不指定标签读取数据失败", Toast.LENGTH_SHORT).show();
                        }
                    }
                    
                } else {//循环
                    if (CkWithUiiRead.isChecked()) {//指定标签
                        String uiiStr = EtTagUiiRead.getText().toString().trim();
                        if (uiiStr.equals("")) {
                            Toast.makeText(ReadTagActivity.this, "标签号不能为空", Toast.LENGTH_SHORT).show();
                            return;
                        }
                        if (!Function.isHex(uiiStr)) {
                            Toast.makeText(ReadTagActivity.this, "标签号必须为十六进制数据", Toast.LENGTH_SHORT).show();
                            return;
                        }
                        boolean isSuccess = uhfH.startReadLoopFromSingleTag(list.get(SpinnerBankRead.getSelectedItemPosition()).getBank(), _ptr, _len, UhfH.UII
                                .getNewInstanceByBytes(Function.HexStringToBytes(uiiStr), 0), new UhfH.OnReadListener() {
                            @Override
                            public void onRead(UhfH.Result.ReadResult result) {
                                Message msg = handler.obtainMessage();
                                Bundle bundle = new Bundle();
                                bundle.putString("uii", Function.bytesToHexString(result.getUii().getBytes(), result.getUii().getUiiLength()));
                                bundle.putString("data", Function.bytesToHexString(result.getData(), result.getData().length));
                                msg.setData(bundle);
                                handler.sendMessage(msg);
                            }
                        });
                        if (isSuccess) {
                            BtUiiRead.setEnabled(false);
                            BtRead.setText("停止");
                        } else {
                            Toast.makeText(ReadTagActivity.this, "开启指定标签循环读取数据失败", Toast.LENGTH_SHORT).show();
                        }
                    } else {//不指定标签
                        boolean isSuccess = uhfH.startReadLoopFromUnSpecifiedTag(list.get(SpinnerBankRead.getSelectedItemPosition()).getBank(), _ptr, _len, new UhfH.OnReadListener() {
                            @Override
                            public void onRead(UhfH.Result.ReadResult result) {
                                Message msg = handler.obtainMessage();
                                Bundle bundle = new Bundle();
                                bundle.putString("uii", Function.bytesToHexString(result.getUii().getBytes(), result.getUii().getUiiLength()));
                                bundle.putString("data", Function.bytesToHexString(result.getData(), result.getData().length));
                                msg.setData(bundle);
                                handler.sendMessage(msg);
                            }
                        });
                        if (isSuccess) {
                            BtUiiRead.setEnabled(false);
                            BtRead.setText("停止");
                        } else {
                            Toast.makeText(ReadTagActivity.this, "开启不指定标签循环读取数据失败", Toast.LENGTH_SHORT).show();
                        }
                    }
                }
            } else {
                uhfH.stopLoopOperate();
                BtRead.setText("读取数据");
                BtUiiRead.setEnabled(true);
            }
        }
    }
    
    public int checkIsExist(String uiiStr, String dataStr, ArrayList<HashMap<String, String>> tagList) {
        int existFlag = -1;
        String tempUiiStr = "";
        String tempDataStr = "";
        for (int i = 0; i < tagList.size(); i++) {
            HashMap<String, String> temp = new HashMap<String, String>();
            temp = tagList.get(i);
            
            tempUiiStr = temp.get("uii");
            tempDataStr = temp.get("data");
            if (uiiStr != "" && uiiStr.equals(tempUiiStr) && tempDataStr.equals(dataStr)) {
                existFlag = i;
            }
        }
        
        return existFlag;
    }
    
    Handler handler = new Handler() {
        
        @Override
        public void handleMessage(Message msg) {
            Bundle bundle = msg.getData();
            String uiiStr = bundle.getString("uii");
            String dataStr = bundle.getString("data");
            
            HashMap<String, String> map = new HashMap<String, String>();
            map.put("uii", uiiStr);
            map.put("data", dataStr);
            map.put("count", String.valueOf(1));
            
            int index = -1;
            if (!uiiStr.equals(null)) {
                index = checkIsExist(uiiStr, dataStr, dataList);
                if (index == -1) {
                    dataList.add(map);
                    LvRead.setAdapter(adapter);
                } else {
                    int count = Integer.parseInt(dataList.get(index).get("count"), 10) + 1;
                    map.put("count", String.valueOf(count));
                    dataList.set(index, map);
                    adapter.notifyDataSetChanged();
                }
            }
        }
    };
    
    
    @Override
    public void onBackPressed() {
        uhfH.stopLoopOperate();
        super.onBackPressed();
    }
    
}
