package com.thomas;

import java.util.ArrayList;
import java.util.List;

import android.app.Activity;
import android.app.AlertDialog.Builder;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.os.Environment;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.Toast;

import com.senter.iot.support.openapi.uhf.UhfH;


public class UpdateActivity extends Activity {
    
    SerialPortFinder serialportfinder;
    @SuppressWarnings("rawtypes")
    ArrayAdapter adapter;
    List<String> list;
    
    //选择bin文件
//	private static final int REQUEST_CODE = 1;   //请求码
//	public static final String EXTRA_FILE_CHOOSER = "file_chooser";
    
    private static String TAG = "UPDATE";
    private Intent fileChooserIntent;
    public static final String EXTRA_FILE_CHOOSER = "file_chooser";
    private static final int REQUEST_CODE_ACTIVE = 1;   //请求码
    private static final int REQUEST_CODE_UPDATE = 2;   //请求码
    
    Spinner SpinnerCom_Update;
    EditText EtBinPath;
    Button BtBrowse;
    Button BtUpdate;
    
    private UhfH uhfH;
    
    @SuppressWarnings({"unchecked", "rawtypes"})
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.update);
        uhfH = UhfH.getInstance();
        
        SpinnerCom_Update = (Spinner) findViewById(R.id.SpinnerCom_Update);
        EtBinPath = (EditText) findViewById(R.id.EtBinPath);
        BtBrowse = (Button) findViewById(R.id.BtBrowse);
        BtUpdate = (Button) findViewById(R.id.BtUpdate);
        
        serialportfinder = new SerialPortFinder();
        list = new ArrayList<String>();
        String[] paths = serialportfinder.getAllDevicesPath();
        for (int i = 0; i < paths.length; i++) {
            list.add(paths[i]);
        }
        
        adapter = new ArrayAdapter(this, R.layout.comitems, R.id.TvCom, list);
        SpinnerCom_Update.setAdapter(adapter);
        SpinnerCom_Update.setPrompt("选择COM口");
        fileChooserIntent = new Intent(UpdateActivity.this, FileChooserActivity.class);
        
        BtBrowse.setOnClickListener(new BtBrowseClickListener());
        BtUpdate.setOnClickListener(new BtUpdateClickListener());
    }
    
    class BtBrowseClickListener implements OnClickListener {
        
        @Override
        public void onClick(View arg0) {
            if (Environment.getExternalStorageState().equals(Environment.MEDIA_MOUNTED))
                startActivityForResult(fileChooserIntent, REQUEST_CODE_UPDATE);
            else
                Toast.makeText(UpdateActivity.this, getText(R.string.sdcard_unmonted_hint), Toast.LENGTH_SHORT).show();
        }
    }
    
    class BtUpdateClickListener implements OnClickListener {
        
        @Override
        public void onClick(View arg0) {
            String path = EtBinPath.getText().toString().trim();
            boolean isSuccess = uhfH.update(path);
            if (isSuccess) {
                Builder builder = new Builder(UpdateActivity.this);
                builder.setMessage("升级成功");
                builder.setTitle("提示");
                
                builder.setPositiveButton("确定", new DialogInterface.OnClickListener() {
                    
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        
                    }
                });
                
                builder.create().show();
            }
        }
    }
    
    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        
        Log.v(TAG, "onActivityResult#requestCode:" + requestCode + "#resultCode:" + resultCode);
        if (resultCode == RESULT_CANCELED) {
            Toast.makeText(UpdateActivity.this, getText(R.string.open_file_none), Toast.LENGTH_SHORT).show();
            return;
        }
        
        if (resultCode == Activity.RESULT_OK && requestCode == REQUEST_CODE_ACTIVE) {
            //获取路径名
            String binPath = data.getStringExtra(EXTRA_FILE_CHOOSER);
            Log.v(TAG, "onActivityResult # binPath : " + binPath);
            if (binPath != null) {
                EtBinPath.setText(binPath);
            } else {
                Toast.makeText(UpdateActivity.this, getText(R.string.open_file_error_format), Toast.LENGTH_SHORT).show();
            }
            
        } else if (resultCode == Activity.RESULT_OK && requestCode == REQUEST_CODE_UPDATE) {
            
            //获取路径名
            String binPath = data.getStringExtra(EXTRA_FILE_CHOOSER);
            Log.v(TAG, "onActivityResult # binPath : " + binPath);
            if (binPath != null) {
                EtBinPath.setText(binPath);
            } else {
                Toast.makeText(UpdateActivity.this, getText(R.string.open_file_error_format), Toast.LENGTH_SHORT).show();
            }
        }
        /*if (resultCode == Activity.RESULT_OK && requestCode == REQUEST_CODE){
            Uri uri = data.getData();	//得到uri，后面就是将uri转化成file的过程。
            String string =uri.toString();
            File file;
            String a[]=new String[2];
            
            if (string.indexOf(String.valueOf(Environment.getExternalStorageDirectory()))!=-1){//判断文件是否在sd卡中
                
                a = string.split(String.valueOf(Environment.getExternalStorageDirectory()));//对Uri进行切割
                file = new File(Environment.getExternalStorageDirectory(),a[1]);//获取到file
            }else if(string.indexOf(String.valueOf(Environment.getDataDirectory()))!=-1){ //判断文件是否在手机内存中
                
                a =string.split(String.valueOf(Environment.getDataDirectory()));//对Uri进行切割
                file = new File(Environment.getDataDirectory(),a[1]);//获取到file
            }else{//出现其他没有考虑到的情况
                
                Toast.makeText(UpdateActivity.this, "文件路径解析失败", Toast.LENGTH_SHORT).show();
                return;
            }

            EtBinPath.setText(file.getAbsolutePath());
        }*/
    }
    
    
}
