package com.thomas;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import android.app.Activity;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.CompoundButton.OnCheckedChangeListener;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.RadioButton;
import android.widget.SimpleAdapter;
import android.widget.Spinner;
import android.widget.Toast;

import com.senter.iot.support.openapi.uhf.UhfH;

public class WriteTagActivity extends Activity {
    
    CheckBox CkWithUiiWrite;
    RadioButton RbWriteSingle;
    RadioButton RbWriteLoop;
    EditText EtTagUiiWrite;
    EditText EtPtrWrite;
    EditText EtLenWrite;
    EditText EtDataWrite;
    Spinner SpinnerBankWrite;
    ListView LvWrite;
    Button BtUiiWrite;
    Button BtWrite;
    Button BtClearWrite;
    
    List<BankItem> list = new ArrayList<>();
    @SuppressWarnings("rawtypes")
    ArrayAdapter adapterBank;
    static ArrayList<HashMap<String, String>> dataList;
    SimpleAdapter adapter;
    
    private UhfH uhfH;
    
    @SuppressWarnings({"unchecked", "rawtypes"})
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.writetag);
        uhfH = UhfH.getInstance();
        dataList = new ArrayList<HashMap<String, String>>();
        adapter = new SimpleAdapter(WriteTagActivity.this,
                                    dataList,
                                    R.layout.writedata_items,
                                    new String[]{"uii", "data", "count"},
                                    new int[]{R.id.TvUii_Write, R.id.TvData_Write, R.id.TvCount_Write});
        
        CkWithUiiWrite = (CheckBox) findViewById(R.id.CkWithUiiWrite);
        RbWriteSingle = (RadioButton) findViewById(R.id.RbWriteSingle);
        RbWriteLoop = (RadioButton) findViewById(R.id.RbWriteLoop);
        EtTagUiiWrite = (EditText) findViewById(R.id.EtTagUiiWrite);
        EtPtrWrite = (EditText) findViewById(R.id.EtPtrWrite);
        EtLenWrite = (EditText) findViewById(R.id.EtLenWrite);
        EtDataWrite = (EditText) findViewById(R.id.EtDataWrite);
        SpinnerBankWrite = (Spinner) findViewById(R.id.SpinnerBankWrite);
        LvWrite = (ListView) findViewById(R.id.LvWrite);
        BtUiiWrite = (Button) findViewById(R.id.BtUiiWrite);
        BtWrite = (Button) findViewById(R.id.BtWrite);
        BtClearWrite = (Button) findViewById(R.id.BtClearWrite);

//		BtUiiWrite.setEnabled(false);
        EtTagUiiWrite.setEnabled(false);
        
        CkWithUiiWrite.setOnCheckedChangeListener(new CkWithUiiWriteCheckedChangeListener());
        BtUiiWrite.setOnClickListener(new BtUiiWriteClickListener());
        BtClearWrite.setOnClickListener(new BtClearWriteClickListener());
        BtWrite.setOnClickListener(new BtWriteClickListener());
        
        list = Bank.InitBankItemListByProType(uhfH.getProSel().getProtocol());
        adapterBank = new ArrayAdapter(this, R.layout.bank, R.id.TvBank, list);
        SpinnerBankWrite.setAdapter(adapterBank);
    }
    
    class CkWithUiiWriteCheckedChangeListener implements OnCheckedChangeListener {
        
        @Override
        public void onCheckedChanged(CompoundButton arg0, boolean arg1) {
            if (arg1) {
                EtTagUiiWrite.setEnabled(true);
            } else {
                EtTagUiiWrite.setEnabled(false);
            }
        }
    }
    
    class BtUiiWriteClickListener implements OnClickListener {
        
        @Override
        public void onClick(View arg0) {
            if (CkWithUiiWrite.isChecked()) {
                UhfH.UII uii = uhfH.inventorySingleTagOnce();
                if (uii != null) {
                    EtTagUiiWrite.setText(Function.bytesToHexString(uii.getBytes(), uii.getUiiLength()));
                } else {
                    Toast.makeText(WriteTagActivity.this, "读取标签号失败", Toast.LENGTH_SHORT).show();
                }
            }
        }
    }
    
    class BtClearWriteClickListener implements OnClickListener {
        
        @Override
        public void onClick(View arg0) {
            dataList.clear();
            adapter.notifyDataSetChanged();
        }
    }
    
    class BtWriteClickListener implements OnClickListener {
        
        @Override
        public void onClick(View arg0) {
            if (BtWrite.getText().toString().trim().equals("写入数据")) {
                String ptrStr = EtPtrWrite.getText().toString().trim();
                if (ptrStr.equals("")) {
                    Toast.makeText(WriteTagActivity.this, "地址 不能为空", Toast.LENGTH_SHORT).show();
                    return;
                }
                if (!Function.isDecimal(ptrStr)) {
                    Toast.makeText(WriteTagActivity.this, "地址 请输入十进制数据", Toast.LENGTH_SHORT).show();
                    return;
                }
                int _ptr = Integer.parseInt(ptrStr);
                String lenStr = EtLenWrite.getText().toString().trim();
                if (lenStr.equals("")) {
                    Toast.makeText(WriteTagActivity.this, "长度 不能为空", Toast.LENGTH_SHORT).show();
                    return;
                }
                if (!Function.isDecimal(lenStr)) {
                    Toast.makeText(WriteTagActivity.this, "长度 请输入十进制数据", Toast.LENGTH_SHORT).show();
                    return;
                }
                int _len = Integer.parseInt(lenStr);
                String dataStr = EtDataWrite.getText().toString().trim();
                if (dataStr.length() != 4 * _len || !Function.isHex(dataStr)) {
                    Toast.makeText(WriteTagActivity.this, "数据 请输入指定长度的十六进制数据", Toast.LENGTH_SHORT).show();
                    return;
                }
                if (RbWriteSingle.isChecked()) {//单步
                    if (CkWithUiiWrite.isChecked()) {//指定标签
                        String uiiStr = EtTagUiiWrite.getText().toString().trim();
                        if (uiiStr.equals("")) {
                            Toast.makeText(WriteTagActivity.this, "标签号不能为空", Toast.LENGTH_SHORT).show();
                            return;
                        }
                        if (!Function.isHex(uiiStr)) {
                            Toast.makeText(WriteTagActivity.this, "标签号必须为十六进制数据", Toast.LENGTH_SHORT).show();
                            return;
                        }
                        UhfH.Result.WriteResult result = uhfH.writeOnceFromSingleTag(list.get(SpinnerBankWrite.getSelectedItemPosition()).getBank(), _ptr, _len, Function
                                .HexStringToBytes(dataStr), UhfH.UII.getNewInstanceByBytes(Function.HexStringToBytes(uiiStr), 0));
                        if (result.isSuccess()) {
                            HashMap<String, String> map = new HashMap<String, String>();
                            map.put("uii", uiiStr);
                            map.put("data", dataStr);
                            map.put("count", String.valueOf(1));
                            int index = checkIsExist(uiiStr, dataStr, dataList);
                            if (index == -1) {
                                dataList.add(map);
                                LvWrite.setAdapter(adapter);
                            } else {
                                int count = Integer.parseInt(dataList.get(index).get("count"), 10) + 1;
                                map.put("count", String.valueOf(count));
                                dataList.set(index, map);
                                adapter.notifyDataSetChanged();
                            }
                        } else {
                            Toast.makeText(WriteTagActivity.this, "指定标签写入数据失败", Toast.LENGTH_SHORT).show();
                        }
                    } else {//不指定标签
                        UhfH.Result.WriteResult result = uhfH.writeOnceFromUnSpecifiedTag(list.get(SpinnerBankWrite.getSelectedItemPosition()).getBank(), _ptr, _len, Function.HexStringToBytes(dataStr));
                        if (result.isSuccess()) {
                            String uiiStr = Function.bytesToHexString(result.getUii().getBytes(), result.getUii().getUiiLength());
                            HashMap<String, String> map = new HashMap<String, String>();
                            map.put("uii", uiiStr);
                            map.put("data", dataStr);
                            map.put("count", String.valueOf(1));
                            int index = checkIsExist(uiiStr, dataStr, dataList);
                            if (index == -1) {
                                dataList.add(map);
                                LvWrite.setAdapter(adapter);
                            } else {
                                int count = Integer.parseInt(dataList.get(index).get("count"), 10) + 1;
                                map.put("count", String.valueOf(count));
                                dataList.set(index, map);
                                adapter.notifyDataSetChanged();
                            }
                        } else {
                            Toast.makeText(WriteTagActivity.this, "不指定标签写入数据失败", Toast.LENGTH_SHORT).show();
                        }
                    }
                } else {//循环
                    if (CkWithUiiWrite.isChecked()) {//指定标签
                        String uiiStr = EtTagUiiWrite.getText().toString().trim();
                        if (uiiStr.equals("")) {
                            Toast.makeText(WriteTagActivity.this, "标签号不能为空", Toast.LENGTH_SHORT).show();
                            return;
                        }
                        if (!Function.isHex(uiiStr)) {
                            Toast.makeText(WriteTagActivity.this, "标签号必须为十六进制数据", Toast.LENGTH_SHORT).show();
                            return;
                        }
                        boolean isSuccess = uhfH.startWriteLoopFromSingleTag(list.get(SpinnerBankWrite.getSelectedItemPosition()).getBank(), _ptr, _len, Function.HexStringToBytes(dataStr),
                                                                             UhfH.UII.getNewInstanceByBytes(Function.HexStringToBytes(uiiStr), 0), new UhfH
                                        .OnWriteListener() {
                                    @Override
                                    public void onWrite(UhfH.Result.WriteResult result) {
                                        if (result.isSuccess()) {
                                            Message msg = handler.obtainMessage();
                                            Bundle bundle = new Bundle();
                                            bundle.putString("uii", Function.bytesToHexString(result.getUii().getBytes(), result.getUii().getUiiLength()));
                                            bundle.putString("data", Function.bytesToHexString(result.getData(), result.getData().length));
                                            msg.setData(bundle);
                                            handler.sendMessage(msg);
                                        }
                                    }
                                });
                        if (isSuccess) {
                            BtUiiWrite.setEnabled(false);
                            BtWrite.setText("停止");
                        } else {
                            Toast.makeText(WriteTagActivity.this, "开启指定标签循环写数据失败", Toast.LENGTH_SHORT).show();
                        }
                    } else {//不指定标签
                        boolean isSuccess = uhfH.startWriteLoopFromUnSpecifiedTag(list.get(SpinnerBankWrite.getSelectedItemPosition()).getBank(), _ptr, _len, Function.HexStringToBytes(dataStr), new UhfH.OnWriteListener
                                () {
                            @Override
                            public void onWrite(UhfH.Result.WriteResult result) {
                                if (result.isSuccess()) {
                                    Message msg = handler.obtainMessage();
                                    Bundle bundle = new Bundle();
                                    bundle.putString("uii", Function.bytesToHexString(result.getUii().getBytes(), result.getUii().getUiiLength()));
                                    bundle.putString("data", Function.bytesToHexString(result.getData(), result.getData().length));
                                    msg.setData(bundle);
                                    handler.sendMessage(msg);
                                }
                            }
                        });
                        if (isSuccess) {
                            BtUiiWrite.setEnabled(false);
                            BtWrite.setText("停止");
                        } else {
                            Toast.makeText(WriteTagActivity.this, "开启不指定标签循环写数据失败", Toast.LENGTH_SHORT).show();
                        }
                    }
                }
            } else {
                uhfH.stopLoopOperate();
                BtWrite.setText("写入数据");
                BtUiiWrite.setEnabled(true);
            }
        }
    }
    
    public int checkIsExist(String uiiStr, String dataStr, ArrayList<HashMap<String, String>> tagList) {
        int existFlag = -1;
        String tempUiiStr = "";
        String tempDataStr = "";
        for (int i = 0; i < tagList.size(); i++) {
            HashMap<String, String> temp = new HashMap<String, String>();
            temp = tagList.get(i);
            
            tempUiiStr = temp.get("uii");
            tempDataStr = temp.get("data");
            if (uiiStr != "" && uiiStr.equals(tempUiiStr) && tempDataStr.equals(dataStr)) {
                existFlag = i;
            }
        }
        
        return existFlag;
    }
    
    Handler handler = new Handler() {
        
        @Override
        public void handleMessage(Message msg) {
            Bundle bundle = msg.getData();
            String uiiStr = bundle.getString("uii");
            String dataStr = bundle.getString("data");
            
            HashMap<String, String> map = new HashMap<String, String>();
            map.put("uii", uiiStr);
            map.put("data", dataStr);
            map.put("count", String.valueOf(1));
            
            int index = -1;
            if (!uiiStr.equals(null)) {
                index = checkIsExist(uiiStr, dataStr, dataList);
                if (index == -1) {
                    dataList.add(map);
                    LvWrite.setAdapter(adapter);
                } else {
                    int count = Integer.parseInt(dataList.get(index).get("count"), 10) + 1;
                    map.put("count", String.valueOf(count));
                    dataList.set(index, map);
                    adapter.notifyDataSetChanged();
                }
            }
        }
    };
    
    @Override
    public void onBackPressed() {
        uhfH.stopLoopOperate();
        super.onBackPressed();
    }
}
